SystemOrganization addCategory: #'Seaside-Platform'!
SystemOrganization addCategory: #'Seaside-Continuations'!
SystemOrganization addCategory: #'Seaside-Utilities'!
SystemOrganization addCategory: #'Seaside-Configuration'!
SystemOrganization addCategory: #'Seaside-HTTP'!
SystemOrganization addCategory: #'Seaside-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Document'!
SystemOrganization addCategory: #'Seaside-Builder'!
SystemOrganization addCategory: #'Seaside-Libraries'!
SystemOrganization addCategory: #'Seaside-Session'!
SystemOrganization addCategory: #'Seaside-StateRegistry'!
SystemOrganization addCategory: #'Seaside-Rendering'!
SystemOrganization addCategory: #'Seaside-Canvas'!
SystemOrganization addCategory: #'Seaside-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-RenderLoop'!
SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Components-Tools'!
SystemOrganization addCategory: #'Seaside-Components-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside-Examples-Test'!
SystemOrganization addCategory: #'Seaside-Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside-Examples-Store'!

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAExternalID class methodsFor: 'as yet unclassified' stamp: ''!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: ''!
fromString: t1 
	| t2 |
	t2 := super new: t1 size.
	t1
		withIndexDo: [:t3 :t4 | t2 at: t4 put: t3 asInteger].
	^ t2! !

!WAExternalID class methodsFor: 'class initialization' stamp: ''!
initialize
	GeneratorMutex := Semaphore forMutualExclusion.
	Generator := Random new! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: ''!
new: t1 
	^ (super new: t1) initialize! !

!WAExternalID methodsFor: 'private' stamp: ''!
initialize
	GeneratorMutex
		critical: [1
				to: self size
				do: [:t1 | self at: t1 put: (($a to: $z)
							, ($A to: $Z) atRandom: Generator) asInteger].
			nil]! !

!WAExternalID methodsFor: 'private' stamp: ''!
printOn: t1 
	self
		do: [:t2 | t1
				nextPut: (Character value: t2)]! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Amb class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
allValues: t1 
	| t2 t3 |
	t2 := failureContinuation.
	t3 := OrderedCollection new.
	(Continuation
			currentDo: [:t4 | 
				failureContinuation := [:t5 | t4 value: false].
				t3 add: t1 value.
				t4 value: true])
		ifTrue: [self fail].
	failureContinuation := t2.
	^ t3 asArray! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
assert: t1 
	t1
		ifFalse: [self fail]! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
deny: t1 
	self assert: t1 not! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
initialize
	failureContinuation := [:t1 | self error: 'Amb tree exhausted']! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
maybe
	^ self
		oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
oneOf: t1 
	^ self
		valueOfOneOf: (t1
				collect: [:t2 | [t2] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
valueOfOneOf: t1 
	| t2 |
	t2 := failureContinuation.
	^ Continuation
		currentDo: [:t3 | 
			t1
				do: [:t4 | Continuation
						currentDo: [:t5 | 
							failureContinuation := [:t6 | 
									failureContinuation := t2.
									t5 value: t6] fixTemps.
							t3 value: t4 value]].
			t2 value: nil]! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
valueOf: t1 or: t2 
	^ self
		valueOfOneOf: (Array with: t1 with: t2)! !

!Amb methodsFor: 'as yet unclassified' stamp: ''!
valueOf: t1 or: t2 or: t3 
	^ self
		valueOfOneOf: (Array
				with: t1
				with: t2
				with: t3)! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #AnswerContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Continuation class methodsFor: 'instance creation' stamp: ''!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: ''!
currentDo: t1 
	^ t1
		value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: ''!
fromContext: t1 
	^ self new initializeFromContext: t1! !

!Continuation methodsFor: 'private' stamp: ''!
initializeFromContext: t1 
	| t2 t3 t5 |
	t2 := WriteStream
				on: (Array new: 20).
	t3 := t1.
	[t3 notNil]
		whileTrue: [t2 nextPut: t3.
			t5 := t3 class instSize.
			1
				to: t5
				do: [:t4 | t2
						nextPut: (t3 instVarAt: t4)].
			t5 := t3 localSize.
			1
				to: t5
				do: [:t4 | t2
						nextPut: (t3 localAt: t4)].
			t3 := t3 sender].
	values := t2 contents! !

!Continuation methodsFor: 'invocation' stamp: ''!
numArgs
	^ 1! !

!Continuation methodsFor: 'as yet unclassified' stamp: ''!
restoreValues
	| t1 t2 t4 |
	t1 := values readStream.
	[t1 atEnd]
		whileFalse: [t2 := t1 next.
			t4 := t2 class instSize.
			1
				to: t4
				do: [:t3 | t2 instVarAt: t3 put: t1 next].
			t4 := t2 localSize.
			1
				to: t4
				do: [:t3 | t2 localAt: t3 put: t1 next]]! !

!Continuation methodsFor: 'private' stamp: ''!
terminate: t1 
	| t2 |
	t2 := t1.
	[t2 notNil]
		whileTrue: [t2 := t2 swapSender: nil]! !

!Continuation methodsFor: 'invocation' stamp: ''!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: ''!
valueWithArguments: t1 
	t1 size == 1
		ifFalse: [^ self error: 'continuations can only be resumed with one argument'].
	self value: t1 first! !

!Continuation methodsFor: 'invocation' stamp: ''!
value: t1 
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^ t1! !

Continuation subclass: #EscapeContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #ResponseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Object methodsFor: '*seaside2' stamp: ''!
inspectorFields
	| t1 |
	t1 := self class allInstVarNames
				collect: [:t2 | t2
						-> (self instVarNamed: t2)].
	self class isVariable
		ifTrue: [t1 := t1
						, ((1 to: self size)
								collect: [:t3 | t3
										-> (self at: t3)])].
	^ t1! !

!Object methodsFor: '*seaside2' stamp: ''!
isIdenticalToSnapshot: t1 
	| t3 |
	t3 := self class instSize.
	1
		to: t3
		do: [:t2 | (t1 instVarAt: t2)
					== (self instVarAt: t2)
				ifFalse: [^ false]].
	self class isVariable
		ifTrue: [t3 := self size.
			1
				to: t3
				do: [:t2 | (t1 at: t2)
							== (self at: t2)
						ifFalse: [^ false]]].
	^ true! !

!Object methodsFor: '*seaside2' stamp: ''!
labelForSelector: t1 
	^ t1 asCapitalizedPhrase! !

!Object methodsFor: '*seaside2' stamp: ''!
renderOn: t1 
	t1 text: self! !

!Object methodsFor: '*seaside2' stamp: ''!
restoreFromSnapshot: t1 
	| t3 |
	t3 := self class instSize.
	1
		to: t3
		do: [:t2 | self
				instVarAt: t2
				put: (t1 instVarAt: t2)].
	self class isVariable
		ifTrue: [t3 := self size.
			1
				to: t3
				do: [:t2 | self
						at: t2
						put: (t1 at: t2)]]! !

!Object methodsFor: '*seaside2' stamp: ''!
snapshotCopy
	^ self shallowCopy! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
base64Decode: t1 
	^ (Base64MimeConverter mimeDecodeToChars: t1 readStream) contents! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
deliverMailFrom: t1 to: t2 text: t3 
	SMTPClient
		deliverMailFrom: t1
		to: t2
		text: t3
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
ensureAuthorInitials: t1 
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: t1 value]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
isProxy: t1 
	^ (t1 class allSuperclasses includes: Object) not! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
mimeDocumentClass
	^ MIMEDocument! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
profileSendsDuring: t1 
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.
	^ String
		streamContents: [:t2 | MessageTally new
				spyEvery: 1
				on: [t1 value.
					Smalltalk garbageCollectMost];
				 report: t2]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
readWriteStream
	^ RWBinaryOrTextStream on: String new! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
smtpServer
	^ MailSender smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
vmStatisticsReportString
	^ Utilities vmStatisticsReportString! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: ''!
weakDictionaryOfSize: t1 
	| t2 |
	t2 := WeakIdentityKeyDictionary new: t1.
	WeakArray addWeakDependent: t2.
	^ t2! !

Object subclass: #WAAbstractHtmlBuilder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: ''!
encode: t1 
	| t2 |
	^ String
		streamContents: [:t3 | t1 asString
				do: [:t4 | 
					t2 := HtmlCharacters
								at: t4 asInteger + 1
								ifAbsent: [t4 asCharacter].
					t2 isString
						ifTrue: [t3 nextPutAll: t2]
						ifFalse: [t3 nextPut: t2]]]! !

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	HtmlCharacters := Array new: 256.
	0
		to: 255
		do: [:t1 | HtmlCharacters at: t1 + 1 put: t1 asCharacter].
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt' )
		pairsDo: [:t2 :t3 | HtmlCharacters at: t2 asInteger + 1 put: '&' , t3 , ';']! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
acronym: t1 do: t2 
	self attributes at: 'title' put: t1.
	self tag: 'acronym' do: t2! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
anchorWithMailto: t1 
	self anchorWithUrl: 'mailto:' , t1 do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
anchorWithMailto: t1 subject: t2 
	self anchorWithUrl: 'mailto:' , t1 , '?subject=' , t2 do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
anchorWithName: t1 
	self attributes name: t1.
	self tag: #a! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: ''!
anchorWithPopupUrl: t1 extent: t2 do: t3 
	self
		anchorWithPopupUrl: t1
		name: ''''''
		extent: t2
		toggles: #(#menubar #resizable #scrollbars )
		do: t3! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: ''!
anchorWithPopupUrl: t1 extent: t2 text: t3 
	self
		anchorWithPopupUrl: t1
		extent: t2
		do: t3! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: ''!
anchorWithPopupUrl: t1 name: t2 extent: t3 toggles: t4 do: t5 
	self attributes at: 'onClick' put: (self
			popupStringWithUrl: t1
			name: t2
			extent: t3
			toggles: t4)
			, '; return false'.
	self anchorWithUrl: t1 do: t5! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
anchorWithUrl: t1 do: t2 
	self attributes href: t1.
	self tag: 'a' do: t2! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
anchorWithUrl: t1 title: t2 do: t3 
	self attributes title: t2.
	self anchorWithUrl: t1 do: t3! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
attributeAt: t1 put: t2 
	self attributes at: t1 put: t2! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
attributes
	^ attributeBuffer
		ifNil: [attributeBuffer := WAHtmlAttributes new]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
attributes: t1 
	t1
		associationsDo: [:t2 | self attributeAt: t2 key put: t2 value]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
bold: t1 
	self tag: 'b' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
break
	self tag: 'br'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
buttonForUrl: t1 withText: t2 
	self
		buttonForUrl: t1
		withText: t2
		data: #()! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
buttonForUrl: t1 withText: t2 data: t3 
	self
		formWithMethod: 'GET'
		action: t1
		do: [t3
				do: [:t4 | self
						inputWithType: 'hidden'
						named: t4 key asString
						value: t4 value].
			self submitButtonWithText: t2]! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
buttonWithType: t1 named: t2 value: t3 do: t4 
	t2
		ifNotNil: [self attributes at: 'name' put: t2;
				 at: 'id' ifAbsentPut: t2].
	t3
		ifNotNil: [self attributes value: t3 asString].
	self attributes type: t1.
	self tag: 'button' do: t4! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
closeTag: t1 
	self document closeTag: t1! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
cssClass: t1 
	self attributeAt: 'class' put: t1! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
cssId: t1 
	self attributeAt: 'id' put: t1! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
divClass: t1 with: t2 
	self cssClass: t1;
		 div: t2! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
divNamed: t1 with: t2 
	self cssId: t1;
		 div: t2! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
div: t1 
	self tag: 'div' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'accessing' stamp: ''!
document
	self subclassResponsibility! !

!WAAbstractHtmlBuilder methodsFor: 'dnu' stamp: ''!
doesNotUnderstand: t1 
	| t2 |
	t2 := t1 arguments size.
	t2 = 0
		ifTrue: [^ self tag: t1 selector].
	t2 = 1
		ifTrue: [^ self tag: t1 selector allButLast do: t1 argument].
	^ super doesNotUnderstand: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
emphasis: t1 
	self tag: 'em' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
encodeCharacter: t1 
	self html: '&#' , t1 asInteger asString , ';'! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
encodeText: t1 
	self text: t1! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
fieldsetWithLegend: t1 do: t2 
	self
		tag: 'fieldset'
		do: [self tag: 'legend' do: t1.
			t2 value]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
formWithAction: t1 do: t2 
	self
		formWithMethod: 'post'
		action: t1
		do: t2! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
formWithMethod: t1 action: t2 do: t3 
	self attributes method: t1;
		 action: t2.
	self tag: 'form' do: t3! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
heading: t1 
	self heading: t1 level: 1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
heading: t1 level: t2 
	self tag: 'h' , t2 asString do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
horizontalRule
	self tag: 'hr'! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
html: t1 
	self document text: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
image: t1 
	self image: t1 altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
image: t1 altText: t2 
	self attributeAt: 'alt' put: t2.
	self attributeAt: 'src' put: t1.
	self tag: #img! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
image: t1 width: t2 height: t3 
	self
		image: t1
		width: t2
		height: t3
		altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
image: t1 width: t2 height: t3 altText: t4 
	self attributeAt: 'width' put: t2.
	self attributeAt: 'height' put: t3.
	self attributeAt: 'border' put: 0.
	self image: t1 altText: t4! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
inputWithType: t1 
	self inputWithType: t1 named: nil! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
inputWithType: t1 named: t2 
	self
		inputWithType: t1
		named: t2
		value: nil! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
inputWithType: t1 named: t2 value: t3 
	t2
		ifNotNil: [self attributes at: 'name' put: t2].
	t3
		ifNotNil: [self attributes value: t3 asString].
	self attributes type: t1.
	self tag: 'input'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
italic: t1 
	self tag: 'i' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
labelFor: t1 do: t2 
	self attributes at: 'for' put: t1.
	self tag: 'label' do: t2! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
layoutTableOfWidth: t1 do: t2 
	self attributes width: t1.
	self layoutTable: t2! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
layoutTable: t1 
	self attributes border: 0;
		 cellspacing: 0;
		 cellpadding: 0.
	self table: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
listItem: t1 
	self tag: #li do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
list: t1 
	self
		list: t1
		do: [:t2 | self text: t2]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
list: t1 do: t2 
	self
		unorderedList: [t1
				do: [:t3 | self
						listItem: [t2 value: t3]]]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
openTag: t1 
	self document openTag: t1 attributes: self attributes.
	attributeBuffer := nil! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
orderedList: t1 
	self tag: 'ol' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
orderedList: t1 do: t2 
	self
		orderedList: [t1
				do: [:t3 | self
						listItem: [t2 value: t3]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
paragraph
	self tag: 'p'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
paragraph: t1 
	self tag: 'p' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: ''!
popupStringWithUrl: t1 name: t2 extent: t3 toggles: t4 
	^ String
		streamContents: [:t5 | t5 nextPutAll: 'window.open(';
				 nextPut: $';
				 nextPutAll: t1;
				 nextPut: $';
				 nextPut: $,;
				 nextPut: $';
				 nextPutAll: t2;
				 nextPut: $';
				 nextPut: $,;
				 nextPut: $';
				 nextPutAll: 'width=';
				 nextPutAll: t3 x asString;
				 nextPutAll: ',height=';
				 nextPutAll: t3 y asString;
				 nextPut: $,;
				
				nextPutAll: (self toggleStringFor: t4);
				 nextPut: $';
				 nextPutAll: ')']! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
preformatted: t1 
	self tag: 'pre' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
render: t1 
	t1 renderOn: self! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: ''!
scriptWithUrl: t1 
	self attributes at: 'type' put: 'text/javascript';
		 at: 'src' put: t1.
	self tag: 'script'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
script: t1 
	self
		tag: 'script'
		do: [self html: t1]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
shouldCloseTag: t1 
	^ #(#hr #br #input #img #link )! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
space
	self html: '&nbsp;'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
spacerRow
	self
		tableRowWith: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
space: t1 
	t1
		timesRepeat: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
spanClass: t1 with: t2 
	self cssClass: t1;
		 span: t2! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
spanNamed: t1 with: t2 
	self cssId: t1;
		 span: t2! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
span: t1 
	self tag: 'span' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: ''!
style: t1 
	self attributeAt: 'style' put: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
submitButton
	self inputWithType: 'submit'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: ''!
submitButtonWithText: t1 
	self attributes value: t1.
	self inputWithType: 'submit'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableData: t1 
	self tag: 'td' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableData: t1 span: t2 
	t2 > 0
		ifTrue: [self attributes at: 'colspan' put: t2.
			self tableData: t1]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableHeadings: t1 
	self
		tableRow: [t1
				do: [:t2 | self tableHeading: t2]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableHeading: t1 
	self tag: 'th' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWithLabel: t1 column: t2 
	self
		tableRow: [self cssClass: 'label'.
			self tableData: t1.
			self tableData: t2]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWithLabel: t1 column: t2 column: t3 
	self
		tableRow: [self cssClass: 'label'.
			self tableData: t1.
			self tableData: t2;
				 tableData: t3]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWith: t1 
	self
		tableRow: [self tableData: t1]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWith: t1 span: t2 
	self
		tableRow: [self tableData: t1 span: t2]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWith: t1 with: t2 
	self
		tableRow: [self tableData: t1;
				 tableData: t2]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRowWith: t1 with: t2 with: t3 
	self
		tableRow: [self tableData: t1;
				 tableData: t2;
				 tableData: t3]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
tableRow: t1 
	self tag: 'tr' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: ''!
table: t1 
	self tag: 'table' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
tag: t1 
	self openTag: t1.
	self closeTag: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
tag: t1 do: t2 
	self openTag: t1.
	self render: t2.
	self closeTag: t1! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: ''!
text: t1 
	self
		html: (self class encode: t1)! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: ''!
toggleStringFor: t1 
	^ String
		streamContents: [:t2 | t1
				do: [:t3 | t2 nextPutAll: t3 asString , '=yes']
				separatedBy: [t2 nextPutAll: ',']]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
underline: t1 
	self tag: 'u' do: t1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: ''!
unorderedList: t1 
	self tag: 'ul' do: t1! !

WAAbstractHtmlBuilder subclass: #WAHtmlBuilder
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new document: t1! !

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: ''!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: ''!
document: t1 
	document := t1! !

WAAbstractHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context callbacks'
	classVariableNames: 'Transparent1X1Form'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: ''!
context: t1 callbacks: t2 
	^ self basicNew initializeWithContext: t1 callbacks: t2! !

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: ''!
transparent1X1Form
	^ Transparent1X1Form
		ifNil: [Transparent1X1Form := Form extent: 1 @ 1]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
anchorOn: t1 of: t2 
	self cssId: t1;
		
		anchorWithAction: (MessageSend receiver: t2 selector: t1)
		text: (self labelForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithAction: t1 do: t2 
	self openAnchorWithAction: t1.
	self render: t2.
	self closeTag: 'a'! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithAction: t1 form: t2 
	self
		anchorWithAction: t1
		do: [self imageWithForm: t2]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithAction: t1 image: t2 
	self
		anchorWithAction: t1
		do: [self imageWithForm: t2]! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
anchorWithAction: t1 liveAction: t2 text: t3 
	| t4 t5 |
	t5 := self ensureId.
	self anchorWithAction: t1 text: t3.
	t4 := self
				urlForLiveRequest: [:t6 :t7 | t2 value: t7].
	self script: 'document.getElementById(' , t5 printString , ').onclick = liveUpdaterUri(' , t4 asString printString , ')'! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithAction: t1 text: t2 
	self anchorWithAction: t1 do: t2! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithAction: t1 text: t2 submitFormNamed: t3 
	| t4 |
	t4 := self context nextKey.
	self attributes at: 'onClick' put: 'submitFormTriggeringCallback(' , t3 printString , ', ' , t4 asString printString , '); return false;'.
	self anchorWithAction: t1 text: t2! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
anchorWithCallback: t1 do: t2 
	self
		anchorWithUrl: (self urlForIdempotentAction: t1)
		do: t2! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
anchorWithDocument: t1 mimeType: t2 fileName: t3 text: t4 
	self
		openAnchorWithDocument: t1
		mimeType: t2
		fileName: t3.
	self text: t4.
	self closeTag: 'a'! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
anchorWithDocument: t1 mimeType: t2 text: t3 
	self
		anchorWithDocument: t1
		mimeType: t2
		fileName: nil
		text: t3! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
anchorWithDocument: t1 text: t2 
	self
		anchorWithDocument: t1
		mimeType: nil
		text: t2! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
anchorWithPopupAction: t1 extent: t2 do: t3 
	self
		anchorWithPopupUrl: (self urlForAction: t1)
		extent: t2
		do: t3! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
anchorWithPopupAction: t1 extent: t2 text: t3 
	self
		anchorWithPopupAction: t1
		extent: t2
		do: t3! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
anchorWithPopupAction: t1 name: t2 extent: t3 toggles: t4 do: t5 
	self
		anchorWithPopupUrl: (self urlForAction: t1)
		name: t2
		extent: t3
		toggles: t4
		do: t5! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
anchorWithScript: t1 do: t2 
	self attributes at: 'onClick' put: t1.
	self anchorWithUrl: '#' do: t2! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
autofocus: t1 
	| t2 |
	t2 := self ensureId.
	t1 value.
	self script: 'document.getElementById("' , t2 asString , '").focus()'! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
booleanMenuOn: t1 of: t2 
	self cssId: t1;
		
		booleanMenuWithValue: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
booleanMenuWithValue: t1 callback: t2 
	self
		booleanMenuWithValue: t1
		callback: t2
		labels: #(#Yes #No )! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
booleanMenuWithValue: t1 callback: t2 labels: t3 
	self
		selectFromList: (Array with: true with: false)
		selected: t1
		callback: t2
		labels: [:t4 | t4
				ifTrue: [t3 first]
				ifFalse: [t3 second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
callbackForSelector: t1 of: t2 
	^ MessageSend receiver: t2 selector: (t1 copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
cancelButtonWithAction: t1 
	self attributes value: 'Cancel'.
	self
		inputWithType: 'submit'
		named: (self callbacks registerCancelActionCallback: t1)! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
checkboxOn: t1 of: t2 
	self
		checkboxWithValue: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
checkboxWithValue: t1 callback: t2 
	| t3 t4 |
	t3 := ValueHolder new.
	t4 := attributeBuffer.
	attributeBuffer := nil.
	self
		hiddenInputWithCallback: [t3 contents: false].
	attributeBuffer := t4.
	self attributeAt: 'checked' put: t1.
	self
		valueInputOfType: 'checkbox'
		value: 'true'
		callback: [t3 contents: true].
	t2 fixTemps.
	self
		hiddenInputWithCallback: [t2 value: t3 contents]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
close
	^ self! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'compound' stamp: ''!
dateInputWithValue: t1 callback: t2 
	| t3 |
	t2 fixTemps.
	t3 := Array new: 3.
	self
		selectFromList: (1 to: 12)
		selected: t1 monthIndex
		callback: [:t4 | t3 at: 2 put: t4]
		labels: [:t5 | Date nameOfMonth: t5].
	self space.
	self
		textInputWithValue: t1 dayOfMonth
		callback: [:t6 | t3 at: 1 put: t6]
		maxLength: 2.
	self space.
	self
		textInputWithValue: t1 year
		callback: [:t7 | t3 at: 3 put: t7]
		maxLength: 4.
	self
		hiddenInputWithCallback: [t2
				value: (Date
						newDay: (t3 first
								min: (Date daysInMonth: t3 second forYear: t3 third))
						monthNumber: t3 second
						year: t3 third)]! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
defaultAction: t1 
	self
		inputWithType: 'hidden'
		named: (self callbacks registerDefaultActionCallback: t1)! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
divWithShow: t1 hide: t2 do: t3 
	| t4 t5 t6 |
	t4 := self context advanceKey.
	t5 := self context advanceKey.
	t6 := 'swapDisplay(' , t4 printString , ', ' , t5 printString , '); return false;'.
	self attributes id: t4;
		 style: 'display: block'.
	self anchorWithScript: t6 do: t1.
	self attributes id: t5;
		 style: 'display: none'.
	self
		div: [self anchorWithScript: t6 do: t2.
			self div: t3]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
ensureId
	^ (self attributes
		at: 'id'
		ifAbsentPut: ['id' , self context advanceKey]) value! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
fileUploadWithCallback: t1 
	t1 fixTemps.
	self
		inputWithType: 'file'
		named: (self callbacks
				registerCallback: [:t2 | t1
						value: (t2 = ''
								ifFalse: [t2])])! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
formWithDefaultAction: t1 do: t2 
	self
		form: [self
				inputWithType: 'hidden'
				named: (self callbacks registerDefaultActionCallback: t1).
			self attributes value: '';
				 width: 1;
				 size: 1.
			self submitButtonWithAction: t1 image: self transparent1X1Form.
			t2 value]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
form: t1 
	self
		formWithMethod: 'post'
		action: context actionUrl urlString
		do: [self
				div: [context actionUrl parameters
						keysAndValuesDo: [:t2 :t3 | self
								inputWithType: 'hidden'
								named: t2
								value: t3].
					t1 value]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
hiddenInputWithCallback: t1 
	self
		inputWithType: 'hidden'
		named: (self callbacks registerCallback: t1)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
hiddenInputWithValue: t1 callback: t2 
	self
		valueInputOfType: 'hidden'
		value: t1
		callback: t2! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
imageMapWithAction: t1 form: t2 
	| t3 t4 t5 |
	t1 fixTemps.
	t3 := ValueHolder new.
	t4 := self callbacks
				registerCallback: [:t6 | t3
						contents: (self parseImageMap: t6)].
	t5 := self
				urlForAction: [t1 value: t3 contents].
	self attributeAt: 'href' put: t5 , '&' , t4 , '='.
	self
		tag: 'a'
		do: [self attributeAt: 'border' put: 0;
				 attributeAt: 'ismap' put: true.
			self imageWithForm: t2]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
imageWithDocument: t1 mimeType: t2 fileName: t3 
	self
		image: (self context
				urlForDocument: t1
				mimeType: t2
				fileName: t3)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
imageWithForm: t1 
	self
		image: (self context urlForDocument: t1)
		width: t1 width
		height: t1 height! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
initializeWithContext: t1 callbacks: t2 
	context := t1.
	callbacks := t2! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelForSelector: t1 of: t2 
	^ t2 labelForSelector: t1! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelledRowForCheckboxOn: t1 of: t2 
	self
		tableRowWithLabel: (self labelForSelector: t1 of: t2)
		column: [self checkboxOn: t1 of: t2]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelledRowForList: t1 on: t2 of: t3 
	self
		tableRowWithLabel: (t3 labelForSelector: t2 of: t3)
		column: [self
				selectFromList: t1
				selected: (t3 perform: t2)
				callback: (self callbackForSelector: t2 of: t3)]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelledRowForTextAreaOn: t1 of: t2 
	self
		tableRowWithLabel: (self labelForSelector: t1 of: t2)
		column: [self textAreaOn: t1 of: t2]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelledRowForTextInputOn: t1 of: t2 
	self
		labelledRowForTextInputOn: t1
		of: t2
		size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
labelledRowForTextInputOn: t1 of: t2 size: t3 
	self
		tableRowWithLabel: (self labelForSelector: t1 of: t2)
		column: [t3
				ifNotNil: [self attributeAt: #size put: t3].
			self textInputOn: t1 of: t2]! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
label: t1 input: t2 
	| t3 |
	t3 := 'id' , self context advanceKey.
	self
		labelFor: t3
		do: [self text: t1.
			self space.
			self cssId: t3.
			t2 value]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
openAnchorWithAction: t1 
	self
		attributeAt: 'href'
		put: (self urlForAction: t1).
	self openTag: 'a'! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
openAnchorWithDocument: t1 mimeType: t2 fileName: t3 
	self
		attributeAt: 'href'
		put: (self context
				urlForDocument: t1
				mimeType: t2
				fileName: t3).
	self openTag: #a! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
openSelect
	| t1 |
	t1 := self callbacks registerDispatchCallback.
	self attributes at: 'name' put: t1.
	self openTag: 'select'! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
optionGroupWithLabel: t1 do: t2 
	self attributes at: 'label' put: t1.
	self tag: 'optgroup' do: t2! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
optionWithLabel: t1 callback: t2 
	self
		optionWithLabel: t1
		selected: false
		callback: t2! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
optionWithLabel: t1 selected: t2 callback: t3 
	self attributeAt: 'selected' put: t2;
		
		attributeAt: 'value'
		put: (self callbacks registerCallback: t3).
	self tag: 'option' do: t1! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
parseImageMap: t1 
	| t2 t3 t4 |
	('?*,*' match: t1)
		ifFalse: [^ nil].
	t2 := t1 readStream.
	t2 upTo: $?.
	t3 := t2 upTo: $,.
	t4 := t2 upToEnd.
	^ t3 asNumber @ t4 asNumber! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
parseNumber: t1 
	^ [t1 asNumber]
		on: Error
		do: [:t2 | t1]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
passwordInputWithCallback: t1 
	self passwordInputWithValue: '' callback: t1! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
passwordInputWithValue: t1 callback: t2 
	self
		valueInputOfType: 'password'
		value: t1
		callback: t2! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
radioButtonInGroup: t1 selected: t2 callback: t3 
	self attributeAt: 'checked' put: t2.
	self
		inputWithType: 'radio'
		named: t1
		value: (self callbacks registerCallback: t3)! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
radioButtonInGroup: t1 withValue: t2 on: t3 of: t4 
	self
		radioButtonInGroup: t1
		selected: t2
				= (t4 perform: t3)
		callback: [t4 perform: t3 asMutator with: t2]! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
radioGroup
	^ self callbacks registerDispatchCallback! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
refreshDivNamed: t1 with: t2 every: t3 
	self
		refreshElementNamed: t1
		createElementWith: #divNamed:with:
		with: t2
		every: t3! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
refreshDivWith: t1 every: t2 
	self
		refreshDivNamed: 'live_update_div'
		with: t1
		every: t2! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
refreshElementNamed: t1 createElementWith: t2 with: t3 every: t4 
	| t5 |
	self
		perform: t2
		with: t1
		with: [t5 := self
						urlForLiveRequest: [:t6 :t7 | t7
								divNamed: t1
								with: [t3 value: t6 value: t7]].
			self script: 'timedUpdate(' , t5 asString printString , ', ' , t4 asMilliSeconds printString , ')']! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
refreshSpanNamed: t1 with: t2 every: t3 
	self
		refreshElementNamed: t1
		createElementWith: #spanNamed:with:
		with: t2
		every: t3! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
refreshSpanWith: t1 every: t2 
	self
		refreshSpanNamed: 'live_update_span'
		with: t1
		every: t2! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
registry
	^ WACurrentSession value application! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
request
	^ self context request! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: ''!
response
	^ self context response! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
selectFromList: t1 selected: t2 callback: t3 
	self
		selectFromList: t1
		selected: t2
		callback: t3
		labels: [:t4 | t4 asString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
selectFromList: t1 selected: t2 callback: t3 labels: t4 
	self openSelect.
	t3 fixTemps.
	t1
		do: [:t5 | self
				optionWithLabel: (t4 value: t5)
				selected: t5 = t2
				callback: [t3 value: t5]].
	self closeTag: 'select'! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
selectFromList: t1 selected: t2 callback: t3 labels: t4 liveCallback: t5 
	| t6 t7 t8 |
	t7 := self ensureId.
	t8 := t1 asArray.
	self
		selectFromList: t8
		selected: t2
		callback: t3
		labels: t4.
	t6 := self
				urlForLiveRequest: [:t9 :t10 | t5
						value: (t8
								at: t9 asInteger + 1
								ifAbsent: [])
						value: t10].
	self script: 'document.getElementById(' , t7 printString , ').onchange = liveSelect(' , t7 printString , ',' , t6 asString printString , ')'! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
selectFromList: t1 selected: t2 callback: t3 labels: t4 nilLabel: t5 
	self
		selectFromList: (Array with: nil)
				, t1 asArray
		selected: t2
		callback: t3
		labels: [:t6 | t6
				ifNil: [t5]
				ifNotNil: [t4 value: t6]]! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
selectFromList: t1 selected: t2 callback: t3 labels: t4 other: t5 label: t6 
	| t7 t8 |
	t7 := 'id' , self context advanceKey asString.
	t8 := (self context nextKey asNumber + t1 size + 1) asString.
	self attributes onChange: 'if(this.value == ' , t8 printString , ') {document.getElementById(' , t7 printString , ').style.display = "inline"; document.getElementById(' , t7 printString , ').focus()} else {document.getElementById(' , t7 printString , ').style.display = "none"}'.
	self
		selectFromList: (t1 asArray copyWith: t6)
		selected: t2
		callback: [:t9 | t9 = t6
				ifFalse: [t3 value: t9]]
		labels: [:t10 | t10 = t6
				ifTrue: [t6]
				ifFalse: [t4 value: t10]].
	self space.
	self cssId: t7.
	self attributes style: 'display: none'.
	self
		textInputWithValue: nil
		callback: [:t9 | t9
				ifNotNil: [t5 value: t9]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
selectInputOn: t1 of: t2 list: t3 
	self
		selectFromList: t3
		selected: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
spanWithShow: t1 hide: t2 do: t3 
	| t4 t5 t6 |
	t4 := self context advanceKey.
	t5 := self context advanceKey.
	t6 := 'swapDisplay(' , t4 printString , ', ' , t5 printString , '); return false;'.
	self attributes id: t4;
		 style: 'display: block'.
	self anchorWithScript: t6 do: t1.
	self attributes id: t5;
		 style: 'display: none'.
	self
		span: [self anchorWithScript: t6 do: t2.
			t3 value]! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
submitButtonOn: t1 of: t2 
	self cssId: t1;
		
		submitButtonWithAction: (MessageSend receiver: t2 selector: t1)
		text: (self labelForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
submitButtonWithAction: t1 
	self
		inputWithType: 'submit'
		named: (self callbacks registerActionCallback: t1)! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
submitButtonWithAction: t1 do: t2 
	self
		buttonWithType: 'submit'
		named: (self callbacks registerActionCallback: t1)
		value: nil
		do: t2! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
submitButtonWithAction: t1 image: t2 
	self attributes
		src: (self context urlForDocument: t2);
		 width: t2 width;
		 height: t2 height.
	self
		inputWithType: 'image'
		named: (self callbacks registerImageCallback: t1)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
submitButtonWithAction: t1 text: t2 
	self attributeAt: 'value' put: t2.
	self submitButtonWithAction: t1! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
textAreaOn: t1 of: t2 
	self cssId: t1;
		
		textAreaWithValue: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
textAreaWithValue: t1 callback: t2 
	| t3 t4 |
	t3 := t1
				ifNil: [[:t5 | t2
						value: (t5 = ''
								ifFalse: [t5])]]
				ifNotNil: [t2].
	t4 := self callbacks registerCallback: t3.
	self attributes at: 'name' put: t4;
		
		at: 'rows'
		ifAbsentPut: [3];
		
		at: 'cols'
		ifAbsentPut: [25].
	self tag: 'textarea' do: t1! !

!WAHtmlRenderer methodsFor: 'model' stamp: ''!
textInputOn: t1 of: t2 
	self
		textInputWithValue: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
textInputWithCallback: t1 
	self textInputWithValue: '' callback: t1! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
textInputWithCallback: t1 liveCallback: t2 
	| t3 t4 |
	t4 := self ensureId.
	self textInputWithValue: '' callback: t1.
	t3 := self urlForLiveRequest: t2.
	self script: 'liveSearch(' , t4 printString , ',' , t3 asString printString , ')'! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
textInputWithValue: t1 callback: t2 
	self
		valueInputOfType: 'text'
		value: t1
		callback: t2! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
textInputWithValue: t1 callback: t2 maxLength: t3 
	self attributes at: 'size' put: t3;
		 at: 'maxlength' put: t3.
	self textInputWithValue: t1 callback: t2! !

!WAHtmlRenderer methodsFor: 'compound' stamp: ''!
timeInputWithValue: t1 callback: t2 
	| t3 |
	t2 fixTemps.
	t3 := Array new: 2.
	self
		textInputWithValue: t1 hour
		callback: [:t4 | t3 at: 1 put: t4]
		maxLength: 2.
	self space; text: ':'; space.
	self
		textInputWithValue: t1 minutes asTwoCharacterString
		callback: [:t5 | t3 at: 2 put: t5 asNumber]
		maxLength: 2.
	self
		hiddenInputWithCallback: [t2
				value: (Time
						hour: t3 first
						minute: (t3 second min: 59)
						second: 0)]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
transparent1X1Form
	^ self class transparent1X1Form! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
unorderedListOn: t1 of: t2 list: t3 
	self
		unorderedList: t3
		selected: (t2 perform: t1)
		callback: (self callbackForSelector: t1 of: t2)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
unorderedList: t1 selected: t2 callback: t3 
	self
		unorderedList: t1
		selected: t2
		callback: t3
		labels: [:t4 | t4 asString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: ''!
unorderedList: t1 selected: t2 callback: t3 labels: t4 
	t3 fixTemps.
	self cssClass: 'options'.
	self
		unorderedList: [t1
				do: [:t5 | 
					self cssClass: 'option'.
					t5 = t2
						ifTrue: [self cssId: 'option-selected'].
					self
						listItem: [self
								anchorWithAction: [t3 value: t5]
								text: (t4 value: t5)]]]! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
urlForAction: t1 
	| t2 |
	t2 := context actionUrl
				withParameter: (self callbacks registerActionCallback: t1).
	^ t2 asString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: ''!
urlForDocument: t1 
	^ self context urlForDocument: t1! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
urlForIdempotentAction: t1 
	| t2 |
	t2 := context actionUrl
				withParameter: (self callbacks registerIdempotentActionCallback: t1).
	^ t2 asString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: ''!
urlForLiveRequest: t1 
	| t2 t3 t4 t5 |
	^ WACurrentSession value
		actionUrlForContinuation: [:t6 | 
			t2 := t6
						at: 's'
						ifAbsent: [].
			t3 := WAResponse new.
			t4 := WAHtmlRenderer context: self context copy callbacks: self callbacks.
			t5 := WAHtmlStreamDocument new stream: t3 stream.
			t4 context document: t5.
			t1 value: t2 value: t4.
			t5 close.
			WACurrentSession value returnResponse: t3]! !

!WAHtmlRenderer methodsFor: 'core' stamp: ''!
valueInputOfType: t1 value: t2 callback: t3 
	| t4 t5 t6 |
	t6 := t2.
	t5 := t3 fixTemps.
	t2 isNumber
		ifTrue: [t2 isFraction
				ifTrue: [t6 := t2 asFloat asString.
					t5 := [:t7 | t3
								value: (t7 = t6
										ifTrue: [t2]
										ifFalse: [self parseNumber: t7])]]
				ifFalse: [t5 := [:t7 | t3
								value: (self parseNumber: t7)]]].
	t2 isNil
		ifTrue: [t6 := ''.
			t5 := [:t7 | t3
						value: (t7 = ''
								ifFalse: [t7])]].
	t4 := self callbacks registerCallback: t5.
	self
		inputWithType: t1
		named: t4
		value: t6.
	^ t4! !

Object subclass: #WABrush
	instanceVariableNames: 'parent canvas isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WABrush methodsFor: 'as yet unclassified' stamp: ''!
close
	self isClosed
		ifFalse: [self
				with: []]! !

!WABrush methodsFor: 'as yet unclassified' stamp: ''!
isClosed
	^ isClosed
		ifNil: [false]! !

!WABrush methodsFor: 'as yet unclassified' stamp: ''!
parent
	^ parent! !

!WABrush methodsFor: 'as yet unclassified' stamp: ''!
setParent: t1 canvas: t2 
	parent := t1.
	canvas := t2! !

!WABrush methodsFor: 'as yet unclassified' stamp: ''!
with: t1 
	canvas nest: t1.
	isClosed := true! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: ''!
callback: t1 
	| t2 |
	t2 := canvas context actionUrl
				withParameter: (canvas callbacks registerActionCallback: t1).
	self attributes at: 'href' put: t2 asString! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: ''!
tag
	^ 'a'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormTag methodsFor: 'as yet unclassified' stamp: ''!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAGenericTag class methodsFor: 'as yet unclassified' stamp: ''!
tag: t1 
	^ self basicNew initializeWithTag: t1! !

!WAGenericTag methodsFor: 'as yet unclassified' stamp: ''!
initializeWithTag: t1 
	tag := t1! !

!WAGenericTag methodsFor: 'as yet unclassified' stamp: ''!
tag
	^ tag! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
attributeAt: t1 put: t2 
	self attributes at: t1 put: t2! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
attributes
	^ attributes
		ifNil: [attributes := WAHtmlAttributes new]! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
attributes: t1 
	attributes := t1! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
document
	^ canvas document! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
style: t1 
	self attributeAt: 'style' put: t1! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: ''!
with: t1 
	self document openTag: self tag attributes: attributes.
	super with: t1.
	self document closeTag: self tag! !

Object subclass: #WACallback
	instanceVariableNames: 'context owner key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAActionCallback methodsFor: 'as yet unclassified' stamp: ''!
block: t1 
	block := t1 fixTemps! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithArgument: t1 
	block value.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: ''!
isFinal
	^ true! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	^ 8! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: ''!
signalRenderNotification
	WARenderNotification new raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACancelActionCallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADefaultActionCallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	^ 10! !

WAActionCallback subclass: #WAIdempotentActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAIdempotentActionCallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithArgument: t1 
	[super evaluateWithArgument: t1]
		on: WARenderNotification
		do: [:t2 | t2 shouldRedirect: false;
				 pass]! !

!WAIdempotentActionCallback methodsFor: 'as yet unclassified' stamp: ''!
signalRenderNotification
	WARenderNotification new shouldRedirect: false;
		 raiseSignal! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAImageCallback methodsFor: 'as yet unclassified' stamp: ''!
convertKey: t1 
	^ t1 , '.x'! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
context
	^ context! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
convertKey: t1 
	^ t1! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithArgument: t1 
	self subclassResponsibility! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithField: t1 
	self
		evaluateWithArgument: (self valueForField: t1)! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
key
	^ self convertKey: key! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	self subclassResponsibility! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
setContext: t1 owner: t2 key: t3 
	context := t1.
	owner := t2.
	key := t3! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
valueForField: t1 
	^ t1
		ifNil: ['']
		ifNotNil: [(t1 isCollection
					and: [t1 isString not])
				ifTrue: [t1 isEmpty
						ifTrue: ['']
						ifFalse: [t1 first]]
				ifFalse: [t1]]! !

!WACallback methodsFor: 'as yet unclassified' stamp: ''!
<= t1 
	^ self priority < t1 priority
		or: [self priority = t1 priority
				and: [self key asNumber <= t1 key asNumber]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithArgument: t1 
	(context callbackAt: t1)
		evaluateWithArgument: nil! !

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	^ 5! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAValueCallback methodsFor: 'as yet unclassified' stamp: ''!
block: t1 
	block := t1 fixTemps! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: ''!
evaluateWithArgument: t1 
	block
		valueWithPossibleArgs: (Array with: t1)! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: ''!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackRegistry class methodsFor: 'as yet unclassified' stamp: ''!
context: t1 owner: t2 
	^ self basicNew initializeWithContext: t1 owner: t2! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
initializeWithContext: t1 owner: t2 
	context := t1.
	owner := t2! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerActionCallback: t1 
	^ self
		storeCallback: (WAActionCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerCallback: t1 
	^ self
		storeCallback: (WAValueCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerCancelActionCallback: t1 
	^ self
		storeCallback: (WACancelActionCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerDefaultActionCallback: t1 
	^ self
		storeCallback: (WADefaultActionCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerIdempotentActionCallback: t1 
	^ self
		storeCallback: (WAIdempotentActionCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerImageCallback: t1 
	^ self
		storeCallback: (WAImageCallback new block: t1)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: ''!
storeCallback: t1 
	| t2 |
	t2 := context storeCallback: t1.
	t1
		setContext: context
		owner: owner
		key: t2.
	^ t2! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackStream class methodsFor: 'as yet unclassified' stamp: ''!
callbacks: t1 request: t2 
	^ self basicNew initializeWithCallbacks: t1 request: t2! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: ''!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: ''!
initializeWithCallbacks: t1 request: t2 
	| t3 |
	t3 := SortedCollection new.
	t2 fields keys
		do: [:t4 | t1
				at: t4
				ifPresent: [:t5 | t3 add: t5]].
	callbacks := ReadStream on: t3 asArray.
	request := t2! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: ''!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: ''!
processCallbacksWithOwner: t1 
	| t2 |
	[callbacks atEnd not
		and: [callbacks peek owner == t1]]
		whileTrue: [t2 := callbacks next.
			t2
				evaluateWithField: (request fields at: t2 key)]! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: ''!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WACanvas methodsFor: 'as yet unclassified' stamp: ''!
brush: t1 
	self flush.
	currentBrush := t1.
	t1 setParent: parentBrush canvas: self.
	^ t1! !

!WACanvas methodsFor: 'as yet unclassified' stamp: ''!
flush
	currentBrush
		ifNotNil: [currentBrush close.
			currentBrush := nil]! !

!WACanvas methodsFor: 'as yet unclassified' stamp: ''!
nest: t1 
	parentBrush := currentBrush.
	currentBrush := nil.
	t1 renderOn: self.
	self flush.
	parentBrush := parentBrush parent! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: ''!
generateTags
	self tags
		do: [:t1 | 
			self compile: t1 second , '
	^ self '
					, (self patternFor: t1 first) classified: 'html-generated'.
			t1 size = 3
				ifTrue: [self compile: t1 third , ' aBlock
	self ' , t1 second , ' with: aBlock' classified: 'html-generated']]! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: ''!
patternFor: t1 
	WATagBrush
		allSubclassesDo: [:t2 | 
			t2 new tag = t1
				ifTrue: [^ 'brush: ' , t2 name , ' new'].
			nil].
	^ 'tag: ' , t1 printString! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: ''!
tags
	^ #(#('a' #anchor) #('p' #paragraph #paragraph:) #('div' #div #div:) #('span' #span #span:) #('blockquote' #blockquote #blockquote:) #('code' #code #code:) #('pre' #preformatted #preformatted:) #('b' #bold #bold:) #('i' #italic #italic:) #('small' #small #small:) #('ul' #unorderedList #unorderedList:) #('li' #listItem #listItem:) #('br' #break) #('hr' #horizontalRule) #('form' #form #form:) #('table' #table #table:) #('tr' #tableRow #tableRow:) #('td' #tableData #tableData:) #('script' #script #script:) )! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
anchor
	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
blockquote
	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
blockquote: t1 
	self blockquote with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
bold
	^ self tag: 'b'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
bold: t1 
	self bold with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
break
	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
code
	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
code: t1 
	self code with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
div
	^ self tag: 'div'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
div: t1 
	self div with: t1! !

!WAHtmlCanvas methodsFor: 'as yet unclassified' stamp: ''!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: ''!
encodeCharacter: t1 
	self html: '&#' , t1 asInteger asString , ';'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
form
	^ self brush: WAFormTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
form: t1 
	self form with: t1! !

!WAHtmlCanvas methodsFor: 'html' stamp: ''!
heading: t1 
	self heading: t1 level: 1! !

!WAHtmlCanvas methodsFor: 'html' stamp: ''!
heading: t1 level: t2 
	(self tag: 'h' , t2 asString)
		with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
horizontalRule
	^ self tag: 'hr'! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: ''!
html: t1 
	self flush.
	self document text: t1 asString! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
italic
	^ self tag: 'i'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
italic: t1 
	self italic with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
listItem
	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
listItem: t1 
	self listItem with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
paragraph
	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
paragraph: t1 
	self paragraph with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
preformatted
	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
preformatted: t1 
	self preformatted with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
script
	^ self tag: 'script'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
script: t1 
	self script with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
small
	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
small: t1 
	self small with: t1! !

!WAHtmlCanvas methodsFor: 'html' stamp: ''!
space
	self html: '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
span
	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
span: t1 
	self span with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
table
	^ self tag: 'table'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
tableData
	^ self tag: 'td'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
tableData: t1 
	self tableData with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
tableRow
	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
tableRow: t1 
	self tableRow with: t1! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
table: t1 
	self table with: t1! !

!WAHtmlCanvas methodsFor: 'as yet unclassified' stamp: ''!
tag: t1 
	^ self
		brush: (WAGenericTag tag: t1)! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: ''!
text: t1 
	self
		html: (WAAbstractHtmlBuilder encode: t1)! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
unorderedList
	^ self tag: 'ul'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: ''!
unorderedList: t1 
	self unorderedList with: t1! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARenderCanvas class methodsFor: 'as yet unclassified' stamp: ''!
context: t1 callbacks: t2 
	^ self basicNew initializeWithContext: t1 callbacks: t2! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
callbacks
	^ callbacks! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
close
	self flush! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
context
	^ context! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
document
	^ self context document! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
initializeWithContext: t1 callbacks: t2 
	context := t1.
	callbacks := t2! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: ''!
render: t1 
	self flush.
	t1 renderOn: self! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfiguration class methodsFor: 'instance creation' stamp: ''!
new
	^ self basicNew initialize! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
readUserConfigurationsFrom: t1 
	| t2 |
	t2 := INIFile readFrom: t1.
	self
		registeredConfigurationsDo: [:t3 | (t2 includesSection: t3 name)
				ifTrue: [t3 clear.
					(t2 section: t3 name)
						associationsDo: [:t4 | t4 value
								ifNotNil: [(t3 hasAttributeNamed: t4 key)
										ifTrue: [t3 valueAt: t4 key put: t4 value]]]]]! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
writeUserConfigurationsOn: t1 
	| t2 |
	t2 := INIFile new.
	self registry
		keysAndValuesDo: [:t3 :t4 | (t2 section: t3)
				addAll: t4 localValues].
	t2 writeOn: t1! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
addAncestorsTo: t1 linearization: t2 
	(t2 includes: self)
		ifTrue: [t1
				do: [:t3 | t2 add: t3 before: self].
			t1
				removeAllSuchThat: [:t3 | true]]
		ifFalse: [t1 add: self.
			self ancestors isEmpty
				ifTrue: [t2 addAll: t1.
					t1
						removeAllSuchThat: [:t3 | true]]
				ifFalse: [self ancestors
						do: [:t3 | t3 addAncestorsTo: t1 linearization: t2]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
allAncestors
	| t1 t2 |
	t1 := OrderedCollection new.
	t2 := OrderedCollection new.
	self addAncestorsTo: t1 linearization: t2.
	^ t2 allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
allAncestorsDo: t1 
	self allAncestors do: t1! !

!WAConfiguration methodsFor: 'attributes' stamp: ''!
allAttributes
	^ Array
		streamContents: [:t1 | self
				withAllAncestorsDo: [:t2 | t1 nextPutAll: t2 attributes]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: ''!
attributeNamed: t1 
	^ self allAttributes
		detect: [:t2 | t2 key = t1]
		ifNone: [self error: 'No attribute named ' , t1 printString]! !

!WAConfiguration methodsFor: 'attributes' stamp: ''!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: ''!
attributesAndValuesDo: t1 
	^ self allAttributes
		do: [:t2 | t1
				value: t2
				value: (self valueForAttribute: t2)]! !

!WAConfiguration methodsFor: 'attributes' stamp: ''!
groupedAttributes
	| t1 t2 |
	t1 := Dictionary new.
	t2 := SortedCollection
				sortBlock: [:t3 :t4 | t3 key <= t4 key].
	self allAttributes
		do: [:t5 | (t1
				at: t5 group
				ifAbsentPut: [SortedCollection
						sortBlock: [:t3 :t4 | t3 key <= t4 key]])
				add: t5].
	t1
		associationsDo: [:t6 | t2 add: t6].
	^ t2! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
hasAttributeNamed: t1 
	^ self allAttributes
		anySatisfy: [:t2 | t2 key = t1]! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
hasLocalValueForAttribute: t1 
	self
		localValueAt: t1 key
		ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: ''!
inheritedValueAndSourceAt: t1 do: t2 
	self
		allAncestorsDo: [:t3 | (t3
				localValueAt: t1
				ifAbsent: [])
				ifNotNilDo: [:t4 | ^ t2 value: t4 value: t3]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
inheritsFrom: t1 
	^ self allAncestors
		anySatisfy: [:t2 | t2 = t1]! !

!WAConfiguration methodsFor: 'initializing' stamp: ''!
initialize
	^ self! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
isDeletable
	^ false! !

!WAConfiguration methodsFor: 'testing' stamp: ''!
isMutable
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: ''!
localValueAt: t1 ifAbsent: t2 
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: ''!
lookupValueAt: t1 
	^ self
		inheritedValueAndSourceAt: t1
		do: [:t2 :t3 | t2]! !

!WAConfiguration methodsFor: 'accessing' stamp: ''!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
potentialAncestors
	^ self allPotentialAncestors
		reject: [:t1 | t1 = self
				or: [(self inheritsFrom: t1)
						or: [t1 inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: ''!
valueAt: t1 
	^ self
		localValueAt: t1
		ifAbsent: [self lookupValueAt: t1]! !

!WAConfiguration methodsFor: 'values' stamp: ''!
valueForAttribute: t1 
	^ self valueAt: t1 key! !

!WAConfiguration methodsFor: 'ancestry' stamp: ''!
withAllAncestorsDo: t1 
	t1 value: self.
	^ self allAncestorsDo: t1! !

WAConfiguration subclass: #WAMutableConfiguration
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAMutableConfiguration subclass: #WALocalConfiguration
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WALocalConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
parent: t1 
	^ self basicNew initializeWithParent: t1! !

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
ancestors
	^ Array with: parent! !

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
initializeWithParent: t1 
	parent := t1.
	self initialize! !

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
name
	^ parent localConfigurationName! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
clear
	values := Dictionary new! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
clearValueForAttribute: t1 
	values
		removeKey: t1 key
		ifAbsent: []! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	values := Dictionary new! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
isMutable
	^ true! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localValueAt: t1 ifAbsent: t2 
	^ values at: t1 ifAbsent: t2! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localValues
	| t1 |
	t1 := Dictionary new.
	self allAttributes
		do: [:t2 | (self
				localValueAt: t2 key
				ifAbsent: [])
				ifNotNilDo: [:t3 | t1
						at: t2 key
						put: (t2 stringForValue: t3)]].
	^ t1! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localValues: t1 
	self allAttributes
		do: [:t2 | (t1
				at: t2 key
				ifAbsent: [])
				ifNotNilDo: [:t3 | self
						valueAt: t2 key
						put: (t2 valueFromString: t3)]]! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
overrideAttribute: t1 
	self
		takeValue: (self valueForAttribute: t1)
		forAttribute: t1! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
takeValue: t1 forAttribute: t2 
	^ t1
		ifNotNil: [values at: t2 key put: t1]! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: ''!
valueAt: t1 put: t2 
	^ self
		takeValue: t2
		forAttribute: (self attributeNamed: t1)! !

WAMutableConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'name ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAUserConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	^ self new name: t1! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
addAncestor: t1 
	(self inheritsFrom: t1)
		ifFalse: [ancestors add: t1]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
allPotentialAncestors
	^ WASystemConfigurationPool default configurations! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	ancestors := OrderedCollection new! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
isDeletable
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name
		ifNil: ['Anonymous']! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: ''!
removeAncestor: t1 
	ancestors
		remove: t1
		ifAbsent: []! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'local'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: ''!
ancestors
	^ Array with: WARenderLoopConfiguration localConfiguration! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: ''!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: ''!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
attributes
	^ Array
		with: ((WAListAttribute key: #serverProtocol)
				options: #(#http #https ))
		with: (WAStringAttribute key: #serverHostname)
		with: (WANumberAttribute key: #serverPort)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
deploymentMode
	^ false! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: ''!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: ''!
ancestors
	^ Array with: WASessionConfiguration localConfiguration! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: ''!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent)
				options: self rootComponents)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: ''!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: ''!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: ''!
rootComponents
	^ (WAComponent allSubclasses
		select: [:t1 | t1 canBeRoot])
		asSortedCollection: [:t2 :t3 | t2 name <= t3 name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
alwaysRedirect
	^ true! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
ancestors
	^ Array with: WAGlobalConfiguration localConfiguration! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
attributes
	^ Array
		with: (WABooleanAttribute key: #alwaysRedirect)
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass)
				options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass)
				options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler)
				options: self errorHandlerClasses)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: ''!
sessionExpirySeconds
	^ 600! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
instance
	^ instance
		ifNil: [instance := self new]! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: ''!
localConfiguration
	^ self instance localConfiguration! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: ''!
attributes
	self subclassResponsibility! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localConfiguration
	^ local
		ifNil: [local := WALocalConfiguration parent: self]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localConfigurationName
	^ self class name! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: ''!
localValueAt: t1 ifAbsent: t2 
	^ (self respondsTo: t1)
		ifTrue: [self perform: t1]
		ifFalse: [t2 value]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: ''!
name
	^ self localConfigurationName , ' defaults'! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	^ t1 visitBooleanAttribute: self with: t2! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: ''!
valueFromString: t1 
	^ t1 = 'true'
		or: [t1 = 'false'
				ifTrue: [false]
				ifFalse: [self error: 'Invalid value for boolean attribute']]! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: ''!
key: t1 
	^ self key: t1 group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: ''!
key: t1 group: t2 
	^ self basicNew initializeWithKey: t1 group: t2! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	self subclassResponsibility! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
group
	^ group
		ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
initializeWithKey: t1 group: t2 
	key := t1.
	group := t2! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
stringForValue: t1 
	^ t1 asString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: ''!
valueFromString: t1 
	self subclassResponsibility! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	^ t1 visitListAttribute: self with: t2! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: ''!
options
	^ options! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: ''!
options: t1 
	options := t1! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: ''!
valueFromString: t1 
	^ self options
		detect: [:t2 | t2 asString = t1]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	^ t1 visitNumberAttribute: self with: t2! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: ''!
valueFromString: t1 
	^ Number readFrom: t1! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	^ t1 visitPasswordAttribute: self with: t2! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: ''!
accept: t1 with: t2 
	^ t1 visitStringAttribute: self with: t2! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: ''!
valueFromString: t1 
	^ t1! !

Object subclass: #WAConfigurationPool
	instanceVariableNames: 'configurations'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	Registry := Dictionary new! !

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	^ Registry
		at: t1
		ifAbsentPut: [self new]! !

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: ''!
add: t1 
	configurations add: t1! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: ''!
configurations
	^ configurations! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: ''!
initialize
	configurations := Set new! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: ''!
remove: t1 
	configurations
		remove: t1
		ifAbsent: []! !

WAConfigurationPool subclass: #WASystemConfigurationPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WASystemConfigurationPool class methodsFor: 'as yet unclassified' stamp: ''!
default
	^ self named: #defaultSystemPool! !

!WASystemConfigurationPool methodsFor: 'as yet unclassified' stamp: ''!
configurations
	^ configurations copy
		addAll: (WASystemConfiguration allSubclasses
				collect: [:t1 | t1 localConfiguration])! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WACookie class methodsFor: 'as yet unclassified' stamp: ''!
key: t1 value: t2 
	^ self new key: t1;
		 value: t2;
		 yourself! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
expireIn: t1 
	self expiry: DateAndTime now + t1! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
expiry
	^ expiry! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
expiryString
	^ String
		streamContents: [:t1 | t1
				nextPutAll: (expiry dayOfWeekName first: 3);
				 nextPutAll: ', ';
				 nextPutAll: expiry dayOfMonth asString;
				 nextPut: $-;
				 nextPutAll: expiry monthName;
				 nextPut: $-;
				 nextPutAll: expiry year asString;
				 space;
				 nextPutAll: expiry hour24 asString;
				 nextPut: $:;
				 nextPutAll: expiry minute asString;
				 nextPut: $:;
				 nextPutAll: expiry second asString;
				 nextPutAll: ' GMT']! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
expiry: t1 
	expiry := t1 asUTC! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
key
	^ key! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
key: t1 
	key := t1! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
path
	^ path
		ifNil: ['/']! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
path: t1 
	path := t1! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
value
	^ value! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [self value , '; expires=' , self expiryString]! !

!WACookie methodsFor: 'as yet unclassified' stamp: ''!
value: t1 
	value := t1! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: ''!
handleError: t1 
	^ self new handleError: t1! !

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: ''!
handleWarning: t1 
	^ self new handleWarning: t1! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: ''!
handleError: t1 
	t1 pass! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: ''!
handleWarning: t1 
	self handleError: t1! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASimpleErrorHandler methodsFor: 'as yet unclassified' stamp: ''!
handleError: t1 
	WACurrentSession value
		returnResponse: (WAResponse internalError: t1)! !

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: ''!
handleError: t1 
	WARenderLoop new
		call: (WAWalkback new exception: t1)
		withToolFrame: false.
	t1 defaultAction! !

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: ''!
handleWarning: t1 
	WARenderLoop new
		call: (WAFormDialog new addMessage: t1 messageText).
	t1 resume! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
contents
	^ contents! !

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
contents: t1 
	contents := t1! !

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
contentType
	^ contentType! !

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
contentType: t1 
	contentType := t1! !

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
fileName
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'as yet unclassified' stamp: ''!
fileName: t1 
	fileName := t1! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'associations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlAttributes methodsFor: 'convenience' stamp: ''!
addClass: t1 
	| t2 |
	t2 := self associations
				detect: [:t3 | t3 key = 'class']
				ifNone: [self associations add: 'class' -> t1.
					^ self].
	t2 value: t2 value , ' ' , t1! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: ''!
alignBottom
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: ''!
alignCenter
	self at: 'align' put: 'center'! !

!WAHtmlAttributes methodsFor: 'private' stamp: ''!
associations
	^ associations
		ifNil: [associations := OrderedCollection new]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: ''!
at: t1 ifAbsentPut: t2 
	^ self associations
		detect: [:t3 | t3 key = t1]
		ifNone: [self associations add: t1 -> t2 value]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: ''!
at: t1 put: t2 
	self associations add: t1 -> t2! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: ''!
doesNotUnderstand: t1 
	| t2 |
	t2 := t1 arguments size.
	t2 = 0
		ifTrue: [^ self at: t1 selector put: true].
	t2 = 1
		ifTrue: [^ self at: t1 selector allButLast put: t1 argument].
	^ super doesNotUnderstand: t1! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: ''!
submitOnChange
	self at: 'onChange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: ''!
submitOnClick
	self at: 'onClick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'printing' stamp: ''!
writeAttribute: t1 on: t2 
	t1 value = false
		ifFalse: [t2 nextPut: $ .
			t2 nextPutAll: t1 key asLowercase.
			t2 nextPutAll: '="'.
			t1 value = true
				ifTrue: [t2 nextPutAll: t1 key asLowercase]
				ifFalse: [t2
						nextPutAll: (WAAbstractHtmlBuilder encode: t1 value asString)].
			t2 nextPut: $"]! !

!WAHtmlAttributes methodsFor: 'printing' stamp: ''!
writeOn: t1 
	associations
		ifNotNil: [associations
				do: [:t2 | self writeAttribute: t2 on: t1]]! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlDocument class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self root: WAHtmlRoot new! !

!WAHtmlDocument class methodsFor: 'as yet unclassified' stamp: ''!
root: t1 
	^ self basicNew initializeWithRoot: t1! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
close
	^ self! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
closeTag: t1 
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
initializeWithRoot: t1 
	root := t1! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
openTag: t1 attributes: t2 
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
root
	^ root! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: ''!
shouldPrintCloseTagFor: t1 
	^ (#('hr' 'br' 'input' 'img' 'link' ) includes: t1) not! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'state stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
bodyStream
	state = #head
		ifTrue: [state := #body.
			root writeOn: stream].
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
close
	self bodyStream nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
closeTag: t1 
	self writeCloseTag: t1 on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
initializeWithRoot: t1 
	super initializeWithRoot: t1.
	stream := String new writeStream.
	state := #head! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
openTag: t1 attributes: t2 
	self
		writeOpenTag: t1
		attributes: t2
		on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
stream: t1 
	stream := t1! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
text: t1 
	self bodyStream nextPutAll: t1! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
writeCloseTag: t1 on: t2 
	(self shouldPrintCloseTagFor: t1)
		ifTrue: [t2 nextPutAll: '</';
				 nextPutAll: t1;
				 nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: ''!
writeOpenTag: t1 attributes: t2 on: t3 
	t3 nextPut: $<;
		 nextPutAll: t1.
	t2
		ifNotNil: [t2 writeOn: t3].
	(self shouldPrintCloseTagFor: t1)
		ifFalse: [t3 nextPutAll: ' /'].
	t3 nextPut: $>! !

WAHtmlDocument subclass: #WAHtmlTreeDocument
	instanceVariableNames: 'head stack body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlTreeDocument class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: ''!
addElement: t1 
	stack last add: t1! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: ''!
closeTag: t1 
	self popElement name = t1
		ifFalse: [self error: 'Mismatched tags']! !

!WAHtmlTreeDocument methodsFor: 'accessing' stamp: ''!
initializeWithRoot: t1 
	super initializeWithRoot: t1.
	body := WAHtmlElement named: 'body'.
	stack := OrderedCollection with: body! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: ''!
openTag: t1 attributes: t2 
	| t3 |
	t3 := WAHtmlElement named: t1 attributes: t2.
	(self shouldPrintCloseTagFor: t1)
		ifTrue: [t3 beClosed]
		ifFalse: [t3 notClosed].
	self pushElement: t3! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: ''!
popElement
	^ stack removeLast! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: ''!
pushElement: t1 
	self addElement: t1.
	stack add: t1! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: ''!
text: t1 
	self addElement: t1! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: ''!
withElement: t1 do: t2 
	self pushElement: t1.
	t2 value.
	self popElement! !

!WAHtmlTreeDocument methodsFor: 'as yet unclassified' stamp: ''!
writeBodyOn: t1 
	body
		childrenDo: [:t2 | t2 writeOn: t1]! !

!WAHtmlTreeDocument methodsFor: 'as yet unclassified' stamp: ''!
writeOn: t1 
	root writeOn: t1.
	self writeBodyOn: t1.
	t1 nextPutAll: '</body></html>'! !

WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPrettyPrintedDocument class methodsFor: 'as yet unclassified' stamp: ''!
renderer: t1 
	^ self basicNew initializeWithRenderer: t1! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
attributes: t1 
	t1
		ifNotNil: [t1 associations
				do: [:t2 | self attribute: t2]]! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
attribute: t1 
	| t2 t3 |
	t2 := t1 key asLowercase.
	t3 := t1 value.
	t3 = false
		ifFalse: [html space.
			html
				spanClass: (self cssClassForAttribute: t2)
				with: [html text: t2].
			html text: '='.
			html
				spanClass: 'attribute-value'
				with: [html text: '"'.
					t2 = 'href'
						ifTrue: [html
								anchorWithUrl: t3
								do: (t3 size > 8
										ifTrue: ['...'
												, (t3 last: 8)]
										ifFalse: [t3])]
						ifFalse: [t3 = true
								ifTrue: [html text: t2]
								ifFalse: [html text: t3 asString]].
					html text: '"']]! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
closeTag: t1 
	indentLevel := indentLevel - 1.
	indentCloseTags removeLast
		ifTrue: [html break.
			indentLevel
				timesRepeat: [html space]].
	(self shouldPrintCloseTagFor: t1)
		ifTrue: [html text: '</'.
			html
				spanClass: (self cssClassFor: t1)
				with: [html text: t1].
			html text: '>']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
cssClassForAttribute: t1 
	^ (self isKnownAttribute: t1)
		ifTrue: ['attribute-known']
		ifFalse: ['attribute-unknown']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
cssClassFor: t1 
	^ (self isKnownTag: t1)
		ifTrue: ['tag-known']
		ifFalse: ['tag-unknown']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
initializeWithRenderer: t1 
	html := t1.
	indentCloseTags := OrderedCollection with: false.
	indentLevel := 0! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
isKnownAttribute: t1 
	^ self knownAttributes includes: t1 asLowercase asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
isKnownTag: t1 
	^ self knownTags includes: t1 asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
knownAttributes
	^ #(#abbr #accept #- #charset #accept #accesskey #action #align #alink #alt #archive #axis #background #bgcolor #bgproperties #border #cellpadding #cellspacing #char #charoff #charset #checked #cite #class #classid #clear #code #codebase #codetype #color #cols #colspan #compact #content #coords #data #datetime #declare #defer #dir #direction #disabled #encoding #enctype #face #for #frame #frameborder #framespacing #gutter #headers #height #href #hreflang #hspace #http #- #equiv #id #ismap #label #lang #leftmargin #link #longdesc #loop #lowsrc #marginheight #marginwidth #maxlength #media #method #methods #multiple #name #nohref #noresize #noshade #nowrap #object #onabort #onblur #onchange #onclick #ondblclick #onerror #onfocus #onkeydown #onkeypress #onkeyup #onload #onmousedown #onmousemove #onmouseout #onmouseover #onmouseup #onreset #onselect #onsubmit #onunload #prompt #PUBLIC #readonly #rel #rev #rows #rowspan #rules #scheme #scope #scrolling #selected #shape #size #span #src #standby #style #summary #tabindex #target #text #title #type #urn #usemap #valign #value #valuetype #version #vlink #vspace #width #wrap #xml:lang #xmlns )! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
knownTags
	^ #(#? #xml #!! #doctype #!! #dt #a #abbr #acronym #address #applet #area #attach #b #base #basefont #bdo #big #blink #blockquote #body #br #button #caption #center #cite #code #col #colgroup #comment #component #dd #del #dfn #dir #div #dl #dt #em #fieldset #font #form #frame #frameset #h #h1 #h2 #h3 #h4 #h5 #h6 #head #hr #html #i #iframe #img #input #ins #isindex #kbd #label #legend #li #link #listing #map #menu #meta #multicol #nextid #nobr #noframes #noscript #object #ol #optgroup #option #p #param #plaintext #pre #q #s #samp #script #select #small #span #strike #strong #style #sub #sup #table #tbody #td #textarea #textflow #tfoot #th #thead #title #tr #tt #u #ul #var #wbr #xmp )! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
openTag: t1 attributes: t2 
	html break.
	indentLevel
		timesRepeat: [html space].
	html text: '<'.
	html
		spanClass: (self cssClassFor: t1)
		with: [html text: t1].
	self attributes: t2.
	(self shouldPrintCloseTagFor: t1)
		ifFalse: [html space; text: '/'].
	html text: '>'.
	indentLevel := indentLevel + 1.
	indentCloseTags removeLast; addLast: true; addLast: false! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: ''!
text: t1 
	html text: t1! !

WAHtmlDocument subclass: #WAStyleCollector
	instanceVariableNames: 'styles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: ''!
closeTag: t1 
	^ self! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: ''!
openTag: t1 attributes: t2 
	t2
		ifNil: [^ self].
	t2 associations
		do: [:t3 | 
			t3 key = 'class'
				ifTrue: [self styles
						addAll: ((t3 value findTokens: ' ')
								collect: [:t4 | '.' , t4])].
			t3 key = 'id'
				ifTrue: [self styles add: '#' , t3 value]]! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: ''!
styles
	^ styles
		ifNil: [styles := Set new]! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: ''!
text: t1 
	^ self! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	^ self named: t1 attributes: WAHtmlAttributes new! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 attributes: t2 
	^ self new initializeWithName: t1 attributes: t2! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
add: t1 
	children
		ifNil: [children := OrderedCollection new].
	children add: t1! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
attributeAt: t1 put: t2 
	attributes at: t1 put: t2! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
beClosed
	isClosed := true! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
childrenDo: t1 
	children
		ifNotNil: [children do: t1]! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
initializeWithName: t1 attributes: t2 
	name := t1.
	attributes := t2.
	isClosed := true! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
notClosed
	isClosed := false! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
printCloseTagOn: t1 
	t1 nextPutAll: '</';
		 nextPutAll: self name;
		 nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
printHtmlOn: t1 
	self printOpenTagOn: t1.
	self
		childrenDo: [:t2 | t2 writeOn: t1].
	self shouldPrintCloseTag
		ifTrue: [self printCloseTagOn: t1]! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
printOpenTagOn: t1 
	t1 nextPut: $<;
		 nextPutAll: self name.
	attributes
		ifNotNil: [attributes writeOn: t1].
	self shouldPrintCloseTag
		ifFalse: [t1 nextPutAll: ' /'].
	t1 nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: ''!
writeOn: t1 
	self printOpenTagOn: t1.
	self
		childrenDo: [:t2 | t2 isString
				ifTrue: [t1 nextPutAll: t2]
				ifFalse: [t2 writeOn: t1]].
	self shouldPrintCloseTag
		ifTrue: [self printCloseTagOn: t1]! !

Object subclass: #WAHtmlRoot
	instanceVariableNames: 'docType title htmlAttrs headAttrs bodyAttrs headElements scripts styles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlRoot class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
addHeadElement: t1 
	headElements add: t1! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
addScript: t1 
	(scripts includes: t1)
		ifFalse: [scripts add: t1]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
addStyle: t1 
	(styles includes: t1)
		ifFalse: [styles add: t1]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
bodyAttributes
	^ bodyAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
docType: t1 
	docType := t1! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
headAttributes
	^ headAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
htmlAttributes
	^ htmlAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
initialize
	htmlAttrs := WAHtmlAttributes new.
	headAttrs := WAHtmlAttributes new.
	bodyAttrs := WAHtmlAttributes new.
	headElements := OrderedCollection new.
	scripts := OrderedCollection new.
	styles := OrderedCollection new.
	docType := '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title := ''! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
title
	^ title! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
title: t1 
	title := t1! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeHeadOn: t1 
	t1 nextPutAll: '<title>' , title , '</title>'.
	styles
		do: [:t2 | self writeStyle: t2 on: t1].
	scripts
		do: [:t2 | self writeScript: t2 on: t1].
	headElements
		do: [:t2 | t2 writeOn: t1]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeOn: t1 
	t1 nextPutAll: docType.
	t1 nextPutAll: '<html'.
	htmlAttrs writeOn: t1.
	t1 nextPutAll: '><head'.
	headAttrs writeOn: t1.
	t1 nextPutAll: '>'.
	self writeHeadOn: t1.
	t1 nextPutAll: '</head><body'.
	bodyAttrs writeOn: t1.
	t1 nextPutAll: '>'! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeScript: t1 on: t2 
	t2 nextPutAll: '<script type="text/javascript">';
		 nextPutAll: t1;
		 nextPutAll: '</script>'! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeStyle: t1 on: t2 
	t2 nextPutAll: '<style>';
		 nextPutAll: t1;
		 nextPutAll: '</style>'! !

WAHtmlRoot subclass: #WARenderedHtmlRoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderedHtmlRoot class methodsFor: 'as yet unclassified' stamp: ''!
context: t1 
	^ self basicNew initializeWithContext: t1! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
initializeWithContext: t1 
	context := t1.
	self initialize! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeScript: t1 on: t2 
	| t3 |
	t3 := context urlForDocument: t1 mimeType: 'text/javascript'.
	t2 nextPutAll: '<script type="text/javascript" src="' , t3 , '"></script>'! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: ''!
writeStyle: t1 on: t2 
	| t3 |
	t3 := context urlForDocument: t1 mimeType: 'text/css'.
	t2 nextPutAll: '<link rel="stylesheet" type="text/css" href="' , t3 , '" />'! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAKom class
	instanceVariableNames: 'port service'!

WAKom subclass: #WAKomEncoded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded methodsFor: 'as yet unclassified' stamp: ''!
convertRequest: t1 
	| t2 t3 t6 |
	self processMultipartFields: t1.
	t3 := t1 method = 'POST'
				ifTrue: [t1 postFields]
				ifFalse: [t1 getFields].
	t3
		associationsDo: [:t4 | (t4 value isKindOf: OrderedCollection)
				ifTrue: [t4
						value: (t4 value
								collect: [:t5 | 
									t6 := (MultiByteBinaryOrTextStream with: t5) reset.
									t6 converter: UTF8TextConverter new.
									t6 contents])]].
	t2 := WARequest
				method: t1 method
				url: t1 url unescapePercents
				headers: t1 header
				fields: t3
				cookies: t1 cookies
				nativeRequest: t1.
	t1 method = 'PUT'
		ifTrue: [t2 fields
				at: 'PUTData'
				put: (t1 stream next: t1 contentLength)].
	^ t2! !

!WAKomEncoded methodsFor: 'as yet unclassified' stamp: ''!
convertResponse: t1 
	| t2 t3 |
	t1
		ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].
	t2 := HttpResponse new.
	t1 cookies
		do: [:t4 | t2
				setCookieName: t4 key
				value: t4 valueWithExpiry
				path: t4 path].
	t1 headers
		associationsDo: [:t4 | t2 fieldAt: t4 key put: t4 value].
	(HttpResponse classPool at: #StatusCodes)
		associationsDo: [:t4 | t4 value key = t1 status
				ifTrue: [t2 status: t4 key]].
	t3 := t1.
	(t1 contentType upTo: $/)
			= 'text'
		ifTrue: [t3 := MultiByteBinaryOrTextStream on: WideString new encoding: #utf8.
			t3 nextPutAll: t1 contents.
			t3 binary reset].
	t2 contents: t3 contents readStream.
	t2 contentType: t1 contentType.
	^ t2! !

!WAKom class methodsFor: 'service' stamp: ''!
createService
	Smalltalk
		at: #HttpService
		ifPresent: [:t1 | ^ (t1 on: port named: 'seaside')
				plug: self default].
	Smalltalk
		at: #ComancheNetService
		ifPresent: [:t2 | ^ (t2 named: 'seaside' onPort: port)
				module: self default].
	self error: 'Comanche is not installed.  Install Comanche from
SqueakMap and try again.'! !

!WAKom class methodsFor: 'as yet unclassified' stamp: ''!
default
	^ self entryPoint: WADispatcher default! !

!WAKom class methodsFor: 'as yet unclassified' stamp: ''!
entryComponent: t1 path: t2 
	^ self
		dispatcher: (t1 applicationWithPath: t2)! !

!WAKom class methodsFor: 'as yet unclassified' stamp: ''!
entryPoint: t1 
	^ self new entryPoint: t1! !

!WAKom class methodsFor: 'service' stamp: ''!
initialize
	Smalltalk addToStartUpList: self after: AutoStart.
	Smalltalk addToShutDownList: self! !

!WAKom class methodsFor: 'service' stamp: ''!
pause
	service
		ifNotNil: [service unregister.
			service := nil]! !

!WAKom class methodsFor: 'service' stamp: ''!
setDebugMode
	service setDebugMode! !

!WAKom class methodsFor: 'service' stamp: ''!
setDeploymentMode
	service setDeploymentMode! !

!WAKom class methodsFor: 'service' stamp: ''!
setVerboseMode
	service setVerboseMode! !

!WAKom class methodsFor: 'service' stamp: ''!
shutdown
	self pause! !

!WAKom class methodsFor: 'service' stamp: ''!
startOn: t1 
	self stop.
	port := t1.
	service := self createService.
	service start! !

!WAKom class methodsFor: 'service' stamp: ''!
startUp
	port
		ifNotNil: [self startOn: port]! !

!WAKom class methodsFor: 'service' stamp: ''!
stop
	self pause.
	port := nil! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
convertRequest: t1 
	| t2 |
	self processMultipartFields: t1.
	t2 := WARequest
				method: t1 method
				url: t1 url unescapePercents
				headers: t1 header
				fields: (t1 method = 'POST'
						ifTrue: [t1 postFields]
						ifFalse: [t1 getFields])
				cookies: t1 cookies
				nativeRequest: t1.
	t1 method = 'PUT'
		ifTrue: [t2 fields
				at: 'PUTData'
				put: (t1 stream next: t1 contentLength)].
	^ t2! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
convertResponse: t1 
	| t2 |
	t1
		ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].
	t2 := HttpResponse new.
	t1 cookies
		do: [:t3 | t2
				setCookieName: t3 key
				value: t3 valueWithExpiry
				path: t3 path].
	t1 headers
		associationsDo: [:t3 | t2 fieldAt: t3 key put: t3 value].
	(HttpResponse classPool at: #StatusCodes)
		associationsDo: [:t3 | t3 value key = t1 status
				ifTrue: [t2 status: t3 key]].
	t2 contents: t1 contents.
	t2 contentType: t1 contentType.
	^ t2! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
entryPoint: t1 
	entryPoint := t1! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
handleRequest: t1 
	^ (entryPoint handlerForRequest: t1)
		handleRequest: t1! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
log: t1 
	Transcript cr; show: t1 url! !

!WAKom methodsFor: 'kom 6.1' stamp: ''!
processHttp
	HttpResponse
		current: (self process: HttpRequest current).
	^ true! !

!WAKom methodsFor: 'kom 6.1' stamp: ''!
processHttpRequest: t1 
	^ self process: t1! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
processMultipartFields: t1 
	| t3 t4 |
	t1
		multipartFormFieldsDo: [:t2 | t2 fileName isEmptyOrNil
				ifFalse: [t3 := WriteStream on: String new.
					t2 saveToStream: t3.
					t4 := WAFile new fileName: t2 fileName;
								 contents: t3 contents;
								 contentType: t2 contentType.
					t1 postFields at: t2 fieldName put: t4]]! !

!WAKom methodsFor: 'as yet unclassified' stamp: ''!
process: t1 
	| t2 t3 t4 |
	self log: t1.
	t2 := self convertRequest: t1.
	t3 := self handleRequest: t2.
	t4 := self convertResponse: t3.
	t3 release.
	^ t4! !

!WAKom methodsFor: 'kom 6.1' stamp: ''!
validateForStack: t1 
	^ self! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WALRUCache class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: ''!
new: t1 
	^ self new capacity: t1! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
at: t1 
	^ self
		at: t1
		ifAbsent: [self error: 'No entry for ' , t1]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
at: t1 ifAbsent: t2 
	| t3 |
	t3 := table
				at: t1
				ifAbsent: [^ t2 value].
	ageTable at: t3 put: 0.
	^ t3! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
at: t1 put: t2 
	| t3 |
	table at: t1 put: t2.
	ageTable at: t2 put: 0.
	t3 := OrderedCollection new.
	ageTable
		associationsDo: [:t4 | 
			t4 value > max
				ifTrue: [t3 add: t4 key].
			t4 value: t4 value + 1].
	t3
		do: [:t5 | self remove: t5]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
capacity: t1 
	max := t1! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
initialize
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
nextKey
	| t1 |
	[table includesKey: (t1 := WAExternalID new asString)] whileTrue.
	^ t1! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
remove: t1 
	ageTable removeKey: t1.
	table
		removeKey: (table keyAtValue: t1)! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: ''!
store: t1 
	| t2 |
	t2 := self nextKey.
	self at: t2 put: t1.
	^ t2! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAMain methodsFor: 'as yet unclassified' stamp: ''!
application
	^ self session application! !

!WAMain methodsFor: 'as yet unclassified' stamp: ''!
session
	^ WACurrentSession value! !

!WAMain methodsFor: 'as yet unclassified' stamp: ''!
start: t1 
	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthMain methodsFor: 'as yet unclassified' stamp: ''!
createRoot
	| t1 |
	t1 := super createRoot.
	t1
		addDecoration: (WABasicAuthentication new authenticator: self).
	^ t1! !

!WAAuthMain methodsFor: 'as yet unclassified' stamp: ''!
verifyPassword: t1 forUser: t2 
	^ (self application preferenceAt: #login)
			= t2
		and: [(self application preferenceAt: #password)
				= t1]! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: ''!
call: t1 
	^ WARenderLoop new call: t1! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: ''!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: ''!
rootClass
	^ self application preferenceAt: #rootComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: ''!
start: t1 
	(WARenderLoop new root: self createRoot) run! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAModelProxy class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new setModel: t1! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
commit
	cache
		keysAndValuesDo: [:t1 :t2 | self performRealWrite: t1 with: t2].
	cache := Dictionary new! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
doesNotUnderstand: t1 
	^ t1 selector isUnary
		ifTrue: [self performRead: t1 selector]
		ifFalse: [(t1 selector isKeyword
					and: [t1 arguments size = 1])
				ifTrue: [self performWrite: t1 selector allButLast with: t1 argument]
				ifFalse: [super doesNotUnderstand: t1]]! !

!WAModelProxy methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
name
	^ model name! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
performRead: t1 
	^ cache
		at: t1
		ifAbsent: [model perform: t1]! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
performRealWrite: t1 with: t2 
	model perform: (t1 , ':') asSymbol with: t2! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
performWrite: t1 with: t2 
	cache at: t1 put: t2! !

!WAModelProxy methodsFor: 'initializing' stamp: ''!
setModel: t1 
	model := t1.
	cache := Dictionary new! !

!WAModelProxy methodsFor: 'forwarding' stamp: ''!
value
	^ model value! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 list: t2 selected: t3 changeSelected: t4 
	^ self
		on: t1
		list: t2
		selected: t3
		changeSelected: t4
		size: 10! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 list: t2 selected: t3 changeSelected: t4 size: t5 
	^ self new model: t1;
		 list: t2;
		 selected: t3;
		 changeSelected: t4;
		 size: t5! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
changeSelected: t1 
	changeSelected := t1! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
list: t1 
	list := t1! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
model: t1 
	model := t1! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
renderOn: t1 
	| t2 |
	t2 := (model perform: list) asArray.
	t1
		divClass: 'column-choice'
		with: [t1
				form: [t1 attributeAt: 'size' put: size.
					t1 attributeAt: 'onChange' put: 'submit()'.
					t1
						selectFromList: t2
						selected: (t2
								at: (model perform: selected)
								ifAbsent: [])
						callback: [:t3 | model
								perform: changeSelected
								with: (t2 indexOf: t3)]]]! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
selected: t1 
	selected := t1! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: ''!
size: t1 
	size := t1! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: ''!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: ''!
batch
	^ items
		select: [:t1 | t1 asString asUppercase first = self currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: ''!
currentPage
	^ currentPage
		ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: ''!
currentPage: t1 
	currentPage := t1! !

!WAAlphabeticBatchedList methodsFor: 'initialization' stamp: ''!
initialize
	self session registerObjectForBacktracking: self! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: ''!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: ''!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: ''!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: ''!
items: t1 
	items := t1! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: ''!
nextPage
	self isOnLastPage
		ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: ''!
previousPage
	self isOnFirstPage
		ifFalse: [currentPage := self validPages before: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	items isEmpty
		ifFalse: [t1
				divNamed: 'batch'
				with: [self renderPreviousOn: t1.
					self renderPagesOn: t1.
					self renderNextOn: t1]]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: ''!
renderNextOn: t1 
	t1 space.
	self isOnLastPage
		ifTrue: [t1 text: '>>']
		ifFalse: [t1
				anchorWithAction: [self nextPage]
				text: '>>']! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: ''!
renderPagesOn: t1 
	self allPages
		do: [:t2 | currentPage = t2
				ifTrue: [t1 bold: t2]
				ifFalse: [(self validPages includes: t2)
						ifTrue: [t1
								anchorWithAction: [self currentPage: t2]
								text: t2]
						ifFalse: [t1 text: t2]]]
		separatedBy: [t1 space]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: ''!
renderPreviousOn: t1 
	self isOnFirstPage
		ifTrue: [t1 text: '<<']
		ifFalse: [t1
				anchorWithAction: [self previousPage]
				text: '<<'].
	t1 space! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: ''!
validPages
	^ (items
		collect: [:t1 | t1 asString asUppercase first]) asSet asSortedCollection! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WABatchedList class methodsFor: 'as yet unclassified' stamp: ''!
example
	^ self new
		items: (1 to: 100);
		 yourself! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
batch
	^ items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
batchSize: t1 
	batchSize := t1! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
currentPage: t1 
	currentPage := t1! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
endIndex
	^ currentPage * batchSize min: items size! !

!WABatchedList methodsFor: 'initialization' stamp: ''!
initialize
	batchSize := 10.
	currentPage := 1.
	self session registerObjectForBacktracking: self! !

!WABatchedList methodsFor: 'testing' stamp: ''!
isOnFirstPage
	^ currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: ''!
isOnLastPage
	^ currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: ''!
items: t1 
	items := t1! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
maxPages
	^ (items size / batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: ''!
nextPage
	self isOnLastPage
		ifFalse: [currentPage := currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: ''!
previousPage
	self isOnFirstPage
		ifFalse: [currentPage := currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	self maxPages > 0
		ifTrue: [t1
				divNamed: 'batch'
				with: [self renderPreviousOn: t1.
					self renderPagesOn: t1.
					self renderNextOn: t1]]! !

!WABatchedList methodsFor: 'rendering' stamp: ''!
renderNextOn: t1 
	t1 space.
	self isOnLastPage
		ifTrue: [t1 text: '>>']
		ifFalse: [t1
				anchorWithAction: [self nextPage]
				text: '>>']! !

!WABatchedList methodsFor: 'rendering' stamp: ''!
renderPagesOn: t1 
	self pageRange
		do: [:t2 | currentPage = t2
				ifTrue: [t1 bold: t2]
				ifFalse: [t1
						anchorWithAction: [self currentPage: t2]
						text: t2]]
		separatedBy: [t1 space]! !

!WABatchedList methodsFor: 'rendering' stamp: ''!
renderPreviousOn: t1 
	self isOnFirstPage
		ifTrue: [t1 text: '<<']
		ifFalse: [t1
				anchorWithAction: [self previousPage]
				text: '<<'].
	t1 space! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: ''!
startIndex
	^ currentPage - 1 * batchSize + 1! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WABatchSelection class methodsFor: 'as yet unclassified' stamp: ''!
items: t1 link: t2 text: t3 
	^ self new items: t1;
		 linkSelector: t2;
		 textSelector: t3! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
choose: t1 
	self answer: t1! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
items: t1 
	batcher := WABatchedList new items: t1;
				 batchSize: 8! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
linkSelector: t1 
	linkSelector := t1! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		list: batcher batch
		do: [:t2 | 
			t1
				anchorWithAction: [self choose: t2]
				text: (t2 perform: linkSelector).
			t1 break;
				text: (t2 perform: textSelector).
			t1 paragraph].
	t1 attributes alignCenter.
	t1 div: batcher! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: ''!
textSelector: t1 
	textSelector := t1! !

WAComponent subclass: #WABatchTest
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WABatchTest methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: batcher! !

!WABatchTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	batcher := WAAlphabeticBatchedList new items: Collection allSubclasses! !

!WABatchTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 render: batcher.
	t1 list: batcher batch! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WABrowser class methodsFor: 'as yet unclassified' stamp: ''!
fullOnClass: t1 
	^ self new
		model: (Browser new setClass: t1 selector: nil)! !

!WABrowser methodsFor: 'actions' stamp: ''!
accept
	| t1 |
	SeasidePlatformSupport
		ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	t1 := contents.
	model contents: contents notifying: self.
	contents := t1! !

!WABrowser methodsFor: 'rendering' stamp: ''!
columnView: t1 
	^ WAPluggableSelectBox
		on: model
		list: (t1 , 'List') asSymbol
		selected: (t1 , 'ListIndex') asSymbol
		changeSelected: (t1 , 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: ''!
contents
	^ contents! !

!WABrowser methodsFor: 'accessing' stamp: ''!
contents: t1 
	contents := t1! !

!WABrowser methodsFor: 'accessing' stamp: ''!
initialize
	self model: Browser new! !

!WABrowser methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!WABrowser methodsFor: 'accessing' stamp: ''!
model: t1 
	model := t1.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents := model contents! !

!WABrowser methodsFor: 'notifying' stamp: ''!
notify: t1 at: t2 in: t3 
	message := t1 allButLast: 3! !

!WABrowser methodsFor: 'rendering' stamp: ''!
renderColumnsOn: t1 
	| t2 |
	t2 := #(#systemCategory #class #messageCategory #message )
				collect: [:t3 | self columnView: t3].
	t1
		table: [t1
				tableRow: [t2
						do: [:t4 | t1
								tableData: [t1 render: t4]]]]! !

!WABrowser methodsFor: 'accessing' stamp: ''!
renderContentOn: t1 
	self renderColumnsOn: t1;
		 renderModeButtonsOn: t1;
		 renderMessageOn: t1;
		 renderContentPaneOn: t1! !

!WABrowser methodsFor: 'accessing' stamp: ''!
renderContentPaneOn: t1 
	t1
		form: [t1 textAreaOn: #contents of: self;
				 break;
				 submitButtonOn: #accept of: self]! !

!WABrowser methodsFor: 'rendering' stamp: ''!
renderMessageOn: t1 
	message
		ifNotNil: [t1 bold: message]! !

!WABrowser methodsFor: 'rendering' stamp: ''!
renderModeButtonsOn: t1 
	t1
		form: [t1
				submitButtonWithAction: [self showInstance]
				text: 'instance';
				
				submitButtonWithAction: [self showHelp]
				text: 'help';
				
				submitButtonWithAction: [self showClass]
				text: 'class']! !

!WABrowser methodsFor: 'notifying' stamp: ''!
select
	^ self! !

!WABrowser methodsFor: 'notifying' stamp: ''!
selectFrom: t1 to: t2 
	^ self! !

!WABrowser methodsFor: 'notifying' stamp: ''!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'accessing' stamp: ''!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'accessing' stamp: ''!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'accessing' stamp: ''!
showInstance
	self model indicateInstanceMessages! !

!WABrowser methodsFor: 'rendering' stamp: ''!
style
	^ '

	#contents {width: 100%; height: 300px; font-family: serif; font-size: 14pt}

	'! !

!WABrowser methodsFor: 'notifying' stamp: ''!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'actions' stamp: ''!
update: t1 
	contents := model contents! !

WAComponent subclass: #WACacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACacheTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	Smalltalk garbageCollect.
	t1 heading: ResponseContinuation allInstances size.
	t1 heading: AnswerContinuation allInstances size.
	t1 heading: EscapeContinuation allInstances size.
	t1
		anchorWithAction: [self inform: 'answer']
		text: 'call'.
	t1 break.
	t1
		anchorWithAction: [self call: self class new]
		text: 'keep calling'! !

WAComponent subclass: #WACallbackTest
	instanceVariableNames: 'transcript counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACallbackTest methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: counter! !

!WACallbackTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	transcript := String new writeStream.
	counter := WACounter new! !

!WACallbackTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithCallback: []
		do: 'Idempotent'.
	t1 space.
	t1
		anchorWithAction: []
		do: 'Side Effect'.
	t1
		form: [t1
				defaultAction: [transcript cr; nextPutAll: 'default action'].
			t1
				textInputWithValue: ''
				callback: [:t2 | transcript cr; nextPutAll: 'text: ' , t2 printString].
			t1
				textInputWithValue: ''
				callback: [:t2 | transcript cr; nextPutAll: 'text2: ' , t2 printString].
			t1 break.
			t1 submitButton.
			t1 space.
			t1
				submitButtonWithAction: [transcript cr; nextPutAll: 'go']
				text: 'Go'.
			t1 space.
			t1
				cancelButtonWithAction: [transcript cr; nextPutAll: 'cancel']].
	t1 preformatted: transcript contents.
	t1 horizontalRule.
	t1 render: counter! !

WAComponent subclass: #WACanvasTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasTest methodsFor: 'as yet unclassified' stamp: ''!
decrease
	count := count - 1! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: ''!
increase
	count := count + 1! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	count := 0! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 div style: 'background-color: lightblue';
		
		with: [t1 text: count;
				 break.
			t1 anchor
				callback: [self increase];
				 with: '++'.
			t1 space.
			t1 anchor
				callback: [self decrease];
				 with: '--']! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: ''!
rendererClass
	^ WARenderCanvas! !

WAComponent subclass: #WAChangePassword
	instanceVariableNames: 'username password confirmation authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChangePassword methodsFor: 'as yet unclassified' stamp: ''!
authenticator: t1 
	authenticator := t1! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: false! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: ''!
changePassword
	password = confirmation
		ifFalse: [^ self inform: 'Sorry, the password and confirmation did not match.'].
	authenticator setPassword: password forUser: username.
	self answer: true! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				table: [t1 tableRowWithLabel: 'Username' column: username.
					t1
						tableRowWithLabel: 'Password'
						column: [t1
								passwordInputWithCallback: [:t2 | password := t2]].
					t1
						tableRowWithLabel: 'Confirm Password'
						column: [t1
								passwordInputWithCallback: [:t2 | confirmation := t2]].
					t1 spacerRow.
					t1 attributes alignCenter.
					t1
						tableRowWith: [t1 submitButtonOn: #changePassword of: self.
							t1 space.
							t1 submitButtonOn: #cancel of: self]
						span: 2]]! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: ''!
username: t1 
	username := t1! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAClosureTest methodsFor: 'as yet unclassified' stamp: ''!
ensure
	[self go]
		ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: ''!
go
	| t1 |
	t1 := 1.
	#(#a #b #c )
		do: [:t2 | 
			self inform: t2 asString , ' ' , t1 asString.
			t1 := t1 + 1]! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [self go]
		text: 'go'.
	t1 space.
	t1
		anchorWithAction: [self ensure]
		text: 'go with ensure'! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: ''!
applicationWithPath: t1 
	| t2 |
	t2 := WAApplication path: t1.
	t2 configuration addAncestor: WARenderLoopConfiguration localConfiguration.
	t2 preferenceAt: #rootComponent put: self.
	^ t2! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ false! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initializeDecoration initialize! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: ''!
registerAsApplication: t1 
	| t2 |
	t2 := self applicationWithPath: t1.
	WADispatcher default registerEntryPoint: t2 at: t1.
	^ t2! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: ''!
registerAsAuthenticatedApplication: t1 
	| t2 t3 t4 |
	t2 := self registerAsApplication: t1.
	t2 configuration addAncestor: WAAuthConfiguration localConfiguration.
	[t3 := FillInTheBlank request: ('Please choose an administrator\username for the application ''' , t1 asString , '''') withCRs.
	t3 = ''] whileTrue.
	[t4 := FillInTheBlank request: 'Please enter a password for ' , t3 printString.
	t4 = ''] whileTrue.
	t2 preferenceAt: #login put: t3.
	t2 preferenceAt: #password put: t4.
	^ t2! !

!WAComponent methodsFor: 'convenience' stamp: ''!
activeComponent
	self
		visiblePresentersDo: [:t1 | t1 isDecoration
				ifFalse: [^ t1]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
addDecoration: t1 
	| t2 t3 |
	t2 := nil.
	t3 := self decoration.
	[t3 ~~ self
		and: [self decoration: t3 shouldWrap: t1]]
		whileTrue: [t2 := t3.
			t3 := t3 owner].
	t1 owner: t3.
	t2
		ifNil: [self decoration: t1]
		ifNotNil: [t2 owner: t1].
	^ t1! !

!WAComponent methodsFor: 'convenience' stamp: ''!
addMessage: t1 
	self
		addDecoration: (WAMessageDecoration new message: t1)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
allDecorationsDo: t1 
	| t2 |
	t2 := self decoration.
	[t2 notNil
		and: [t2 ~~ self]]
		whileTrue: [t1 value: t2.
			t2 := t2 owner]! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
answer: t1 
	self
		decorationChainDo: [:t2 | t2 handleAnswer: t1]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
authenticateWith: t1 during: t2 
	^ self
		decorateWith: (WABasicAuthentication new authenticator: t1)
		during: t2! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
call: t1 
	^ AnswerContinuation
		currentDo: [:t2 | self show: t1 onAnswer: t2]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
children
	^ #()! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
childrenDo: t1 
	self children
		do: [:t2 | t2
				ifNotNil: [t1 value: t2]]! !

!WAComponent methodsFor: 'convenience' stamp: ''!
confirm: t1 
	^ self
		call: (WAYesOrNoDialog new addMessage: t1)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
decorateWith: t1 during: t2 
	| t3 |
	self addDecoration: t1.
	t3 := t2 value.
	self removeDecoration: t1.
	^ t3! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
decoration
	decoration
		ifNil: [decoration := WAStateHolder new contents: self].
	^ decoration contents! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
decorationChainDo: t1 
	t1 value: self decoration! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
decoration: t1 
	decoration contents: t1! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
decoration: t1 shouldWrap: t2 
	^ (t1 isGlobal
			and: [t2 isGlobal not])
		or: [t1 isDelegation
				and: [t2 isLocal]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
delegations
	| t1 |
	t1 := OrderedCollection new.
	self
		allDecorationsDo: [:t2 | t2 isDelegation
				ifTrue: [t1 add: t2]].
	^ t1! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
handleAnswer: t1 
	^ false! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
home
	self delegations
		do: [:t1 | self removeDecoration: t1]! !

!WAComponent methodsFor: 'convenience' stamp: ''!
inform: t1 
	self
		call: (WAFormDialog new addMessage: t1)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
initializeDecoration
	decoration := WAStateHolder new contents: self! !

!WAComponent methodsFor: 'convenience' stamp: ''!
isolate: t1 
	| t2 t3 |
	t2 := WATransaction new.
	t3 := self decorateWith: t2 during: t1.
	t2 close.
	^ t3! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
nextPresentersDo: t1 
	self
		childrenDo: [:t2 | t2 decorationChainDo: t1]! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
onAnswer: t1 
	^ self
		addDecoration: (WAAnswerHandler new block: t1)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
removeDecoration: t1 
	| t2 |
	t2 := self decoration.
	t2 = t1
		ifTrue: [self decoration: t2 owner.
			^ self].
	[t2 notNil]
		whileTrue: [t2 owner = t1
				ifTrue: [t2 owner: t1 owner.
					^ self].
			t2 := t2 owner]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
renderOn: t1 
	self
		decorationChainDo: [:t2 | t2 renderWithContext: t1 context]! !

!WAComponent methodsFor: 'convenience' stamp: ''!
request: t1 
	^ self request: t1 default: ''! !

!WAComponent methodsFor: 'convenience' stamp: ''!
request: t1 default: t2 
	^ self
		request: t1
		label: nil
		default: t2! !

!WAComponent methodsFor: 'convenience' stamp: ''!
request: t1 label: t2 
	^ self
		request: t1
		label: t2
		default: ''! !

!WAComponent methodsFor: 'convenience' stamp: ''!
request: t1 label: t2 default: t3 
	^ self
		call: ((WAInputDialog new label: t2;
				 default: t3) addMessage: t1)! !

!WAComponent methodsFor: 'rendering' stamp: ''!
script
	^ nil! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
show: t1 
	self
		show: t1
		onAnswer: [:t2 | t2]! !

!WAComponent methodsFor: 'call/answer' stamp: ''!
show: t1 onAnswer: t2 
	| t3 t4 |
	t3 := WADelegation new delegate: t1.
	t4 := nil.
	t4 := t1
				onAnswer: [:t5 | 
					t3 remove.
					t4 remove.
					t2 value: t5].
	self addDecoration: t3.
	WARenderNotification raiseSignal! !

!WAComponent methodsFor: 'rendering' stamp: ''!
style
	^ nil! !

!WAComponent methodsFor: 'convenience' stamp: ''!
validateWith: t1 
	self
		addDecoration: (WAValidationDecoration new validateWith: t1)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: ''!
visiblePresentersDo: t1 
	self
		decorationChainDo: [:t2 | t2 withNextPresentersDo: t1]! !

WAComponent subclass: #WAConfigurationBrowser
	instanceVariableNames: 'pool editors selection trail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
addConfiguration: t1 
	| t2 |
	t2 := WAUserConfiguration named: t1.
	pool add: t2.
	self select: t2! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: trail with: selection! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
deleteConfiguration
	(self confirm: 'Are you sure you want to delete ' , self selectedConfiguration name printString , '?')
		ifTrue: [pool remove: self selectedConfiguration].
	selection := trail := nil! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
editorFor: t1 
	^ editors
		at: t1
		ifAbsentPut: [WAConfigurationEditor new configuration: t1;
				
				onAnswer: [:t2 | self answer];
				 yourself]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
initialize
	editors := Dictionary new! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
pool: t1 
	pool := t1! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				selectFromList: pool configurations
				selected: self selectedConfiguration
				callback: [:t2 | self select: t2]
				labels: [:t3 | t3 name].
			t1 space.
			t1 submitButtonWithText: 'Go'].
	t1
		form: [t1 text: 'New configuration: '.
			t1
				textInputWithValue: ''
				callback: [:t2 | self addConfiguration: t2].
			t1 space.
			t1 submitButtonWithText: 'Add'].
	selection
		ifNotNil: [t1 render: trail.
			t1 horizontalRule.
			self selectedConfiguration isDeletable
				ifTrue: [t1
						paragraph: [t1
								anchorWithAction: [self deleteConfiguration]
								text: 'Delete']].
			t1 render: selection]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
selectedConfiguration
	^ selection
		ifNotNil: [selection configuration]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: ''!
select: t1 
	selection := self editorFor: t1.
	trail := WATrail on: selection! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAConfigurationEditor subclass: #WAApplicationEditor
	instanceVariableNames: 'application library'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAApplicationEditor methodsFor: 'rendering' stamp: ''!
addLibrary
	application libraries add: library! !

!WAApplicationEditor methodsFor: 'rendering' stamp: ''!
allLibraries
	^ WAStyleLibrary subclasses , WAScriptLibrary subclasses! !

!WAApplicationEditor methodsFor: 'accessing' stamp: ''!
application: t1 
	application := t1.
	configuration := application configuration! !

!WAApplicationEditor methodsFor: 'rendering' stamp: ''!
libraryOptions
	^ self allLibraries difference: application libraries! !

!WAApplicationEditor methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1 heading: 'Application: ' , application name.
	super renderContentOn: t1! !

!WAApplicationEditor methodsFor: 'rendering' stamp: ''!
renderFormOn: t1 
	t1 text: 'Base Path: '.
	t1 textInputOn: #basePath of: application.
	t1 heading: 'Libraries' level: 2.
	self libraryOptions isEmpty
		ifFalse: [t1 text: 'Add Library: '.
			t1
				selectFromList: self libraryOptions
				selected: nil
				callback: [:t2 | library := t2].
			t1 space.
			t1
				submitButtonWithAction: [self addLibrary]
				text: 'Add'].
	t1
		list: application libraries
		do: [:t3 | 
			t1 text: t3.
			t1 space.
			t1
				anchorWithAction: [application libraries remove: t3]
				text: '(remove)'].
	super renderFormOn: t1! !

!WAApplicationEditor methodsFor: 'actions' stamp: ''!
select: t1 
	self call: (WAConfigurationBrowser new pool: WASystemConfigurationPool default;
			 select: t1;
			 yourself)! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: ''!
configuration
	^ configuration! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: ''!
configuration: t1 
	configuration := t1! !

!WAConfigurationEditor methodsFor: 'actions' stamp: ''!
done
	self answer! !

!WAConfigurationEditor methodsFor: 'initialization' stamp: ''!
initialize
	configuration := WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderAncestryListFor: t1 seen: t2 on: t3 
	t1 ancestors isEmpty
		ifTrue: [^ self].
	t3
		list: t1 ancestors
		do: [:t4 | 
			self renderParent: t4 on: t3.
			(t2 includes: t4)
				ifFalse: [t2 add: t4.
					self
						renderAncestryListFor: t4
						seen: t2
						on: t3]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderAncestryOn: t1 
	t1 attributes style: 'border: 1px solid black; background: lightgrey'.
	t1
		div: [t1
				table: [t1 heading: 'Configuration Ancestors' level: 2.
					configuration potentialAncestors isEmpty
						ifFalse: [t1 text: 'Add ancestor: '.
							self renderParentSelectorOn: t1].
					self
						renderAncestryListFor: configuration
						seen: Set new
						on: t1]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderAttribute: t1 on: t2 
	t2
		tableRow: [t2
				tableData: (self labelForSelector: t1 key).
			t2
				tableData: [(configuration valueForAttribute: t1)
						ifNil: [self renderUnspecifiedAttribute: t1 on: t2]
						ifNotNil: [(configuration hasLocalValueForAttribute: t1)
								ifTrue: [self renderOverridenAttribute: t1 on: t2]
								ifFalse: [self renderInheritedAttribute: t1 on: t2]]].
			self renderInheritanceForAttribute: t1 on: t2]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1
		form: [self renderFormOn: t1.
			t1 break.
			t1 submitButtonOn: #save of: self.
			t1 submitButtonOn: #done of: self]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderFormOn: t1 
	self renderAncestryOn: t1.
	t1 break.
	t1 attributes style: 'border: 1px solid black'.
	t1
		div: [t1
				table: [configuration groupedAttributes
						do: [:t2 | 
							t1
								tableRowWith: [t1
										heading: (self labelForSelector: t2 key)
										level: 3]
								span: 2.
							t2 value
								do: [:t3 | self renderAttribute: t3 on: t1]]]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderInheritanceForAttribute: t1 on: t2 
	configuration
		inheritedValueAndSourceAt: t1 key
		do: [:t3 :t4 | 
			(configuration hasLocalValueForAttribute: t1)
				ifTrue: [t2
						tableData: [t2
								anchorWithAction: [configuration clearValueForAttribute: t1]
								text: 'revert'.
							t2 text: ' to: ' , t3 printString].
					t2
						tableData: [t2 text: 'overriden from ' , t4 name]]
				ifFalse: [t2
						tableData: [t2
								anchorWithAction: [configuration overrideAttribute: t1]
								text: 'override'].
					t2
						tableData: [t2 text: 'inherited from ' , t4 name]].
			^ self].
	(configuration hasLocalValueForAttribute: t1)
		ifTrue: [t2
				tableData: [t2
						anchorWithAction: [configuration clearValueForAttribute: t1]
						text: 'clear']]
		ifFalse: [t2
				tableData: [t2 attributes style: 'color: #ff0000'.
					t2
						span: [t2 text: '(unspecified)']]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderInheritedAttribute: t1 on: t2 
	t2 text: (configuration valueForAttribute: t1) printString! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderInheritedValueForAttribute: t1 on: t2 
	| t3 |
	t3 := configuration lookupValueAt: t1 key.
	t3
		ifNil: [t2 attributes style: 'color: #ff0000'.
			t2
				span: [t2 text: '(unspecified)']]
		ifNotNil: [t2 text: t3 printString]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderLinkToAncestor: t1 on: t2 
	t2 text: t1! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderOverrideForAttribute: t1 on: t2 
	t2
		anchorWithAction: [configuration overrideAttribute: t1]
		text: 'edit'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderOverridenAttribute: t1 on: t2 
	t1 accept: self with: t2! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderParentSelectorOn: t1 
	| t2 |
	t2 := ValueHolder new.
	t1
		selectFromList: configuration potentialAncestors
		selected: nil
		callback: [:t3 | t2 contents: t3]
		labels: [:t4 | t4 name].
	t1
		submitButtonWithAction: [configuration addAncestor: t2 contents]
		text: 'Add'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderParent: t1 on: t2 
	t1 isMutable
		ifTrue: [t2
				anchorWithAction: [self select: t1]
				text: t1 name]
		ifFalse: [t2 text: t1 name].
	t2 space.
	(configuration hasMutableAncestry
			and: [configuration ancestors includes: t1])
		ifTrue: [t2
				anchorWithAction: [configuration removeAncestor: t1]
				text: '(remove)']! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderRevertForAttribute: t1 on: t2 
	t2
		anchorWithAction: [configuration clearValueForAttribute: t1]
		text: 'clear'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: ''!
renderUnspecifiedAttribute: t1 on: t2 
	t1 accept: self with: t2! !

!WAConfigurationEditor methodsFor: 'actions' stamp: ''!
save
	^ self! !

!WAConfigurationEditor methodsFor: 'actions' stamp: ''!
select: t1 
	self
		call: (WAConfigurationEditor new configuration: t1)! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: ''!
trailName
	^ configuration name! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: ''!
visitBooleanAttribute: t1 with: t2 
	t2
		booleanMenuWithValue: (configuration valueForAttribute: t1)
		callback: [:t3 | configuration takeValue: t3 forAttribute: t1]
		labels: ((Array new: 2) at: 1 put: true; at: 2 put: false; yourself)! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: ''!
visitListAttribute: t1 with: t2 
	t2
		selectFromList: (Array with: nil)
				, t1 options asArray
		selected: (configuration valueForAttribute: t1)
		callback: [:t3 | configuration takeValue: t3 forAttribute: t1]
		labels: [:t4 | t4
				ifNil: ['None']
				ifNotNil: [t4 asString]]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: ''!
visitNumberAttribute: t1 with: t2 
	t2 attributes size: 5.
	t2
		textInputWithValue: (configuration valueForAttribute: t1)
		callback: [:t3 | configuration takeValue: t3 asNumber forAttribute: t1]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: ''!
visitPasswordAttribute: t1 with: t2 
	t2
		passwordInputWithCallback: [:t3 | configuration takeValue: t3 forAttribute: t1]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: ''!
visitStringAttribute: t1 with: t2 
	t2
		textInputWithValue: (configuration valueForAttribute: t1)
		callback: [:t3 | configuration takeValue: t3 forAttribute: t1]! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACounter class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WACounter class methodsFor: 'as yet unclassified' stamp: ''!
example
	^ self new! !

!WACounter class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self registerAsApplication: 'counter'! !

!WACounter methodsFor: 'as yet unclassified' stamp: ''!
count
	^ count! !

!WACounter methodsFor: 'as yet unclassified' stamp: ''!
decrease
	count := count - 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: ''!
increase
	count := count + 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self session registerObjectForBacktracking: self.
	count := 0! !

!WACounter methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: count.
	t1
		anchorWithAction: [self increase]
		text: '++'.
	t1 space.
	t1
		anchorWithAction: [self decrease]
		text: '--'! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
date
	(self
			privateIsValidDay: day
			monthNumber: month
			year: year)
		ifFalse: [self error: 'Invalid date'].
	^ Date
		newDay: day
		monthNumber: month
		year: year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
dateIsValid
	[self date]
		on: Error
		do: [:t1 | ^ false].
	^ true! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
date: t1 
	day := t1 dayOfMonth.
	month := t1 monthIndex.
	year := t1 year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
endYear: t1 
	endYear := t1! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
initialize
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: Date today! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
labelForDay: t1 
	^ t1! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
labelForMonth: t1 
	^ Date nameOfMonth: t1! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
labelForYear: t1 
	^ t1! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
privateIsValidDay: t1 monthNumber: t2 year: t3 
	| t4 |
	t2 >= 0 & (t2 < 12)
		ifFalse: [^ false].
	t4 := Month daysInMonth: t2 forYear: t3.
	^ t1 > 0 & (t1 <= t4)! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		selectFromList: self months
		selected: month
		callback: [:t2 | month := t2]
		labels: [:t3 | self labelForMonth: t3].
	t1
		selectFromList: self days
		selected: day
		callback: [:t2 | day := t2]
		labels: [:t3 | self labelForDay: t3].
	t1
		selectFromList: self yearRange
		selected: year
		callback: [:t2 | year := t2]
		labels: [:t3 | self labelForYear: t3].
	self dateIsValid
		ifFalse: [self renderValidationErrorOn: t1]! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
renderValidationErrorOn: t1 
	t1 spanClass: 'error' with: 'invalid date'! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
startYear: t1 
	startYear := t1! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: ''!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
datesDo: t1 separatedBy: t2 
	| t3 |
	t3 := datesCache first monthIndex.
	datesCache
		do: [:t4 | 
			t4 monthIndex = t3
				ifFalse: [t3 := t4 monthIndex.
					t2 value].
			t1 value: t4].
	t2 value! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
endDate: t1 
	endDate := t1.
	self updateDatesCache! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
monthsAndLengthsDo: t1 
	| t2 t3 |
	t2 := 0.
	self
		datesDo: [:t4 | 
			t2 := t2 + 1.
			t3 := t4]
		separatedBy: [t1 value: t3 month value: t2.
			t2 := 0]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderCellForDate: t1 row: t2 index: t3 on: t4 
	t4
		tableData: [t4 space]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 attributes border: 1.
	t1 cssClass: 'DateTable';
		
		table: [t1
				tableRow: [self renderMonthHeadingsOn: t1].
			t1
				tableRow: [self renderDayHeadingsOn: t1].
			rows
				withIndexDo: [:t2 :t3 | t1
						tableRow: [self
								renderRow: t2
								index: t3
								on: t1]]]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderDayHeadingsOn: t1 
	self renderHeadingSpacerOn: t1.
	self
		datesDo: [:t2 | t1 cssClass: 'DayHeading';
				
				tableHeading: [t1 text: t2 dayOfMonth]]
		separatedBy: [self renderHeadingSpacerOn: t1]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderHeadingForRow: t1 on: t2 
	t2 cssClass: 'RowHeading';
		
		tableHeading: [t2 text: t1]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderHeadingSpacerOn: t1 
	t1
		tableData: []! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderMonthHeadingsOn: t1 
	self
		monthsAndLengthsDo: [:t2 :t3 | 
			self renderHeadingSpacerOn: t1.
			t1 cssClass: 'MonthHeading';
				 attributeAt: 'colspan' put: t3;
				
				tableHeading: [t1 text: t2 name;
						 space;
						 text: t2 year]]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
renderRow: t1 index: t2 on: t3 
	self renderHeadingForRow: t1 on: t3.
	self
		datesDo: [:t4 | self
				renderCellForDate: t4
				row: t1
				index: t2
				on: t3]
		separatedBy: [self renderHeadingSpacerOn: t3]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
rows: t1 
	rows := t1! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
startDate: t1 
	startDate := t1.
	self updateDatesCache! !

!WADateTable methodsFor: 'as yet unclassified' stamp: ''!
updateDatesCache
	| t1 |
	(startDate isNil
			or: [endDate isNil])
		ifTrue: [^ self].
	datesCache := OrderedCollection new.
	t1 := startDate.
	[t1 > endDate]
		whileFalse: [datesCache add: t1.
			t1 := t1 next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
colorForDate: t1 rowIndex: t2 
	^ (self hasSelection
			and: [self selectionContainsDate: t1 rowIndex: t2])
		ifTrue: ['lightgrey']
		ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
endDateSelection
	^ dateSelectionStart
		ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
endDate: t1 
	self clearSelection.
	super endDate: t1! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
endRowSelection
	^ rowSelectionStart
		ifNotNil: [rows
				at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
renderCellForDate: t1 row: t2 index: t3 on: t4 
	| t5 |
	t4
		attributeAt: 'bgcolor'
		put: (self colorForDate: t1 rowIndex: t3).
	t4 attributeAt: 'align' put: 'center'.
	t4
		tableData: [t5 := cellBlock value: t2 value: t1.
			t4
				anchorWithAction: [self selectDate: t1 rowIndex: t3]
				text: t5]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
rowsAndDatesDisplay: t1 
	cellBlock := t1! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
rows: t1 
	self clearSelection.
	super rows: t1! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
selectDate: t1 rowIndex: t2 
	self hasSelection
		ifTrue: [dateSelectionEnd := t1.
			rowSelectionEnd := t2]
		ifFalse: [dateSelectionStart := dateSelectionEnd := t1.
			rowSelectionStart := rowSelectionEnd := t2]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
selectionContainsDate: t1 rowIndex: t2 
	^ ((t1 between: dateSelectionStart and: dateSelectionEnd)
			or: [t1 between: dateSelectionEnd and: dateSelectionStart])
		and: [(t2 between: rowSelectionStart and: rowSelectionEnd)
				or: [t2 between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
startDateSelection
	^ dateSelectionStart
		ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
startDate: t1 
	self clearSelection.
	super startDate: t1! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
startRowSelection
	^ rowSelectionStart
		ifNotNil: [rows
				at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: ''!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADefaultFormTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		formWithDefaultAction: [self inform: 'Default: ' , value asString]
		do: [t1
				submitButtonWithAction: [self inform: 'Before']
				text: 'Before'.
			t1 break.
			t1
				textInputWithValue: ''
				callback: [:t2 | value := t2].
			t1 break.
			t1
				submitButtonWithAction: [self inform: 'After']
				text: 'After']! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor methodsFor: 'actions' stamp: ''!
addEntryPoint
	| t1 |
	path isEmpty
		ifTrue: [^ self inform: 'You must enter a path.'].
	t1 := type new.
	dispatcher registerEntryPoint: t1 at: path.
	self configure: t1! !

!WADispatcherEditor methodsFor: 'actions' stamp: ''!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'actions' stamp: ''!
configure: t1 
	t1 configurationComponent
		ifNotNilDo: [:t2 | self call: t2]! !

!WADispatcherEditor methodsFor: 'accessing' stamp: ''!
dispatcher: t1 
	dispatcher := t1! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: ''!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'initialization' stamp: ''!
initialize
	dispatcher := WADispatcher default.
	type := WAApplication.
	path := ''! !

!WADispatcherEditor methodsFor: 'actions' stamp: ''!
remove: t1 
	dispatcher removeEntryPoint: t1! !

!WADispatcherEditor methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1 heading: 'Squeak Enterprise Aubergines Server'.
	t1 bold: dispatcher basePath.
	t1
		form: [t1
				table: [dispatcher entryPoints keysSortedSafely
						do: [:t2 | self
								renderRowForEntryPoint: (dispatcher entryPoints at: t2)
								named: t2
								on: t1]]].
	t1 paragraph.
	t1 bold: 'add entry point: '.
	t1
		form: [t1
				table: [t1
						tableRowWithLabel: 'Path:'
						column: [t1
								textInputWithValue: ''
								callback: [:t3 | path := t3]].
					t1
						tableRowWithLabel: 'Type:'
						column: [t1
								selectFromList: self entryPointClasses
								selected: type
								callback: [:t4 | type := t4]
								labels: [:t5 | t5 description].
							t1 space.
							t1
								submitButtonWithAction: [self addEntryPoint]
								text: 'Add']]].
	t1
		anchorWithAction: [self
				call: (WAConfigurationBrowser new pool: WASystemConfigurationPool default)]
		text: 'Edit Configurations'.
	t1 preformatted: SeasidePlatformSupport vmStatisticsReportString.
	t1
		anchorWithAction: [self clearCaches]
		text: 'Clear Caches'! !

!WADispatcherEditor methodsFor: 'rendering' stamp: ''!
renderRowForEntryPoint: t1 named: t2 on: t3 
	t3
		tableRowWith: [t3 anchorWithUrl: t1 basePath do: t2]
		with: [t3
				anchorWithAction: [self configure: t1]
				text: 'configure'.
			t3 space;
				anchorWithAction: [self remove: t1]
				text: 'remove']! !

!WADispatcherEditor methodsFor: 'actions' stamp: ''!
verifyPassword: t1 forUser: t2 
	^ t2 = 'fooz'
		and: [t1 = 'bar']! !

WAComponent subclass: #WAEmailConfirmation
	instanceVariableNames: 'from to subject body notice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
body: t1 
	body := t1! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
from: t1 
	from := t1! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
notice: t1 
	notice := t1! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 |
	t2 := t1
				urlForAction: [self answer].
	self sendMessageWithUrl: t2.
	t1 divClass: 'notice' with: notice! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
sendMessageWithUrl: t1 
	SeasidePlatformSupport
		deliverMailFrom: from
		to: (Array with: to)
		text: t1 , '
		
' , body! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
subject: t1 
	subject := t1! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: ''!
to: t1 
	to := t1! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAEncodingTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 t3 t4 |
	t2 := WriteStream on: String new.
	32
		to: 255
		do: [:t5 | t2 nextPut: t5 asCharacter].
	t3 := t2 contents.
	t1
		code: [t1 text: 'Start';
				 break.
			t4 := ReadStream on: t3.
			[t4 atEnd]
				whileFalse: [t1
						text: (t4 next: 14);
						 break].
			t1 text: 'End';
				 break].
	t1 text: 'Characters Encoded: '.
	'Hello World'
		do: [:t5 | t1 encodeCharacter: t5].
	t1 break! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAErrorTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [1 / 0]
		text: 'Raise error'.
	t1 break.
	t1
		anchorWithAction: [self notify: 'Really?'.
			self inform: 'Ok!!']
		text: 'Raise warning'! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self registerAsApplication: 'examplebrowser'! !

!WAExampleBrowser methodsFor: 'helper' stamp: ''!
allClasses
	^ (WAComponent allSubclasses
		select: [:t1 | t1 class selectors
				anySatisfy: [:t2 | t2 beginsWith: self selectorPrefix]])
		asSortedCollection: [:t3 :t4 | t3 name < t4 name]! !

!WAExampleBrowser methodsFor: 'helper' stamp: ''!
allSelectors
	^ (class class selectors
		select: [:t1 | t1 beginsWith: self selectorPrefix]) asSortedCollection! !

!WAExampleBrowser methodsFor: 'accessing' stamp: ''!
children
	^ Array with: component! !

!WAExampleBrowser methodsFor: 'accessing' stamp: ''!
class: t1 
	class := t1.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'accessing' stamp: ''!
component: t1 
	component := t1.
	hasAnswer := false.
	answer := nil.
	component
		onAnswer: [:t2 | 
			hasAnswer := true.
			answer := t2]! !

!WAExampleBrowser methodsFor: 'initialize' stamp: ''!
initialize
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1 cssId: 'test-forms';
		
		table: [t1
				tableRowWith: [t1
						form: [t1
								selectFromList: self allClasses
								selected: class
								callback: [:t2 | self class: t2].
							t1 submitButtonWithText: 'OK']]
				with: [t1
						form: [t1
								selectFromList: self allSelectors
								selected: selector
								callback: [:t3 | self selector: t3].
							t1 submitButtonWithText: 'OK']]].
	t1 horizontalRule.
	t1 render: component.
	hasAnswer
		ifTrue: [t1 horizontalRule.
			t1 bold: 'Answer ';
				 text: answer printString]! !

!WAExampleBrowser methodsFor: 'helper' stamp: ''!
selectorPrefix
	^ 'example'! !

!WAExampleBrowser methodsFor: 'accessing' stamp: ''!
selector: t1 
	selector := t1.
	self
		component: (class perform: selector)! !

WAComponent subclass: #WAExpiryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpiryTest class methodsFor: 'as yet unclassified' stamp: ''!
install
	(self registerAsApplication: 'expiry')
		preferenceAt: #sessionClass
		put: WAExpirySession! !

!WAExpiryTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		table: [t1 tableRowWithLabel: 'Live session instances' column: WAExpirySession allInstances size.
			t1 tableRowWithLabel: 'Live component instances' column: self class allInstances size.
			t1 tableRowWithLabel: 'Sessions created' column: WAExpirySession created.
			t1 tableRowWithLabel: 'Sessions unregistered' column: WAExpirySession unregistered].
	t1 anchorWithUrl: self session application baseUrl do: 'New Session'.
	t1 break.
	t1
		anchorWithAction: [self session expire]
		text: 'Expire'.
	t1 break.
	t1
		anchorWithAction: [WAExpirySession resetCounters]
		text: 'Reset Counters'.
	t1 break.
	t1
		anchorWithAction: [Smalltalk garbageCollect]
		text: 'Garbage Collect'.
	t1 break.
	t1
		anchorWithAction: [self session application clearHandlers.
			Smalltalk garbageCollect]
		text: 'Clear Handlers'.
	t1 break.
	t1
		anchorWithAction: [self session application clearHandlers.
			WAExpirySession resetCounters.
			Smalltalk garbageCollect]
		text: 'Reset All'.
	t1
		form: [t1 text: 'Expiry seconds:'.
			t1
				textInputWithValue: (self session application preferenceAt: #sessionExpirySeconds)
				callback: [:t2 | self session application preferenceAt: #sessionExpirySeconds put: t2].
			t1 space.
			t1 submitButton]! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChoiceDialog class methodsFor: 'as yet unclassified' stamp: ''!
options: t1 
	^ self new options: t1! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#ok #cancel )! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
options
	^ options! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
options: t1 
	options := t1! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		selectFromList: options
		selected: nil
		callback: [:t2 | selection := t2]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#ok )! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self addFormByDefault
		ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
model
	^ self! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
ok
	self answer! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
removeForm
	form
		ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		hiddenInputWithCallback: [validationError := nil].
	validationError
		ifNotNil: [self renderValidationError: validationError on: t1].
	t1
		divClass: self divClass
		with: [self renderDialogOn: t1]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDialogOn: t1 
	^ self! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderSpacerRowOn: t1 
	t1
		divClass: 'dialog-spacer'
		with: [t1 space]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderValidationError: t1 on: t2 
	t2 spanClass: 'dialog-validation' with: t1! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: ''!
validationError: t1 
	validationError := t1! !

WAFormDialog subclass: #WAGridDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
columns
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
cssClassForItem: t1 
	^ 'dialog-row'! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
items
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderColumn: t1 for: t2 on: t3 
	| t4 |
	t4 := self renderingSelectorFor: t1.
	(self respondsTo: t4)
		ifTrue: [self
				perform: t4
				with: t2
				with: t3]
		ifFalse: [self
				renderDefaultColumn: t1
				for: t2
				on: t3]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDefaultColumn: t1 for: t2 on: t3 
	t3
		text: (t2 perform: t1)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDialogOn: t1 
	t1
		table: [self renderHeadingsOn: t1.
			self items
				do: [:t2 | self renderRowForItem: t2 on: t1]]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderHeadingForSelector: t1 on: t2 
	t2
		text: (self labelForSelector: t1)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderHeadingsOn: t1 
	self columns
		do: [:t2 | 
			t1 cssClass: t2.
			t1
				tableHeading: [self renderHeadingForSelector: t2 on: t1]]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderingSelectorFor: t1 
	^ ('render' , t1 capitalized , 'For:on:') asSymbol! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
renderRowForItem: t1 on: t2 
	t2
		cssClass: (self cssClassForItem: t1).
	t2
		tableRow: [self columns
				do: [:t3 | 
					t2 cssClass: t3.
					t2
						tableData: [self
								renderColumn: t3
								for: t1
								on: t2]]]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	.dialog-buttons {text-align: center}
	'! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WALabelledFormDialog subclass: #WAEditDialog
	instanceVariableNames: 'model snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEditDialog class methodsFor: 'as yet unclassified' stamp: ''!
model: t1 
	^ self new model: t1! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#save #cancel )! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self rollback.
	self answer: false! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
model
	^ model! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
model: t1 
	model := t1.
	self snapshot! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
rollback
	model copyFrom: snapshot! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
save
	self validate.
	self isValid
		ifTrue: [self answer: true]! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
snapshot
	snapshot := model clone! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: ''!
validate
	^ self! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDefaultFieldForSelector: t1 on: t2 
	t2 textInputOn: t1 of: self model! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDialogOn: t1 
	self rows
		do: [:t2 | t2 = #-
				ifTrue: [self renderSpacerRowOn: t1]
				ifFalse: [self renderRowForSelector: t2 on: t1]]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderFieldForSelector: t1 on: t2 
	| t3 |
	t3 := self renderingSelectorFor: t1.
	(self respondsTo: t3)
		ifTrue: [self perform: t3 with: t2]
		ifFalse: [self renderDefaultFieldForSelector: t1 on: t2]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderingSelectorFor: t1 
	^ ('render' , t1 capitalized , 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderLabelForSelector: t1 on: t2 
	t2
		text: (self labelForSelector: t1)! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderRowForSelector: t1 on: t2 
	t2 cssClass: 'dialog-row'.
	t2
		divNamed: t1
		with: [t2
				spanClass: 'dialog-form-label'
				with: [self renderLabelForSelector: t1 on: t2].
			t2
				spanClass: 'dialog-form-field'
				with: [self renderFieldForSelector: t1 on: t2]]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
renderTableRowsOn: t1 
	self rows
		do: [:t2 | t2 = #-
				ifTrue: [self renderSpacerRowOn: t1]
				ifFalse: [self renderRowForSelector: t2 on: t1]]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WALabelledFormDialog subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
countries
	^ #(#Canada #USA )! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
initialize
	address := WAStoreAddress new.
	super initialize! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
labelForSelector: t1 
	t1 == #name
		ifTrue: [^ 'Your name'].
	t1 == #street
		ifTrue: [^ 'The street'].
	t1 == #city
		ifTrue: [^ 'The city'].
	t1 == #ok
		ifTrue: [^ 'Continue'].
	^ super labelForSelector: t1! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
model
	^ address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
renderCountryOn: t1 
	t1
		selectFromList: self countries
		selected: address country
		callback: [:t2 | address country: t2]! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: ''!
rows
	^ #(#name #street #city #country )! !

WALabelledFormDialog subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
months
	^ 1 to: 12! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
ok
	self answer: (cardType new name: name;
			 number: cardNumber;
			
			expiry: (Date
					newDay: 1
					monthNumber: month
					year: year))! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
renderCardNumberOn: t1 
	t1
		textInputWithValue: cardNumber
		callback: [:t2 | cardNumber := t2]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
renderCardTypeOn: t1 
	t1
		selectFromList: self cardTypes
		selected: cardType
		callback: [:t2 | cardType := t2]
		labels: [:t3 | t3 abbreviation]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
renderExpirationDateOn: t1 
	t1
		selectFromList: self months
		selected: month
		callback: [:t2 | month := t2].
	t1
		selectFromList: self years
		selected: year
		callback: [:t3 | year := t3]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
renderNameOn: t1 
	t1
		textInputWithValue: name
		callback: [:t2 | name := t2]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
rows
	^ #(#cardType #name #cardNumber #expirationDate )! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: ''!
years
	^ Date today year to: Date today year + 5! !

WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAViewer class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new presenter: t1! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#save )! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
model
	^ presenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
presenter: t1 
	presenter := t1! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: presenter asString level: 3.
	super renderContentOn: t1! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
renderCssOn: t1 
	t1 attributes rows: 20;
		 cols: 80.
	t1
		textAreaWithValue: presenter style
		callback: [:t2 | presenter class compile: 'style ^ ' , t2 printString]! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
rows
	^ #(#css )! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
save
	^ self! !

!WAViewer methodsFor: 'as yet unclassified' stamp: ''!
script
	^ 'self.opener.location=self.opener.location'! !

WAFormDialog subclass: #WANoteDialog
	instanceVariableNames: 'note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WANoteDialog methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#ok #cancel )! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: nil! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: ''!
ok
	self answer: note! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: ''!
renderDialogOn: t1 
	t1 cssId: 'dialog-note'.
	t1
		textAreaWithValue: note
		callback: [:t2 | note := t2]! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: ''!
style
	^ ' 
	#dialog-note {width: 80%; height: 200px}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ #(#yes #no )! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: ''!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: ''!
yes
	self answer: true! !

WAComponent subclass: #WAFrameComponent
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

WAFrameComponent subclass: #WAAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAAllTests class methodsFor: 'testing' stamp: ''!
canBeRoot
	^ true! !

!WAAllTests class methodsFor: 'initialize' stamp: ''!
initialize
	self registerAsApplication: 'alltests'! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self contents: (WASimpleNavigation new add: WAInputTest new label: 'Input';
			 add: WAHtmlTest new label: 'Html';
			 add: WAEncodingTest new label: 'Encoding';
			 add: WAErrorTest new label: 'Error';
			 add: WAExceptionTest new label: 'Exception';
			 add: WAClosureTest new label: 'Closure';
			 add: WATransactionTest new label: 'Transaction';
			 add: WAUploadTest new label: 'Upload';
			
			add: (WAParentTest new parent: self)
			label: 'Parent';
			 add: WAPathTest new label: 'Path';
			 add: WATaskTest new label: 'Task';
			 add: WACookieTest new label: 'Cookies';
			 add: WACallbackTest new label: 'Callbacks';
			 add: WACanvasTest new label: 'Canvas';
			 add: WALiveRequestTest new label: 'Live';
			 add: WAImageTest new label: 'Images';
			 add: WAHomeTest new label: 'Home';
			 add: WACacheTest new label: 'Cache';
			 add: WADefaultFormTest new label: 'Default Form';
			 add: WALinkSubmitTest new label: 'Submit';
			 yourself)! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: 'Test Components'.
	t1 render: contents! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: ''!
updateRoot: t1 
	super updateRoot: t1.
	t1 title: 'Seaside Tests: ' , contents selection asString! !

!WAFrameComponent class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new contents: t1! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: contents! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: ''!
contents
	^ contents! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: ''!
contents: t1 
	contents := t1! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 render: contents! !

WAFrameComponent subclass: #WAPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPathTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self contents: WACounter new! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 anchorWithName: contents count.
	t1 render: contents! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: ''!
updateUrl: t1 
	t1 addToPath: contents count asString.
	t1 fragment: contents count asString! !

WAFrameComponent subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfiler methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 |
	t2 := SeasidePlatformSupport
				profileSendsDuring: [t1 render: contents].
	t1 horizontalRule.
	t1 preformatted: t2! !

WAFrameComponent subclass: #WAToolFrame
	instanceVariableNames: 'showHalos renderTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAToolFrame class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new contents: t1! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
actions
	^ #(#configure #toggleHalos )! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
configure
	self
		call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
initialize
	showHalos := WAStateHolder new contents: false! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
openTool: t1 
	self call: (t1 new root: contents;
			
			addDecoration: (WAWindowDecoration new title: t1 title);
			 yourself)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
renderChildOn: t1 
	showHalos contents
		ifTrue: [t1 context debugMode].
	renderTime := Time
				millisecondsToRun: [t1 render: contents].
	t1 context clearMode! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		divNamed: 'frameContent'
		with: [self renderChildOn: t1].
	self renderToolbarOn: t1! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
renderToolbarOn: t1 
	t1 paragraph.
	t1
		divNamed: 'toolbar'
		with: [t1
				anchorWithUrl: self session application baseUrl
				do: [t1 text: 'New Session'];
				 space.
			self actions
				do: [:t2 | t1 anchorOn: t2 of: self;
						 space].
			self tools
				do: [:t2 | t1
						anchorWithAction: [self openTool: t2]
						text: t2 linkText;
						 space].
			t1
				anchorWithUrl: (t1 context actionUrl withParameter: 'terminate' value: '1')
				do: 'Terminate'.
			t1 space.
			t1 anchorWithUrl: 'http://validator.w3.org/check/referer' do: 'XHTML'.
			t1 space.
			t1 text: renderTime asString , ' ms']! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	.halo {border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa}
	.halo-header {font-size: 10pt; background-color: #cccccc; margin-bottom: 4px}
	.halo-mode {float: right}
	.halo-icons: {float: left}
	.halo-contents: {clear: both} 
'! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
toggleHalos
	WAHalo initialize.
	showHalos contents: showHalos contents not! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: ''!
tools
	^ WATool allSubclasses! !

WAComponent subclass: #WAHalo
	instanceVariableNames: 'target mode'
	classVariableNames: 'Halos'
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAHalo class methodsFor: 'as yet unclassified' stamp: ''!
for: t1 
	^ Halos
		at: t1
		ifAbsentPut: [self new target: t1]! !

!WAHalo class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	Halos := SeasidePlatformSupport weakDictionaryOfSize: 20! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
findStyles
	| t1 |
	t1 := WARenderingContext new document: WAStyleCollector new;
				 actionUrl: WAUrl new;
				 request: self session currentRequest.
	self target renderWithContext: t1.
	^ String
		streamContents: [:t2 | t1 document styles
				do: [:t3 | t2 nextPutAll: t3;
						 space]]! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
initialize
	mode := WAStateHolder new contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 |
	t2 := self rendererClass context: t1 context callbacks: t1 callbacks.
	t2
		divClass: 'halo'
		with: [t2
				divClass: 'halo-header'
				with: [t2
						divClass: 'halo-icons'
						with: [t2
								divClass: 'halo-mode'
								with: [t2 text: '['.
									t2
										anchorWithAction: [self renderMode]
										text: 'R'.
									t2 text: ' | '.
									t2
										anchorWithAction: [self sourceMode]
										text: 'S'.
									t2 text: ']'].
							t2 text: self target class name.
							t2 space.
							self
								renderHalo: 'Halo-Debug'
								withWindow: [WABrowser fullOnClass: self target class]
								titled: 'System Browser'
								on: t2.
							self
								renderHalo: 'Halo-View'
								withWindow: [WAInspector on: self target]
								titled: 'Inspector'
								on: t2.
							self
								renderHalo: 'Halo-Paint'
								withWindow: [WAViewer on: self target]
								titled: 'Style Editor'
								on: t2]].
			t2
				divClass: 'halo-contents'
				with: [self perform: mode contents with: t1]].
	t2 close.
	t1 close! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
renderHalo: t1 withAction: t2 on: t3 
	t3
		anchorWithAction: t2
		text: [t3
				imageWithForm: (ScriptingSystem formAtKey: t1)]! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
renderHalo: t1 withWindow: t2 titled: t3 on: t4 
	t4 attributes at: 'title' put: t3.
	t4 attributes at: 'label' put: t3.
	self
		renderHalo: t1
		withAction: [WARenderLoop new call: (t2 value
					addDecoration: (WAWindowDecoration new title: t3);
					 yourself)]
		on: t4! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
renderMode
	mode contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
render: t1 
	self target renderContentOn: t1! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
sourceMode
	mode contents: #source:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
source: t1 
	| t2 t3 |
	t3 := self rendererClass context: t1 context callbacks: t1 callbacks.
	t2 := t3 context copy.
	t2 clearMode.
	t2
		document: (WAPrettyPrintedDocument renderer: t3).
	t3
		divClass: 'halo-source'
		with: [self target renderWithContext: t2].
	t3 close! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
target
	^ target! !

!WAHalo methodsFor: 'as yet unclassified' stamp: ''!
target: t1 
	target := t1! !

WAComponent subclass: #WAHomeTest
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHomeTest methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: main! !

!WAHomeTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	main := WATaskTest new! !

!WAHomeTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [main home]
		text: 'Home'.
	t1 div: main! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: ''!
allSelectors
	^ (self class selectors asSortedCollection
		select: [:t1 | t1 beginsWith: 'render']) remove: #renderContentOn:;
		 yourself! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	message := 'Hello world!!'.
	booleanList := #(#a #b #c #d )
				collect: [:t1 | t1 -> (Array with: true with: false) atRandom].
	number := 10 atRandom! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderCheckboxesOn: t1 
	t1 text: booleanList.
	t1 paragraph.
	t1
		form: [booleanList
				do: [:t2 | 
					t1 text: t2 key;
						 space.
					t1
						checkboxWithValue: t2 value
						callback: [:t3 | t2 value: t3].
					t1 break].
			t1 submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	self allSelectors
		pairsDo: [:t2 :t3 | t1
				divClass: 'row'
				with: [t1
						divClass: 'left'
						with: [self perform: t2 with: t1].
					t1
						divClass: 'left'
						with: [self perform: t3 with: t1]]]! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderRadioButtonsOn: t1 
	| t3 |
	t1 text: booleanList.
	t1 paragraph.
	t1
		form: [booleanList
				do: [:t2 | 
					t3 := t1 radioGroup.
					t1 text: t2 key;
						 space.
					t1
						radioButtonInGroup: t3
						selected: t2 value
						callback: [t2 value: true].
					t1
						radioButtonInGroup: t3
						selected: t2 value not
						callback: [t2 value: false].
					t1 break].
			t1 submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderSelectsOn: t1 
	t1 text: number.
	t1 paragraph.
	t1
		form: [t1
				selectFromList: (1 to: 10)
				selected: number
				callback: [:t2 | number := t2].
			t1 submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderSubmitButtonsOn: t1 
	t1 text: number.
	t1 paragraph.
	t1
		form: [(1 to: 10)
				do: [:t2 | 
					t1
						submitButtonWithAction: [number := t2]
						text: t2.
					t1 space]]! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderTextAreaOn: t1 
	t1
		form: [t1 text: message.
			t1 paragraph.
			t1
				textAreaWithValue: message
				callback: [:t2 | message := t2].
			t1 break; submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: ''!
renderTextInputOn: t1 
	t1
		form: [t1 text: message.
			t1 paragraph.
			t1
				textInputWithValue: message
				callback: [:t2 | message := t2].
			t1 submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: ''!
renderZ: t1 
	t1 space! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

WAComponent subclass: #WAImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAImageTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				submitButtonWithAction: [self inform: 'ok']
				image: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAInputDialog methodsFor: 'as yet unclassified' stamp: ''!
default: t1 
	value := t1! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: ''!
label
	^ label
		ifNil: [label := 'OK']! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: ''!
label: t1 
	label := t1! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				defaultAction: [self answer: value].
			t1
				textInputWithValue: value
				callback: [:t2 | value := t2].
			t1 space.
			t1 submitButtonWithText: self label]! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAInputTest class methodsFor: 'example' stamp: ''!
example
	^ self new! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
emptyString
	^ emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
emptyString: t1 
	emptyString := t1! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
fraction
	^ fraction! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
fraction: t1 
	fraction := t1! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	nilString := nil.
	emptyString := ''.
	integer := 42.
	fraction := 1 / 3! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
integer
	^ integer! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
integer: t1 
	integer := t1! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
nilString
	^ nilString! !

!WAInputTest methodsFor: 'accessing' stamp: ''!
nilString: t1 
	nilString := t1! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				table: [t1 tableHeadings: #(#Name #Value #PrintString );
						
						tableRowWithLabel: 'Nil String'
						column: [t1 textInputOn: #nilString of: self]
						column: [t1 text: nilString printString];
						
						tableRowWithLabel: 'Empty String'
						column: [t1 textInputOn: #emptyString of: self]
						column: [t1 text: emptyString printString];
						
						tableRowWithLabel: 'Integer'
						column: [t1 textInputOn: #integer of: self]
						column: [t1 text: integer printString];
						
						tableRowWithLabel: 'Fraction'
						column: [t1 textInputOn: #fraction of: self]
						column: [t1 text: fraction printString]].
			t1 submitButton]! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAInspector class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new object: t1! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
canInspect: t1 
	^ [t1 isNumber
		or: [(Array
				with: nil
				with: true
				with: false)
				includes: t1]]
		on: Error
		do: [:t2 | false]! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: path! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
chooseObject: t1 named: t2 
	path pushSegment: t1 name: t2! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
initialize
	path := WAPath new! !

!WAInspector methodsFor: 'state variables' stamp: ''!
object
	^ path currentSegment! !

!WAInspector methodsFor: 'state variables' stamp: ''!
object: t1 
	path pushSegment: t1 name: t1 printString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 render: path.
	t1
		heading: (self object printStringLimitedTo: 50).
	t1 text: 'Identity Hash: ' , self object identityHash asString;
		 break;
		 break.
	self renderMembersOn: t1! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
renderMembersOn: t1 
	| t2 |
	t2 := self object inspectorFields.
	t2 isEmpty
		ifTrue: [^ self].
	t1 bold: 'Members: '.
	t1 attributeAt: 'border' put: 1.
	t1
		table: [t2
				associationsDo: [:t3 | self
						renderRowForObject: t3 value
						named: t3 key
						on: t1]]! !

!WAInspector methodsFor: 'as yet unclassified' stamp: ''!
renderRowForObject: t1 named: t2 on: t3 
	t3
		tableRow: [t3
				tableData: [(self canInspect: t1)
						ifTrue: [t3 text: t2]
						ifFalse: [t3
								anchorWithAction: [self chooseObject: t1 named: t2]
								text: t2]].
			t3
				tableData: [t3
						text: (t1 printStringLimitedTo: 100)]]! !

WAComponent subclass: #WALibraryBrowser
	instanceVariableNames: 'group selector library hits search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
findAll: t1 
	hits := Dictionary new.
	(t1 findTokens: ' ')
		do: [:t2 | self find: t2].
	hits isEmpty
		ifFalse: [self goto: self orderedHits first]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
find: t1 
	| t2 |
	self libraries
		do: [:t3 | 
			t2 := t3 new.
			t3 selectors
				do: [:t4 | ((t2 perform: t4)
							includesSubString: t1)
						ifTrue: [(hits
								at: (Array with: t3 with: t4)
								ifAbsentPut: [SortedCollection new])
								add: t1]]]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
goto: t1 
	library := t1 first.
	selector := t1 second! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
hits
	^ hits
		ifNil: [#()]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
libraries
	^ WAStyleLibrary subclasses , WAScriptLibrary subclasses
		asSortedCollection: [:t1 :t2 | t1 name <= t2 name]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
library
	^ library! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
library: t1 
	library := t1.
	selector := nil! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
orderedHits
	^ hits keys
		asSortedCollection: [:t1 :t2 | (hits at: t1) size >= (hits at: t2) size]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
renderColumnsOn: t1 
	t1 attributes size: 10;
		 submitOnChange.
	t1
		selectFromList: self libraries
		selected: self library
		callback: [:t2 | self library: t2].
	t1 attributes size: 10;
		 submitOnChange.
	t1
		selectFromList: self selectors
		selected: self selector
		callback: [:t2 | self selector: t2]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		divClass: 'stylebrowser-columns'
		with: [t1
				form: [self renderColumnsOn: t1]].
	t1
		divClass: 'stylebrowser-search'
		with: [t1
				form: [t1
						textInputWithValue: search
						callback: [:t2 | search := t2].
					t1 space.
					t1
						submitButtonWithAction: [self findAll: search]
						text: 'Search'].
			t1
				list: self orderedHits
				do: [:t3 | self renderHit: t3 on: t1]].
	t1
		divClass: 'stylebrowser-editor'
		with: [t1
				form: [self renderEditorOn: t1.
					t1 paragraph.
					t1
						submitButtonWithAction: [self save]
						text: 'Save']]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
renderEditorOn: t1 
	t1 attributes rows: 20;
		 cols: 80.
	t1
		textAreaWithValue: self string
		callback: [:t2 | self string: t2]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
renderHit: t1 on: t2 
	| t3 |
	t3 := String
				streamContents: [:t4 | 
					t4 nextPutAll: t1 first name.
					t4 nextPutAll: '>>'.
					t4 nextPutAll: t1 second.
					t4 space.
					t4 nextPutAll: '('.
					(hits at: t1)
						do: [:t5 | t4 nextPutAll: t5]
						separatedBy: [t4 nextPutAll: ', '].
					t4 nextPutAll: ')'].
	t2
		anchorWithAction: [self goto: t1]
		text: t3! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
save
	^ self! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
search: t1 
	search := t1.
	self findAll: search! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
selector
	^ selector! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
selectors
	^ library
		ifNil: [#()]
		ifNotNil: [library selectors]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
selector: t1 
	(library selectors includes: t1)
		ifTrue: [selector := t1]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
string
	^ self selector
		ifNotNilDo: [:t1 | library new perform: t1]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
string: t1 
	self selector
		ifNotNilDo: [:t2 | library compile: t2 , '
	^ ' , t1 printString]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	.stylebrowser-search {float: left}
	.stylebrowser-columns {float: left}
	.stylebrowser-columns select {width: 250px}
	.stylebrowser-editor {clear: both}
	'! !

WAComponent subclass: #WALinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALinkSubmitTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	count := 0! !

!WALinkSubmitTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 attributes name: 'myform'.
	t1
		form: [t1
				textInputWithValue: count
				callback: [:t2 | count := t2].
			t1 break.
			t1
				anchorWithAction: [count := count - 1]
				text: '--'
				submitFormNamed: 'myform'.
			t1 space.
			t1
				anchorWithAction: [count := count + 1]
				text: '++'
				submitFormNamed: 'myform']! !

WAComponent subclass: #WALiveRequestTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	count := 0! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 |
	t2 := [:t3 :t4 | t4 text: Time now printString].
	t1
		table: [t1
				tableRowWith: [t1 text: 'Current Time in default div:']
				with: [t1 refreshDivWith: t2 every: 2 seconds].
			t1
				tableRowWith: [t1 text: 'Current Time in another div:']
				with: [t1
						refreshDivNamed: 'mylivediv'
						with: t2
						every: 3 seconds].
			t1
				tableRowWith: [t1 text: 'Current Time in default span:']
				with: [t1 refreshSpanWith: t2 every: 5 seconds]].
	t1
		form: [t1
				textInputWithCallback: [:t5 | t5]
				liveCallback: [:t3 :t4 | t4
						divNamed: 'forward'
						with: [t4
								list: t3
								do: [:t6 | t4
										anchorWithAction: [self inform: t6 asString]
										text: t6 asString]]]].
	t1
		form: [t1
				textInputWithCallback: [:t5 | t5]
				liveCallback: [:t3 :t4 | t4
						divNamed: 'backward'
						with: [t4
								list: t3 reverse
								do: [:t6 | t4
										anchorWithAction: [self inform: t6 asString]
										text: t6 asString]]]].
	t1
		form: [t1
				selectFromList: #(#a #b #c )
				selected: #a
				callback: [:t5 | t5]
				labels: [:t7 | t7 asString]
				liveCallback: [:t8 :t4 | t4 spanNamed: 'selection' with: t8]].
	t1
		anchorWithAction: []
		liveAction: [:t4 | t4 spanNamed: 'time' with: Time now]
		text: 'Show time'.
	t1 break.
	t1
		anchorWithAction: []
		liveAction: [:t4 | t4 spanNamed: 'time' with: 1 / 0]
		text: 'Live error'.
	t1 heading: 'Forward' level: 3.
	t1 divNamed: 'forward' with: ''.
	t1 heading: 'Backward' level: 3.
	t1 divNamed: 'backward' with: ''.
	t1 heading: 'Selection' level: 3.
	t1 spanNamed: 'selection' with: ''.
	t1 heading: 'Time' level: 3.
	t1 spanNamed: 'time' with: ''! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: ''!
selection
	^ #a! !

!WALiveRequestTest methodsFor: 'as yet unclassified' stamp: ''!
selection: t1 
	^ self! !

WAComponent subclass: #WALoginDialog
	instanceVariableNames: 'username password authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALoginDialog methodsFor: 'as yet unclassified' stamp: ''!
authenticator: t1 
	authenticator := t1! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: ''!
cancel
	self answer: nil! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: ''!
login
	(authenticator verifyPassword: password forUser: username)
		ifTrue: [self answer: username]! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [t1
				table: [t1
						tableRowWithLabel: 'Username:'
						column: [t1
								textInputWithValue: username
								callback: [:t2 | username := t2]].
					t1
						tableRowWithLabel: 'Password:'
						column: [t1
								passwordInputWithCallback: [:t2 | password := t2]].
					t1 attributes alignCenter.
					t1
						tableRowWith: [t1 submitButtonOn: #login of: self.
							t1 space.
							t1 submitButtonOn: #cancel of: self]
						span: 2]]! !

WAComponent subclass: #WAMemoryUse
	instanceVariableNames: 'instances sizes table root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
buildTable
	^ WATableReport new rowPeriod: 1;
		 rowColors: #('lightgrey' 'white' );
		 rows: sizes keys asSortedCollection;
		
		columns: (Array
				with: (WAReportColumn selector: #yourself title: 'Class')
				with: (WAReportColumn new title: 'Instances';
						
						valueBlock: [:t1 | instances at: t1])
				with: (WAReportColumn new title: 'Total Size';
						
						valueBlock: [:t1 | sizes at: t1]))! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: table! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 bold: self totalInstances asString , ' instances in ' , self totalSizeString.
	t1 render: table! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
root: t1 
	| t2 t3 |
	root := t1.
	t2 := ImageSegment new
				copyFromRoots: (Array with: root)
				sizeHint: 100000.
	t3 := t2 doSpaceAnalysis.
	instances := t3 first.
	sizes := t3 second.
	table := self buildTable! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
totalInstances
	^ instances
		detectSum: [:t1 | t1]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
totalSize
	^ sizes
		detectSum: [:t1 | t1]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: ''!
totalSizeString
	| t1 t2 |
	t1 := self totalSize.
	t2 := 'bytes'.
	t1 > 1024
		ifTrue: [t1 := t1 / 1024.
			t2 := 'kB'.
			t1 > 1024
				ifTrue: [t1 := t1 / 1024.
					t2 := 'MB']].
	^ (t1 printShowingDecimalPlaces: 1)
		, ' ' , t2! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAMiniCalendar class methodsFor: 'as yet unclassified' stamp: ''!
example
	^ self new! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
canSelectBlock: t1 
	canSelectBlock := t1! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
canSelect: t1 
	^ canSelectBlock notNil
		and: [canSelectBlock value: t1]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
date: t1 
	date contents: t1.
	month contents: t1 month! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
initialize
	month := WAStateHolder new contents: Date today month.
	date := WAStateHolder new! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
monthHeading
	^ self month name , ' ' , self month year asString! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
month: t1 
	^ month contents: t1! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
renderCellForDate: t1 on: t2 
	t2
		tableData: [t1 month = self month
				ifTrue: [t2
						cssClass: (self date = t1
								ifTrue: ['calendarArchiveDate']).
					t2
						span: [(self canSelect: t1)
								ifTrue: [t2
										anchorWithAction: [self select: t1]
										text: t1 dayOfMonth]
								ifFalse: [t2 text: t1 dayOfMonth]]]]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		divClass: 'calendar'
		with: [t1 spanClass: 'calendarCaption' with: self monthHeading.
			t1
				table: [t1 cssClass: 'calendarTitle';
						
						tableRow: [self weekDays
								do: [:t2 | t1 tableData: t2]].
					self month
						eachWeekDo: [:t3 | self renderRowForWeek: t3 on: t1]].
			self renderMonthNavigationOn: t1]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
renderMonthNavigationOn: t1 
	t1
		spanClass: 'calendarPrevious'
		with: [t1
				anchorWithAction: [self month: self month previous]
				text: (self month previous name first: 3)].
	t1 space.
	t1
		spanClass: 'calendarNext'
		with: [t1
				anchorWithAction: [self month: self month next]
				text: (self month next name first: 3)]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
renderRowForWeek: t1 on: t2 
	t2
		tableRow: [t1
				do: [:t3 | self renderCellForDate: t3 on: t2]]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
selectBlock: t1 
	selectBlock := t1! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
select: t1 
	self date: t1.
	selectBlock
		ifNotNil: [selectBlock value: t1]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: ''!
weekDays
	^ (1 to: 7)
		collect: [:t1 | (Date nameOfDay: t1)
				first: 3]! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self registerAsApplication: 'multi'! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: ''!
children
	^ counters! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: ''!
initialize
	counters := (1 to: 5)
				collect: [:t1 | WACounter new]! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	counters
		do: [:t2 | t1 render: t2]
		separatedBy: [t1 horizontalRule]! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: ''!
initialize
	selection := WAStateHolder new! !

!WANavigation methodsFor: 'query' stamp: ''!
labelForOption: t1 
	^ t1 asString! !

!WANavigation methodsFor: 'initialize' stamp: ''!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1
		divClass: 'kalsey'
		with: [t1
				divClass: 'navigation-options'
				with: [self renderOptionsOn: t1].
			t1
				divClass: 'navigation-content'
				with: [self renderSelectionOn: t1]]! !

!WANavigation methodsFor: 'rendering' stamp: ''!
renderOptionsOn: t1 
	t1
		unorderedList: self options
		selected: self selection
		callback: [:t2 | self select: t2]
		labels: [:t3 | self labelForOption: t3]! !

!WANavigation methodsFor: 'rendering' stamp: ''!
renderSelectionOn: t1 
	^ self! !

!WANavigation methodsFor: 'selection' stamp: ''!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: ''!
selectionChanged
	^ self! !

!WANavigation methodsFor: 'selection' stamp: ''!
select: t1 
	selection contents: t1.
	self selectionChanged! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WASimpleNavigation class methodsFor: 'example' stamp: ''!
example
	^ self new add: WACounter example label: 'Counter';
		 add: WAPath example label: 'Path';
		 select: 'Counter';
		 yourself! !

!WASimpleNavigation methodsFor: 'behavior' stamp: ''!
add: t1 label: t2 
	components add: t2 -> t1! !

!WASimpleNavigation methodsFor: 'accessing' stamp: ''!
children
	^ Array with: self selectedComponent! !

!WASimpleNavigation methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: ''!
labels
	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: ''!
options
	^ components
		collect: [:t1 | t1 key]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: ''!
renderSelectionOn: t1 
	t1 render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: ''!
selectedComponent
	^ (components
		detect: [:t1 | t1 key = self selection]
		ifNone: [^ nil]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector mOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
actionsSelector: t1 
	actionsSelector := t1! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
initialize
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	mOwner := t1! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	self actions
		do: [:t2 | t2 numArgs = 0
				ifTrue: [self renderLink: t2 on: t1]
				ifFalse: [self renderInput: t2 on: t1]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
renderInput: t1 on: t2 
	t2
		form: [t2 bold: t1 capitalized.
			t2 space.
			t2
				textInputWithValue: ''
				callback: [:t3 | self target perform: t1 with: t3]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
renderLink: t1 on: t2 
	t2 anchorOn: t1 of: self target.
	t2 break! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: ''!
target
	^ mOwner activeComponent! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAParentTest methodsFor: 'as yet unclassified' stamp: ''!
go
	parent inform: 'foo'! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: ''!
parent: t1 
	parent := t1! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [self go]
		text: 'swap parent'! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAPath class methodsFor: 'example' stamp: ''!
example
	^ self new pushSegment: 123 name: 'xxx';
		 pushSegment: 456 name: 'yyy';
		 pushSegment: 789 name: 'zzz';
		 yourself! !

!WAPath methodsFor: 'behavior' stamp: ''!
choose: t1 
	| t2 |
	t2 := Array new writeStream.
	stack
		do: [:t3 | 
			t2 nextPut: t3.
			t3 == t1
				ifTrue: [stack := t2 contents.
					^ self].
			nil]! !

!WAPath methodsFor: 'accessing' stamp: ''!
currentSegment
	^ stack isEmpty
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: ''!
initialize
	stack := #().
	self session registerObjectForBacktracking: self! !

!WAPath methodsFor: 'behavior' stamp: ''!
pushSegment: t1 name: t2 
	stack := stack
				, (Array with: t2 -> t1)! !

!WAPath methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	stack isEmpty
		ifTrue: [^ self].
	t1
		divNamed: 'path'
		with: [stack allButLast
				do: [:t2 | 
					t1
						anchorWithAction: [self choose: t2]
						text: t2 key.
					t1 text: ' >> '].
			t1 bold: stack last key]! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReport methodsFor: 'initialize' stamp: ''!
initialize
	rows := #()! !

!WAReport methodsFor: 'accessing' stamp: ''!
rows: t1 
	rows := t1! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATableReport methodsFor: 'as yet unclassified' stamp: ''!
chooseRow: t1 column: t2 
	t2 chooseRow: t1! !

!WATableReport methodsFor: 'as yet unclassified' stamp: ''!
colorForRowNumber: t1 
	^ rowColors
		at: t1 - 1 // rowPeriod \\ rowColors size + 1
		ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: ''!
columns: t1 
	columns := t1! !

!WATableReport methodsFor: 'accessing' stamp: ''!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow' ).
	rowPeriod := 3! !

!WATableReport methodsFor: 'as yet unclassified' stamp: ''!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderColumn: t1 row: t2 on: t3 
	| t4 |
	t4 := t1 textForRow: t2.
	t4 isEmpty
		ifTrue: [t4 := ' '].
	t3
		tableData: [t1 canChoose
				ifTrue: [t3
						anchorWithAction: [self chooseRow: t2 column: t1]
						text: t4]
				ifFalse: [t3 text: t4]]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	t1 attributeAt: 'cellspacing' put: 0;
		 attributeAt: 'cellpadding' put: 5.
	t1
		table: [self renderTableHeaderOn: t1.
			self renderRowsOn: t1.
			self renderTableFooterOn: t1]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderFooterForColumn: t1 on: t2 
	t2
		tableHeading: [t2
				text: (t1 totalForRows: rows)]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderHeaderForColumn: t1 on: t2 
	t2
		tableHeading: [t1 canSort
				ifTrue: [t2
						anchorWithAction: [self sortColumn: t1]
						text: t1 title]
				ifFalse: [t2 text: t1 title]]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderRowNumber: t1 item: t2 on: t3 
	t3
		attributeAt: 'bgcolor'
		put: (self colorForRowNumber: t1).
	t3
		tableRow: [columns
				do: [:t4 | self
						renderColumn: t4
						row: t2
						on: t3]]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderRowsOn: t1 
	self rows
		withIndexDo: [:t2 :t3 | self
				renderRowNumber: t3
				item: t2
				on: t1]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderTableFooterOn: t1 
	t1
		tableRow: [columns
				do: [:t2 | self renderFooterForColumn: t2 on: t1]]! !

!WATableReport methodsFor: 'rendering' stamp: ''!
renderTableHeaderOn: t1 
	t1
		tableRow: [columns
				do: [:t2 | self renderHeaderForColumn: t2 on: t1]]! !

!WATableReport methodsFor: 'accessing' stamp: ''!
rowColors: t1 
	rowColors := t1! !

!WATableReport methodsFor: 'accessing' stamp: ''!
rowPeriod: t1 
	rowPeriod := t1! !

!WATableReport methodsFor: 'as yet unclassified' stamp: ''!
rows
	| t1 |
	self sortColumn
		ifNil: [^ rows].
	t1 := self sortColumn sortRows: rows.
	^ self isReversed
		ifTrue: [t1 reversed]
		ifFalse: [t1]! !

!WATableReport methodsFor: 'state variables' stamp: ''!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: ''!
sortColumn: t1 
	t1 = self sortColumn
		ifTrue: [isReversed := isReversed not]
		ifFalse: [isReversed := false].
	sortColumn contents: t1! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button text zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAScreenshot class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
buttonCode
	^ button = #red
		ifTrue: [4]
		ifFalse: [button = #blue
				ifTrue: [2]
				ifFalse: [1]]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
click: t1 
	| t2 |
	t2 := Sensor createMouseEvent.
	t2 at: 3 put: t1 x.
	t2 at: 4 put: t1 y.
	t2 at: 5 put: self buttonCode.
	Sensor processEvent: t2.
	t2 at: 5 put: 0.
	Sensor processEvent: t2.
	button := #red! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
form
	^ zoom
		ifTrue: [self topWindow imageForm]
		ifFalse: [Display copy]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
initialize
	button := #red.
	zoom := false! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
offset
	^ zoom
		ifTrue: [self topWindow position]
		ifFalse: [0 @ 0]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 |
	t1
		table: [t1
				tableRow: [t1
						tableData: [t1
								form: [t1
										table: [t1
												tableRow: [t1 tableData: 'Button: '.
													t2 := t1 radioGroup.
													#(#red #yellow #blue )
														do: [:t3 | 
															t1 attributes at: 'bgcolor' put: t3.
															t1
																tableData: [t1
																		radioButtonInGroup: t2
																		selected: button = t3
																		callback: [button := t3]]].
													t1
														tableData: [t1 submitButtonWithText: 'Set']]]]].
					t1
						tableData: [t1
								anchorWithAction: [self toggleZoom]
								text: self toggleZoomText].
					t1
						tableData: [t1
								anchorWithAction: [self toggleUIProcess]
								text: self toggleUIText]]].
	t1
		imageMapWithAction: [:t4 | self click: t4 + self offset]
		form: self form.
	t1 horizontalRule! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
toggleUIText
	^ Project uiProcess isSuspended
		ifTrue: ['Resume UI Process']
		ifFalse: ['Suspend UI Process']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
toggleZoom
	zoom := zoom not! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
toggleZoomText
	^ zoom
		ifTrue: ['Zoom out']
		ifFalse: ['Zoom in']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: ''!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WASelection methodsFor: 'as yet unclassified' stamp: ''!
initialize
	items := #().
	labelBlock := [:t1 | t1 asString]! !

!WASelection methodsFor: 'as yet unclassified' stamp: ''!
items: t1 
	items := t1! !

!WASelection methodsFor: 'as yet unclassified' stamp: ''!
labelBlock: t1 
	labelBlock := t1! !

!WASelection methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		list: items
		do: [:t2 | t1
				anchorWithAction: [self answer: t2]
				text: (labelBlock value: t2)]! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStore class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WAStore class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self registerAsApplication: 'store'! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: task! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
initialize
	task := WAStoreTask new! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 cssId: 'banner'.
	t1
		table: [t1
				tableRowWith: [t1 divNamed: 'title' with: self title.
					t1 divNamed: 'subtitle' with: self subtitle]].
	t1 divNamed: 'body' with: task! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	body {margin: 0px; font-family: sans-serif}
	#banner {width: 100%}	
	#banner tr {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#body {padding: 5px}
	.validation-error {color: red; font-size: 9pt; padding: 5px}
	'! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'sushiNet'! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: ''!
cart: t1 
	cart := t1! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t3 t4 |
	t1 attributes border: 0.
	t1
		table: [t1 tableHeadings: #(#Item #Price #Count #Total ).
			cart countsAndItems
				do: [:t2 | 
					t3 := t2 key.
					t4 := t2 value.
					t1
						tableRow: [t1 cssClass: 'item-title'.
							t1 tableData: t4 title.
							t1 cssClass: 'item-price'.
							t1 tableData: t4 price printStringAsCents.
							t1 cssClass: 'item-count'.
							t1 tableData: t3 asString.
							t1 cssClass: 'item-price'.
							t1 tableData: (t4 price * t3) printStringAsCents]].
			t1 cssClass: 'cart-total'.
			t1 tableRowWith: cart totalPrice printStringAsCents span: 4].
	t1 paragraph.
	t1
		form: [t1
				submitButtonWithAction: [self answer: true]
				text: 'Proceed with checkout'.
			t1 break.
			t1
				submitButtonWithAction: [self answer: false]
				text: 'Modify my order']! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
.item-title {	text-align: left; padding: 0 40px 0 0;}
.item-count { text-align: right;}
.item-price { text-align: right; padding: 0 0 0 10px;}
.cart-total { text-align: right; font-weight: bold; height: 50px;}
'! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartView methodsFor: 'accessing' stamp: ''!
cart: t1 
	cart := t1! !

!WAStoreCartView methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	cart hasItems
		ifFalse: [^ self].
	t1
		divNamed: 'cart'
		with: [t1
				small: [t1 bold: 'Your cart:'].
			t1
				table: [cart countsAndItems
						do: [:t2 | self
								renderRowForCount: t2 key
								of: t2 value
								on: t1].
					t1 spacerRow.
					t1
						tableRowWith: ''
						with: ''
						with: [t1 bold: cart totalPrice printStringAsCents]]]! !

!WAStoreCartView methodsFor: 'rendering' stamp: ''!
renderRowForCount: t1 of: t2 on: t3 
	| t4 |
	t4 := t1 = 1
				ifTrue: ['']
				ifFalse: ['(' , t1 asString , ') '].
	t3
		tableRowWith: [t3
				anchorWithAction: [cart remove: t2]
				text: '-']
		with: t4 , t2 title
		with: (t1 * t2 price) printStringAsCents! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
cart: t1 
	cart := t1.
	cartView cart: t1! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
checkout
	self answer! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
children
	^ Array with: cartView with: main! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
displayItems: t1 
	| t2 |
	t1 size = 1
		ifTrue: [^ self displayItem: t1 first].
	t2 := WABatchSelection
				items: t1
				link: #title
				text: #subtitle.
	[self
		displayItem: (main call: t2)] repeat! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
displayItem: t1 
	main call: (WAStoreItemView new item: t1;
			 cart: cart)! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
initialize
	main := WAStoreInfo new.
	cartView := WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		table: [t1
				tableRow: [t1 cssId: 'nav';
						
						tableData: [self renderNavBarOn: t1].
					t1 cssId: 'main';
						 tableData: main.
					t1 cssId: 'side';
						 tableData: cartView]]! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
renderNavBarOn: t1 
	t1
		form: [t1 bold: 'Search:'.
			t1 space.
			t1
				textInputWithValue: ''
				callback: [:t2 | self search: t2]].
	t1
		anchorWithAction: [self browse]
		text: 'Browse'.
	cart hasItems
		ifTrue: [t1 break.
			t1
				anchorWithAction: [self checkout]
				text: 'Checkout']! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
search: t1 
	| t2 |
	t2 := self inventory findItem: t1.
	t2 isEmpty
		ifTrue: [main inform: 'No items match ' , t1 printString]
		ifFalse: [self displayItems: t2]! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 html: self text! !

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: ''!
text
	^ 'Welcome to the sushiNet online store.
<p>
This is a sample Seaside application.
<p>
Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: ''!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: ''!
cart: t1 
	cart := t1! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: ''!
item: t1 
	item := t1! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: item title.
	t1 heading: item subtitle level: 3.
	t1 paragraph: item description.
	t1 italic: item price printStringAsCents.
	t1
		form: [t1
				submitButtonWithAction: [self addToCart]
				text: 'Add To Cart'.
			t1 space.
			t1
				submitButtonWithAction: [self answer]
				text: 'Done']! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: ''!
updateUrl: t1 
	t1 addToPath: item name! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WATask subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACookieTest methodsFor: 'as yet unclassified' stamp: ''!
go
	[self session checkForCookies]
		whileFalse: [self inform: 'You must have cookies enabled to proceed.'].
	self session redirectWithCookie: (WACookie new key: 'cookietest';
			 value: 1000 atRandom asString;
			
			expireIn: (Duration seconds: 60);
			 yourself).
	self inform: self session currentRequest cookies asString! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExceptionTest methodsFor: 'as yet unclassified' stamp: ''!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
		on: Error
		do: [:t1 | self inform: 'Caught: ' , t1 asString]! !

WATask subclass: #WAOnceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAOnceTest methodsFor: 'as yet unclassified' stamp: ''!
go
	1
		to: 3
		do: [:t1 | self inform: t1 asString]! !

!WAOnceTest methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self addDecoration: WAOnce new! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
confirmContentsOfCart
	^ self
		call: ((WAStoreCartConfirmation new cart: cart)
				addMessage: 'Please verify your order:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
fillCart
	self
		call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
getAddressWithMessage: t1 
	^ self
		call: ((WAStoreAddressEditor new
				validateWith: [:t2 | t2 validate])
				addMessage: t1)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
getPaymentInfo
	^ self
		call: ((WAStorePaymentEditor new
				validateWith: [:t1 | t1 validate])
				addMessage: 'Please enter your payment information:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
go
	| t1 t2 t3 |
	cart := WAStoreCart new.
	self
		isolate: [[self fillCart.
			self confirmContentsOfCart] whileFalse.
			nil].
	self
		isolate: [t1 := self getShippingAddress.
			t2 := (self useAsBillingAddress: t1)
						ifTrue: [t1]
						ifFalse: [self getBillingAddress].
			t3 := self getPaymentInfo.
			self
				shipTo: t1
				billTo: t2
				payWith: t3].
	self displayConfirmation! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
shipTo: t1 billTo: t2 payWith: t3 
	^ self! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: ''!
useAsBillingAddress: t1 
	^ self confirm: 'Do you wish to use ' , t1 street printString , ' as your billing address?'! !

!WATask methodsFor: 'as yet unclassified' stamp: ''!
decoration: t1 shouldWrap: t2 
	^ (t1 isGlobal
			and: [t2 isGlobal not])
		or: [t1 isLocal
				and: [t2 isDelegation]]! !

!WATask methodsFor: 'as yet unclassified' stamp: ''!
go
	self subclassResponsibility! !

!WATask methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	self session
		redirectTo: (t1
				urlForAction: [[self answer: self go] repeat])! !

WATask subclass: #WATool
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WATool subclass: #WAMemoryUseTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: ''!
linkText
	^ 'Memory Use'! !

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'Memory Use'! !

!WAMemoryUseTool methodsFor: 'as yet unclassified' stamp: ''!
go
	self
		call: (WAMemoryUse new root: self session)! !

WATool subclass: #WAProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: ''!
linkText
	^ 'Profile'! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ 'Profiler'! !

!WAProfilerTool methodsFor: 'as yet unclassified' stamp: ''!
go
	self
		call: (WAProfiler new contents: root)! !

!WATool class methodsFor: 'as yet unclassified' stamp: ''!
linkText
	^ self name! !

!WATool class methodsFor: 'as yet unclassified' stamp: ''!
title
	^ self name! !

!WATool methodsFor: 'as yet unclassified' stamp: ''!
root: t1 
	root := t1! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATransactionTest methodsFor: 'as yet unclassified' stamp: ''!
go
	self inform: 'Before parent txn'.
	self
		isolate: [self inform: 'Inside parent txn'.
			self
				isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

WAComponent subclass: #WATaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATaskTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [self call: WAExceptionTest new]
		text: 'go'! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATrail class methodsFor: 'as yet unclassified' stamp: ''!
on: t1 
	^ self new root: t1! !

!WATrail methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	| t2 t3 |
	t1 cssClass: 'trail'.
	t1
		unorderedList: [root
				visiblePresentersDo: [:t4 | (t4 isDecoration
							and: [t4 isDelegation])
						ifTrue: [(t4 component respondsTo: #trailName)
								ifTrue: [t2 := t4.
									t1
										listItem: [t1
												anchorWithAction: [t4 remove]
												text: t4 component trailName]]]].
			t3 := t2
						ifNil: [root]
						ifNotNil: [t2 delegate].
			(t3 respondsTo: #trailName)
				ifTrue: [t1 listItem: t3 trailName]]! !

!WATrail methodsFor: 'as yet unclassified' stamp: ''!
root: t1 
	root := t1! !

!WATrail methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}
	
	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }
        
	ul.trail li.first:before {
        content: " ";
        }
'! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATree class methodsFor: 'examples' stamp: ''!
example
	| t1 |
	^ (t1 := self new) root: Object;
		
		labelBlock: [:t2 | t2 name];
		
		childrenBlock: [:t2 | t2 subclasses];
		
		selectBlock: [:t2 | t1
				call: (WABrowser fullOnClass: t2)];
		
		canSelectBlock: [:t2 | t2 category
				beginsWith: (self category copyUpTo: $-)];
		 yourself! !

!WATree class methodsFor: 'instance creation' stamp: ''!
root: t1 selected: t2 
	^ self new root: t1;
		 selected: t2;
		
		expandAll: (t2 isNil
				ifTrue: [Array new]
				ifFalse: [t2 parents]);
		
		childrenBlock: [:t3 | t3 hasChildren
				ifTrue: [t3 children sorted]];
		 yourself! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
canSelectBlock
	^ canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
canSelectBlock: t1 
	canSelectBlock := t1! !

!WATree methodsFor: 'testing' stamp: ''!
canSelect: t1 
	^ self selectBlock notNil
		and: [self canSelectBlock isNil
				or: [self canSelectBlock value: t1]]! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
childrenBlock
	^ childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
childrenBlock: t1 
	childrenBlock := t1! !

!WATree methodsFor: 'accessing-nodes' stamp: ''!
childrenOf: t1 
	| t2 |
	t2 := self childrenBlock value: t1.
	^ t2 isNil
		ifTrue: [Array new]
		ifFalse: [t2]! !

!WATree methodsFor: 'actions' stamp: ''!
collapse: t1 
	expanded remove: t1! !

!WATree methodsFor: 'actions' stamp: ''!
expandAll: t1 
	expanded addAll: t1! !

!WATree methodsFor: 'actions' stamp: ''!
expand: t1 
	expanded add: t1! !

!WATree methodsFor: 'testing' stamp: ''!
hasChildren: t1 
	^ (self childrenOf: t1) isEmpty not! !

!WATree methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := Set new).
	self
		selectBlock: [:t1 | self answer: t1].
	self
		childrenBlock: [:t1 | Array new].
	self
		labelBlock: [:t1 | t1 asLabel]! !

!WATree methodsFor: 'testing' stamp: ''!
isExpanded: t1 
	^ expanded includes: t1! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
labelBlock
	^ labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
labelBlock: t1 
	labelBlock := t1! !

!WATree methodsFor: 'accessing-nodes' stamp: ''!
labelOf: t1 
	^ self labelBlock value: t1! !

!WATree methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	self renderTreeOn: t1! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNodeButtonLink: t1 action: t2 text: t3 on: t4 
	t4 anchorWithAction: t2 text: t3! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNodeButton: t1 on: t2 
	| t3 |
	t2
		spanClass: 'button'
		with: [(self hasChildren: t1)
				ifTrue: [t3 := self isExpanded: t1.
					self
						renderNodeButtonLink: t1
						action: (MessageSend
								receiver: self
								selector: (t3
										ifTrue: [#collapse:]
										ifFalse: [#expand:])
								argument: t1)
						text: (t3
								ifTrue: ['-']
								ifFalse: ['+'])
						on: t2]]! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNodeChildren: t1 on: t2 
	| t3 |
	t3 := self childrenOf: t1.
	t3 isEmpty
		ifFalse: [(self isExpanded: t1)
				ifTrue: [t2
						unorderedList: [t3
								do: [:t4 | self renderNode: t4 on: t2]]]]! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNodeLabelLink: t1 action: t2 text: t3 on: t4 
	t4 anchorWithAction: t2 text: t3! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNodeLabel: t1 on: t2 
	| t3 |
	self selected = t1
		ifTrue: [t2 cssClass: 'active'].
	t2
		spanClass: 'label'
		with: [t3 := self labelOf: t1.
			(self canSelect: t1)
				ifTrue: [self
						renderNodeLabelLink: t1
						action: (MessageSend
								receiver: self
								selector: #select:
								argument: t1)
						text: t3
						on: t2]
				ifFalse: [t2 render: t3]]! !

!WATree methodsFor: 'rendering-nodes' stamp: ''!
renderNode: t1 on: t2 
	t2
		listItem: [self renderNodeButton: t1 on: t2.
			self renderNodeLabel: t1 on: t2.
			self renderNodeChildren: t1 on: t2]! !

!WATree methodsFor: 'rendering' stamp: ''!
renderTreeOn: t1 
	t1
		unorderedList: [self renderNode: self root on: t1]! !

!WATree methodsFor: 'accessing' stamp: ''!
root
	^ root! !

!WATree methodsFor: 'accessing' stamp: ''!
root: t1 
	root := t1! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
selectBlock
	^ selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: ''!
selectBlock: t1 
	selectBlock := t1! !

!WATree methodsFor: 'accessing' stamp: ''!
selected
	^ selected! !

!WATree methodsFor: 'accessing' stamp: ''!
selected: t1 
	selected := t1! !

!WATree methodsFor: 'actions' stamp: ''!
select: t1 
	(self canSelect: t1)
		ifTrue: [self selected: t1.
			self selectBlock isNil
				ifFalse: [self selectBlock value: t1]]! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAUploadTest methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: 'Upload File'.
	t1 attributeAt: 'enctype' put: 'multipart/form-data'.
	t1
		form: [t1
				fileUploadWithCallback: [:t2 | file := t2].
			t1 submitButton].
	file
		ifNotNil: [t1
				anchorWithDocument: file contents
				mimeType: file contentType
				fileName: file fileName
				text: file fileName.
			t1 preformatted: file contents contents]! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVersionUploader class methodsFor: 'as yet unclassified' stamp: ''!
canBeRoot
	^ true! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: ''!
loadFile
	| t1 t2 |
	t1 := MCVersionReader readerClassForFileNamed: file fileName.
	t1
		ifNil: [self inform: file fileName , ' is not in a known format'].
	t2 := t1 versionFromStream: file contents asByteArray readStream.
	t2 load! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: ''!
loadURL
	| t1 t2 |
	t1 := url asUrl retrieveContents content asByteArray readStream.
	t2 := (MCVersionReader readerClassForFileNamed: url)
				versionFromStream: t1.
	t2 load! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: ''!
newVersion: t1 
	| t2 t3 |
	t2 := [t1 newVersion]
				on: MCVersionNameAndMessageRequest
				do: [:t4 | t4
						resume: (Array with: t4 suggestedName with: '')].
	t3 := RWBinaryOrTextStream on: String new.
	t2 fileOutOn: t3.
	self session
		respond: [:t5 | 
			t5 addToPath: t2 fileName.
			WAResponse redirectTo: t5 asString].
	self session returnResponse: (WAResponse new contentType: 'application/octet-stream';
			 nextPutAll: t3 contents;
			 yourself)! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 bold: 'Loaded versions:'.
	t1
		list: MCWorkingCopy allManagers
		do: [:t2 | 
			t1
				anchorWithAction: [self newVersion: t2]
				text: 'Save'.
			t1 space.
			t1 text: t2 description].
	t1 attributeAt: 'enctype' put: 'multipart/form-data'.
	t1
		form: [t1 bold: 'Load version from file: ';
				 break.
			t1
				fileUploadWithCallback: [:t3 | file := t3].
			t1 space.
			t1
				submitButtonWithAction: [self loadFile]
				text: 'Load'].
	t1
		form: [t1 bold: 'Load version from URL: ';
				 break.
			t1 attributes size: 60.
			t1
				textInputWithValue: 'http://'
				callback: [:t4 | url := t4].
			t1 space.
			t1
				submitButtonWithAction: [self loadURL]
				text: 'Load'].
	t1
		anchorWithAction: [self saveImage]
		text: 'Save Image'! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: ''!
saveImage
	Smalltalk snapshot: true andQuit: false! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
debug
	self answer! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
exception: t1 
	exception := t1! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		anchorWithAction: [self debug]
		text: 'Debug'.
	self renderWalkbackOn: t1! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
renderObject: t1 labelled: t2 on: t3 
	| t4 |
	[t4 := (SeasidePlatformSupport isProxy: t1)
				ifTrue: [t1 printString]
				ifFalse: [t1 printStringLimitedTo: 100]]
		on: Error
		do: [:t5 | t4 := '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	t3 tableRowWithLabel: t2 column: t4! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
renderStackFrame: t1 on: t2 
	| t3 |
	t2
		listItem: [t2 text: t1 fullPrintString.
			t2
				blockquote: [t2
						table: [t3 := t1 receiver.
							self
								renderObject: t3
								labelled: 'self'
								on: t2.
							t2
								tableRowWith: [t2 bold: 'temps']
								span: 2.
							t1 tempNames
								withIndexDo: [:t4 :t5 | self
										renderObject: (t1 tempAt: t5)
										labelled: t4
										on: t2].
							t3 isNil
								ifFalse: [((SeasidePlatformSupport isProxy: t3) not
											and: [t3 class instSize > 0])
										ifTrue: [t2
												tableRowWith: [t2 bold: 'inst vars']
												span: 2.
											t3 class allInstVarNames
												withIndexDo: [:t4 :t5 | self
														renderObject: (t3 instVarAt: t5)
														labelled: t4
														on: t2]]]]]]! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: ''!
renderWalkbackOn: t1 
	| t2 |
	t1 heading: exception description.
	t1
		unorderedList: [t2 := thisContext.
			[t2 receiver isKindOf: Exception]
				whileFalse: [t2 := t2 sender].
			[t2 receiver isKindOf: Exception]
				whileTrue: [t2 := t2 sender].
			[t2 notNil]
				whileTrue: [self renderStackFrame: t2 on: t1.
					t2 := t2 sender].
			nil]! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'event block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerHandler methodsFor: 'as yet unclassified' stamp: ''!
block: t1 
	block := t1! !

!WAAnswerHandler methodsFor: 'as yet unclassified' stamp: ''!
handleAnswer: t1 continueWith: t2 
	block value: t1! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
authenticator: t1 
	authenticator := t1! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
processChildCallbacks: t1 
	(self verifyRequest: self session currentRequest)
		ifTrue: [super processChildCallbacks: t1]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
realm
	^ realm
		ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
realm: t1 
	realm := t1! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	(self verifyRequest: t1 request)
		ifTrue: [self renderOwnerOn: t1]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
respondWithChallenge
	self session
		returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: ''!
verifyRequest: t1 
	^ authenticator verifyPassword: t1 password forUser: t1 user! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
handleAnswer: t1 
	(self owner handleAnswer: t1)
		ifFalse: [self
				handleAnswer: t1
				continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
handleAnswer: t1 continueWith: t2 
	t2 value! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
isDecoration
	^ true! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
isDelegation
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
isGlobal
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
isLocal
	^ (self isGlobal
		or: [self isDelegation]) not! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
nextPresentersDo: t1 
	t1 value: self owner! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ next
		ifNotNil: [next contents]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	next
		ifNil: [next := WAStateHolder new].
	next contents: t1! !

!WADecoration methodsFor: 'as yet unclassified' stamp: ''!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: ''!
renderOwnerOn: t1 
	self owner
		ifNotNilDo: [:t2 | t2 renderWithContext: t1 context]! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'as yet unclassified' stamp: ''!
delegate
	^ delegate! !

!WADelegation methodsFor: 'as yet unclassified' stamp: ''!
delegate: t1 
	delegate := t1! !

!WADelegation methodsFor: 'as yet unclassified' stamp: ''!
isDelegation
	^ true! !

!WADelegation methodsFor: 'as yet unclassified' stamp: ''!
nextPresentersDo: t1 
	delegate decorationChainDo: t1! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: ''!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: ''!
buttons: t1 
	buttons := t1! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderButtonForSelector: t1 on: t2 
	t2 submitButtonOn: t1 of: self owner! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderButtonsOn: t1 
	t1
		divClass: 'dialog-buttons'
		with: [self buttons
				do: [:t2 | t1
						spanNamed: t2
						with: [self renderButtonForSelector: t2 on: t1]]]! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		form: [self renderOwnerOn: t1.
			self renderButtonsOn: t1]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: ''!
message: t1 
	message := t1! !

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1 heading: message level: 3.
	self renderOwnerOn: t1! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WASessionProtector methodsFor: 'testing' stamp: ''!
isGlobal
	^ true! !

!WASessionProtector methodsFor: 'forwarding' stamp: ''!
processChildCallbacks: t1 
	(self verifyRequest: self session currentRequest)
		ifTrue: [super processChildCallbacks: t1]
		ifFalse: [self respondNotVerified]! !

!WASessionProtector methodsFor: 'accessing' stamp: ''!
remoteAddressFromRequest: t1 
	^ t1
		headerAt: 'x-forwarded-for'
		ifAbsent: [t1 nativeRequest remoteAddress]! !

!WASessionProtector methodsFor: 'forwarding' stamp: ''!
renderContentOn: t1 
	(self verifyRequest: t1 request)
		ifTrue: [self renderOwnerOn: t1]
		ifFalse: [self respondNotVerified]! !

!WASessionProtector methodsFor: 'forwarding' stamp: ''!
respondNotVerified
	self session redirectTo: self session application basePath! !

!WASessionProtector methodsFor: 'accessing' stamp: ''!
storedRemoteAddress
	remoteAddress isNil
		ifTrue: [remoteAddress := self remoteAddressFromRequest: self session currentRequest].
	^ remoteAddress! !

!WASessionProtector methodsFor: 'testing' stamp: ''!
verifyRequest: t1 
	^ (self remoteAddressFromRequest: t1)
		= self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WATransaction methodsFor: 'as yet unclassified' stamp: ''!
close
	active := false! !

!WATransaction methodsFor: 'as yet unclassified' stamp: ''!
initialize
	active := true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: ''!
isGlobal
	^ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: ''!
processChildCallbacks: t1 
	^ active
		ifTrue: [super processChildCallbacks: t1]
		ifFalse: [self session pageExpired]! !

!WATransaction methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	active
		ifTrue: [self renderOwnerOn: t1]
		ifFalse: [self session pageExpired]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
handleAnswer: t1 
	(super handleAnswer: t1)
		ifFalse: [^ (self validate: t1) not].
	^ true! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
handleAnswer: t1 continueWith: t2 
	(self validate: t1)
		ifTrue: [t2 value]! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
initialize
	message := WAStateHolder new! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	message contents
		ifNotNilDo: [:t2 | t1 divClass: 'validation-error' with: t2].
	self renderOwnerOn: t1! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
validateWith: t1 
	validationBlock := t1! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: ''!
validate: t1 
	[validationBlock value: t1.
	^ true]
		on: Error
		do: [:t2 | message contents: t2 messageText].
	^ false! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: ''!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderCloseButtonOn: t1 
	t1
		anchorWithAction: [self component answer]
		text: 'close'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: ''!
renderContentOn: t1 
	t1
		divClass: 'window-titlebar'
		with: [t1
				spanClass: 'window-close'
				with: [self renderCloseButtonOn: t1].
			t1 spanClass: 'window-title' with: title].
	t1
		divClass: 'window-content'
		with: [self renderOwnerOn: t1]! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: ''!
style
	^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: ''!
title: t1 
	title := t1! !

!WAPresenter class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'initialization' stamp: ''!
initialize
	^ self! !

!WAPresenter methodsFor: 'decoration' stamp: ''!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: ''!
nextPresentersDo: t1 
	self subclassResponsibility! !

!WAPresenter methodsFor: 'request processing' stamp: ''!
processCallbackStream: t1 
	t1 processCallbacksWithOwner: self.
	self processChildCallbacks: t1.
	t1 processCallbacksWithOwner: self! !

!WAPresenter methodsFor: 'request processing' stamp: ''!
processChildCallbacks: t1 
	self
		nextPresentersDo: [:t2 | t2 processCallbackStream: t1]! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
renderContentOn: t1 
	self
		nextPresentersDo: [:t2 | t2 renderWithContext: t1 context]! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
rendererClass
	^ WAHtmlRenderer! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
renderWithContext: t1 
	| t2 t3 |
	t3 := t1 callbacksFor: self.
	t2 := self rendererClass context: t1 callbacks: t3.
	(self showHalo
			and: [t1 isDebugMode])
		ifTrue: [(WAHalo for: self)
				renderContentOn: t2]
		ifFalse: [self renderContentOn: t2].
	t2 close! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
script
	^ nil! !

!WAPresenter methodsFor: 'convenience' stamp: ''!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
showHalo
	^ true! !

!WAPresenter methodsFor: 'rendering' stamp: ''!
style
	^ nil! !

!WAPresenter methodsFor: 'path' stamp: ''!
updateRoot: t1 
	self script
		ifNotNilDo: [:t2 | t1 addScript: t2].
	self style
		ifNotNilDo: [:t3 | t1 addStyle: t3]! !

!WAPresenter methodsFor: 'path' stamp: ''!
updateUrl: t1 
	^ self! !

!WAPresenter methodsFor: 'tree' stamp: ''!
withNextPresentersDo: t1 
	t1 value: self.
	self
		nextPresentersDo: [:t2 | t2 withNextPresentersDo: t1]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'timeout responseSem mutex process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAProcessMonitor class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: ''!
critical: t1 ifError: t2 
	| t3 |
	mutex
		critical: [responseSem := Semaphore new.
			process := [[t3 := t1 on: Error do: t2]
						ensure: [responseSem signal]] fork.
			responseSem wait].
	process := nil.
	^ t3! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: ''!
initialize
	timeout := 5.
	mutex := Semaphore forMutualExclusion! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: ''!
terminate
	process
		ifNotNil: [process terminate]! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: ''!
timeout
	^ timeout! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: ''!
timeoutSeconds: t1 
	timeout := t1! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderingContext class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
actionUrl
	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
actionUrl: t1 
	actionUrl := t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
advanceKey
	| t1 |
	t1 := self nextKey.
	self increaseKey.
	^ t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
callbackAt: t1 
	^ callbacks at: t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
callbackStreamForRequest: t1 
	^ WACallbackStream callbacks: callbacks request: t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
callbacksFor: t1 
	^ WACallbackRegistry context: self owner: t1! !

!WARenderingContext methodsFor: 'modes' stamp: ''!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'modes' stamp: ''!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
document
	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
document: t1 
	document := t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
increaseKey
	count := count + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: ''!
initialize
	count := 1.
	callbacks := Dictionary new! !

!WARenderingContext methodsFor: 'modes' stamp: ''!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
nextKey
	^ count asString! !

!WARenderingContext methodsFor: 'documents' stamp: ''!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
request: t1 
	request := t1! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: ''!
response: t1 
	response := t1! !

!WARenderingContext methodsFor: 'callbacks' stamp: ''!
storeCallback: t1 
	| t2 |
	t2 := self advanceKey.
	callbacks
		at: (t1 convertKey: t2)
		put: t1.
	^ t2! !

!WARenderingContext methodsFor: 'documents' stamp: ''!
urlForDocument: t1 
	^ self urlForDocument: t1 mimeType: nil! !

!WARenderingContext methodsFor: 'documents' stamp: ''!
urlForDocument: t1 mimeType: t2 
	^ self
		urlForDocument: t1
		mimeType: t2
		fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: ''!
urlForDocument: t1 mimeType: t2 fileName: t3 
	^ (self registry
		urlForRequestHandler: (WADocumentHandler
				document: t1
				mimeType: t2
				fileName: t3)) asString! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'rendering' stamp: ''!
alwaysRedirect
	^ self application preferenceAt: #alwaysRedirect! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: ''!
application
	^ self session application! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: ''!
basicRoot: t1 
	root := t1! !

!WARenderLoop methodsFor: 'call' stamp: ''!
call: t1 
	^ self call: t1 withToolFrame: true! !

!WARenderLoop methodsFor: 'call' stamp: ''!
call: t1 withToolFrame: t2 
	t2
		ifTrue: [self root: t1]
		ifFalse: [self basicRoot: t1].
	t1
		onAnswer: [:t3 | ^ t3].
	self run! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
processCallbacks: t1 
	| t2 |
	t2 := nil.
	[t1 position = t2]
		whileFalse: [t2 := t1 position.
			root
				decorationChainDo: [:t3 | t3 processCallbackStream: t1]].
	t1 atEnd
		ifTrue: [WARenderNotification raiseSignal]
		ifFalse: [self unprocessedCallbacks: t1 upToEnd]! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
redirect
	self alwaysRedirect
		ifTrue: [self session
				respond: [:t1 | 
					self updateUrl: t1.
					WAResponse redirectTo: t1 asString]]! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
render
	| t1 t2 t3 t4 t6 |
	t2 := WARenderingContext new request: self session currentRequest.
	t1 := self session
				respond: [:t5 | 
					self updateUrl: t5.
					t4 := WARenderedHtmlRoot context: t2.
					root
						visiblePresentersDo: [:t7 | t7 updateRoot: t4].
					self session application updateRoot: t4.
					t6 := WAResponse new.
					t6 headerAt: 'Cache-Control' put: 'No-cache'.
					t3 := WAHtmlStreamDocument root: t4.
					t3 stream: t6 stream.
					t2 actionUrl: t5;
						 document: t3.
					root
						decorationChainDo: [:t7 | t7 renderWithContext: t2].
					t3 close.
					t6].
	self
		processCallbacks: (t2 callbackStreamForRequest: t1)! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: ''!
root: t1 
	self
		basicRoot: ((self application preferenceAt: #deploymentMode)
				ifTrue: [t1]
				ifFalse: [WAToolFrame on: t1])! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
run
	| t1 |
	[self
		withPageExpiredHandler: [t1 := self
						withRenderNowHandler: [self render].
			t1 shouldRedirect
				ifTrue: [self redirect]]] repeat! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: ''!
session
	^ WACurrentSession value! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
unprocessedCallbacks: t1 
	| t2 |
	t2 := (t1
				collect: [:t3 | t3 owner]) asSet asArray.
	self error: 'Components not found while processing callbacks: ' , t2 asString! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
updateUrl: t1 
	root
		visiblePresentersDo: [:t2 | t2 updateUrl: t1]! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
withPageExpiredHandler: t1 
	^ t1
		on: WAPageExpired
		do: [:t2 | t2]! !

!WARenderLoop methodsFor: 'rendering' stamp: ''!
withRenderNowHandler: t1 
	^ t1
		on: WARenderNotification
		do: [:t2 | t2]! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: ''!
selector: t1 
	^ self selector: t1 title: t1 capitalized! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: ''!
selector: t1 title: t2 
	^ self
		selector: t1
		title: t2
		onClick: nil! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: ''!
selector: t1 title: t2 onClick: t3 
	^ self new title: t2;
		 selector: t1;
		 clickBlock: t3! !

!WAReportColumn methodsFor: 'public' stamp: ''!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: ''!
canSort
	^ sortBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: ''!
chooseRow: t1 
	^ clickBlock value: t1! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
clickBlock: t1 
	clickBlock := t1! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
columnClickBlock: t1 
	self
		clickBlock: [:t2 | t1
				value: (self valueForRow: t2)]! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
formatBlock: t1 
	formatBlock := t1! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
hasTotal: t1 
	hasTotal := t1! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
index: t1 
	valueBlock := [:t2 | t2 at: t1]! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
initialize
	formatBlock := [:t1 | t1 asString].
	sortBlock := [:t2 :t3 | t2 <= t3].
	valueBlock := [:t4 | nil].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
selector: t1 
	valueBlock := [:t2 | t2 perform: t1]! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
sortBlock: t1 
	sortBlock := t1! !

!WAReportColumn methodsFor: 'public' stamp: ''!
sortRows: t1 
	| t2 |
	t2 := t1
				collect: [:t3 | t3
						-> (self valueForRow: t3)].
	t2 := t2
				asSortedCollection: [:t4 :t5 | sortBlock value: t4 value value: t5 value].
	^ t2
		collect: [:t3 | t3 key]! !

!WAReportColumn methodsFor: 'public' stamp: ''!
textForRow: t1 
	^ formatBlock
		value: (self valueForRow: t1)! !

!WAReportColumn methodsFor: 'public' stamp: ''!
title
	^ title! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
title: t1 
	title := t1! !

!WAReportColumn methodsFor: 'public' stamp: ''!
totalForRows: t1 
	^ hasTotal
		ifTrue: [formatBlock
				value: (t1
						detectSum: [:t2 | self valueForRow: t2])]
		ifFalse: ['']! !

!WAReportColumn methodsFor: 'accessing' stamp: ''!
valueBlock: t1 
	valueBlock := t1! !

!WAReportColumn methodsFor: 'public' stamp: ''!
valueForRow: t1 
	^ valueBlock value: t1! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WARequest class methodsFor: 'as yet unclassified' stamp: ''!
method: t1 url: t2 headers: t3 fields: t4 cookies: t5 
	^ self new
		setMethod: t1
		url: t2
		headers: t3
		fields: t4
		cookies: t5! !

!WARequest class methodsFor: 'as yet unclassified' stamp: ''!
method: t1 url: t2 headers: t3 fields: t4 cookies: t5 nativeRequest: t6 
	^ (self
		method: t1
		url: t2
		headers: t3
		fields: t4
		cookies: t5) nativeRequest: t6;
		 yourself! !

!WARequest methodsFor: 'accessing' stamp: ''!
at: t1 
	^ fields at: t1! !

!WARequest methodsFor: 'accessing' stamp: ''!
at: t1 ifAbsent: t2 
	^ fields at: t1 ifAbsent: t2! !

!WARequest methodsFor: 'private' stamp: ''!
authorization
	^ (self
		headerAt: 'Authorization'
		ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:t1 | self decodeAuthorization: t1]! !

!WARequest methodsFor: 'accessing' stamp: ''!
cookies
	^ cookies! !

!WARequest methodsFor: 'private' stamp: ''!
decodeAuthorization: t1 
	^ SeasidePlatformSupport base64Decode: (t1 findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: ''!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: ''!
headerAt: t1 
	^ self
		headerAt: t1
		ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: ''!
headerAt: t1 ifAbsent: t2 
	^ headers at: t1 ifAbsent: t2! !

!WARequest methodsFor: 'accessing' stamp: ''!
headers
	^ headers! !

!WARequest methodsFor: 'testing' stamp: ''!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'accessing' stamp: ''!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: ''!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: ''!
nativeRequest: t1 
	nativeRequest := t1! !

!WARequest methodsFor: 'accessing' stamp: ''!
password
	^ self authorization
		ifNotNilDo: [:t1 | t1 copyAfter: $:]! !

!WARequest methodsFor: 'private' stamp: ''!
setMethod: t1 url: t2 headers: t3 fields: t4 cookies: t5 
	method := t1.
	url := t2.
	headers := t3.
	fields := t4.
	cookies := t5! !

!WARequest methodsFor: 'accessing' stamp: ''!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: ''!
user
	^ self authorization
		ifNotNilDo: [:t1 | t1 copyUpTo: $:]! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WADocumentHandler class methodsFor: 'as yet unclassified' stamp: ''!
document: t1 mimeType: t2 fileName: t3 
	^ self basicNew
		initializeWithDocument: t1
		mimeType: t2
		fileName: t3! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
document
	^ document! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
handleRequest: t1 
	^ self response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
initializeWithDocument: t1 mimeType: t2 fileName: t3 
	document := t1.
	mimeType := t2.
	fileName := t3! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
isActive
	^ true! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
mimeDocument
	^ mimeDocument
		ifNil: [mimeDocument := document asMIMEDocument]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
response
	| t1 |
	t1 := WAResponse new.
	t1 contents: self mimeDocument contentStream text.
	t1
		contentType: (mimeType
				ifNil: [self mimeDocument contentType]).
	t1 headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName
		ifNotNil: [t1 headerAt: 'Content-Disposition' put: 'attachment; filename=' , fileName].
	^ t1! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: ''!
= t1 
	^ (t1 species = self species
			and: [t1 document = self document])
		and: [t1 mimeType = self mimeType]! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'as yet unclassified' stamp: ''!
default
	default
		ifNil: [default := self new].
	default basePath
		ifNil: [default basePath: '/seaside'].
	^ default! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'Subdirectory'! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WADispatcher methodsFor: 'public' stamp: ''!
basePath: t1 
	| t2 |
	basePath := t1.
	t2 := (t1 isEmpty
					or: [t1 last ~= $/])
				ifTrue: [t1 , '/']
				ifFalse: [t1].
	entryPoints
		keysAndValuesDo: [:t3 :t4 | t4 basePath: t2 , t3]! !

!WADispatcher methodsFor: 'public' stamp: ''!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher methodsFor: 'public' stamp: ''!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'public' stamp: ''!
handleRequest: t1 
	^ (self handlerForRequest: t1)
		handleRequest: t1! !

!WADispatcher methodsFor: 'private' stamp: ''!
handlerForRequest: t1 
	^ self handlerForRequest: t1 relativeTo: basePath! !

!WADispatcher methodsFor: 'private' stamp: ''!
handlerForRequest: t1 relativeTo: t2 
	| t3 t4 t5 |
	t3 := t1 url.
	(t3 beginsWith: t2)
		ifTrue: [t5 := t3 allButFirst: t2 size.
			(t5 notEmpty
					and: [t5 first = $/])
				ifTrue: [t4 := (t5 findTokens: '/')
								at: 1
								ifAbsent: []].
			entryPoints
				at: t4
				ifPresent: [:t6 | ^ t6]].
	^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'private' stamp: ''!
initialize
	entryPoints := Dictionary new! !

!WADispatcher methodsFor: 'public' stamp: ''!
registerEntryPoint: t1 at: t2 
	| t3 |
	entryPoints at: t2 asString put: t1.
	t3 := (basePath isEmpty
					or: [basePath last ~= $/])
				ifTrue: [basePath , '/' , t2]
				ifFalse: [basePath , t2].
	t1 basePath: t3! !

!WADispatcher methodsFor: 'public' stamp: ''!
removeEntryPoint: t1 
	entryPoints
		removeKey: (entryPoints keyAtValue: t1)! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: ''!
concreteSubclasses
	^ self allSubclasses
		reject: [:t1 | t1 isAbstract]! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self description isNil! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: ''!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: ''!
basePath: t1 
	basePath := t1! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: ''!
baseUrl
	^ WAUrl new addToPath: basePath;
		 yourself! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: ''!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: '(' , self basePath , ')'! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration libraries sessionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAApplication class methodsFor: 'as yet unclassified' stamp: ''!
description
	^ 'Seaside Application'! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: ''!
path: t1 
	^ self new basePath: t1! !

!WAApplication methodsFor: 'accessing' stamp: ''!
baseUrl
	^ super baseUrl
		port: (self preferenceAt: #serverPort);
		
		hostname: (self preferenceAt: #serverHostname);
		
		scheme: (self preferenceAt: #serverProtocol);
		 yourself! !

!WAApplication methodsFor: 'preferences' stamp: ''!
configuration
	^ configuration
		ifNil: [configuration := WAUserConfiguration new addAncestor: self defaultAncestor]! !

!WAApplication methodsFor: 'accessing' stamp: ''!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: ''!
defaultAncestor
	^ WARenderLoopConfiguration localConfiguration! !

!WAApplication methodsFor: 'accessing' stamp: ''!
defaultLibraries
	^ Array with: WAStandardScripts with: WAStandardStyles! !

!WAApplication methodsFor: 'request handling' stamp: ''!
handleDefaultRequest: t1 
	| t2 |
	t2 := self sessionClass application: self.
	^ t2 handleRequest: t1! !

!WAApplication methodsFor: 'accessing' stamp: ''!
libraries
	^ libraries
		ifNil: [libraries := OrderedCollection withAll: self defaultLibraries]! !

!WAApplication methodsFor: 'accessing' stamp: ''!
name
	| t1 |
	t1 := basePath findTokens: '/'.
	^ t1 isEmpty
		ifTrue: ['']
		ifFalse: [t1 last]! !

!WAApplication methodsFor: 'preferences' stamp: ''!
preferenceAt: t1 
	^ self configuration valueAt: t1! !

!WAApplication methodsFor: 'preferences' stamp: ''!
preferenceAt: t1 put: t2 
	^ self configuration valueAt: t1 put: t2! !

!WAApplication methodsFor: 'basic configuration' stamp: ''!
sessionClass
	^ configuration valueAt: #sessionClass! !

!WAApplication methodsFor: 'request handling' stamp: ''!
updateRoot: t1 
	t1 title = ''
		ifTrue: [t1 title: self basePath].
	self libraries
		do: [:t2 | t2 updateRoot: t1]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: ''!
clearAllHandlers
	self allSubInstances
		do: [:t1 | t1 clearHandlers]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WARegistry methodsFor: 'private' stamp: ''!
clearHandlers
	self mutex
		critical: [handlersByKey := Dictionary new.
			keysByHandler := Dictionary new]! !

!WARegistry methodsFor: 'private' stamp: ''!
handleDefaultRequest: t1 
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: ''!
handleExpiredRequest: t1 
	| t2 |
	t2 := WAUrl new.
	t2 addToPath: t1 url.
	t1 isGet
		ifTrue: [t1 fields
				keysAndValuesDo: [:t3 :t4 | (self isSeasideField: t3)
						ifFalse: [t2 addParameter: t3 value: t4]]].
	^ WAResponse
		refreshWithMessage: 'That page has expired.'
		location: t2 asString
		delay: 3! !

!WARegistry methodsFor: 'private' stamp: ''!
handleKeyRequest: t1 
	| t2 t3 |
	t2 := [WAExternalID
				fromString: (t1 at: self handlerField)]
				on: Error
				do: [:t4 | nil].
	t3 := handlersByKey
				at: t2
				ifAbsent: [].
	^ (t3 notNil
			and: [t3 isActive])
		ifTrue: [t3 handleRequest: t1]
		ifFalse: [self handleExpiredRequest: t1]! !

!WARegistry methodsFor: 'public' stamp: ''!
handleRequest: t1 
	^ (t1 fields includesKey: self handlerField)
		ifTrue: [self handleKeyRequest: t1]
		ifFalse: [self handleDefaultRequest: t1]! !

!WARegistry methodsFor: 'private' stamp: ''!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: ''!
initialize
	self clearHandlers! !

!WARegistry methodsFor: 'private' stamp: ''!
isSeasideField: t1 
	^ t1 first = $_! !

!WARegistry methodsFor: 'private' stamp: ''!
keyOrNilForHandler: t1 
	^ self mutex
		critical: [keysByHandler
				at: t1
				ifAbsent: []]! !

!WARegistry methodsFor: 'private' stamp: ''!
mutex
	^ mutex
		ifNil: [mutex := Semaphore forMutualExclusion]! !

!WARegistry methodsFor: 'private' stamp: ''!
registerRequestHandler: t1 
	| t2 |
	t2 := WAExternalID new: 16.
	self shouldCollectHandlers
		ifTrue: [self unregisterExpiredHandlers].
	self mutex
		critical: [handlersByKey at: t2 put: t1.
			keysByHandler at: t1 put: t2].
	^ t2! !

!WARegistry methodsFor: 'private' stamp: ''!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: ''!
unregisterExpiredHandlers
	| t1 t2 t3 |
	self mutex
		critical: [t1 := OrderedCollection new.
			t2 := Dictionary new.
			handlersByKey
				associationsDo: [:t4 | t4 value isActive
						ifTrue: [t2 add: t4]
						ifFalse: [t1 add: t4 value]].
			t3 := Dictionary new.
			keysByHandler
				associationsDo: [:t4 | (t2 includesKey: t4 value)
						ifTrue: [t3 add: t4]].
			handlersByKey := t2.
			keysByHandler := t3].
	t1
		do: [:t5 | [t5 unregistered] fixTemps fork]! !

!WARegistry methodsFor: 'public' stamp: ''!
urlForRequestHandler: t1 
	| t2 t3 |
	t2 := (self keyOrNilForHandler: t1)
				ifNil: [self registerRequestHandler: t1].
	t3 := self baseUrl.
	t3 addParameter: self handlerField value: t2 asString.
	^ t3! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
expire
	expired := true! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
expired
	^ expired
		ifNil: [false]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
handleRequest: t1 
	lastAccess := Time totalSeconds.
	^ self incomingRequest: t1! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
incomingRequest: t1 
	self subclassResponsibility! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
isActive
	^ self expired not
		and: [self secondsSinceLastAccess < self timeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
lastAccess
	^ lastAccess
		ifNil: [lastAccess := Time totalSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
timeoutSeconds
	^ timeout
		ifNil: [self defaultTimeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: ''!
timeoutSeconds: t1 
	timeout := t1! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation monitor state currentRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

WASession subclass: #WAExpirySession
	instanceVariableNames: ''
	classVariableNames: 'Created Unregistered'
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: ''!
created
	^ Created! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self resetCounters! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: ''!
resetCounters
	Unregistered := 0.
	Created := 0! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: ''!
unregistered
	^ Unregistered! !

!WAExpirySession methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	Created := Created + 1! !

!WAExpirySession methodsFor: 'as yet unclassified' stamp: ''!
unregistered
	Unregistered := Unregistered + 1! !

!WASession class methodsFor: 'as yet unclassified' stamp: ''!
application: t1 
	^ self basicNew initializeWithApplication: t1! !

!WASession methodsFor: 'request handling' stamp: ''!
actionField
	^ '_k'! !

!WASession methodsFor: 'responding' stamp: ''!
actionUrlForContinuation: t1 
	^ self
		actionUrlForKey: (continuations store: t1)! !

!WASession methodsFor: 'responding' stamp: ''!
actionUrlForKey: t1 
	^ (application urlForRequestHandler: self) addParameter: self actionField value: t1;
		 yourself! !

!WASession methodsFor: 'accessing' stamp: ''!
application
	^ application! !

!WASession methodsFor: 'cookies' stamp: ''!
checkForCookies
	| t1 |
	t1 := WAExternalID new asString.
	self redirectWithCookie: (WACookie new key: t1;
			 value: 'yes';
			
			expireIn: (Duration seconds: 2);
			 yourself).
	^ currentRequest cookies includesKey: t1! !

!WASession methodsFor: 'responding' stamp: ''!
closePopup
	^ self
		respond: [:t1 | WAResponse new nextPutAll: '<html><script>';
				 nextPutAll: 'self.close();';
				 nextPutAll: 'self.opener.location=self.opener.location';
				 nextPutAll: '</script></html>';
				 yourself]! !

!WASession methodsFor: 'responding' stamp: ''!
closePopupAndContinue
	^ self
		respond: [:t1 | WAResponse new nextPutAll: '<html><script>';
				 nextPutAll: 'self.close();';
				 nextPutAll: 'self.opener.location=' , t1 asString printString;
				 nextPutAll: '</script></html>';
				 yourself]! !

!WASession methodsFor: 'request handling' stamp: ''!
currentRequest
	^ currentRequest! !

!WASession methodsFor: 'expiring' stamp: ''!
defaultTimeoutSeconds
	^ (self application preferenceAt: #sessionExpirySeconds)
		ifNil: [super defaultTimeoutSeconds]! !

!WASession methodsFor: 'request handling' stamp: ''!
errorHandler
	^ application preferenceAt: #errorHandler! !

!WASession methodsFor: 'request handling' stamp: ''!
incomingRequest: t1 
	((t1 fields includesKey: 'terminate')
			and: [(self application preferenceAt: #deploymentMode) not])
		ifTrue: [monitor terminate.
			^ WAResponse new nextPutAll: 'Process terminated'].
	^ monitor
		critical: [self responseForRequest: t1]
		ifError: [:t2 | WAResponse internalError: t2]! !

!WASession methodsFor: 'initializing' stamp: ''!
initialize
	^ self! !

!WASession methodsFor: 'initializing' stamp: ''!
initializeWithApplication: t1 
	application := t1.
	continuations := WALRUCache new.
	monitor := WAProcessMonitor new.
	state := WAStateRegistry new.
	self initialize! !

!WASession methodsFor: 'accessing' stamp: ''!
mainClass
	^ application preferenceAt: #mainClass! !

!WASession methodsFor: 'expiring' stamp: ''!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired raiseSignal! !

!WASession methodsFor: 'responding' stamp: ''!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'request handling' stamp: ''!
performRequest: t1 
	| t2 t3 |
	t2 := t1 fields
				at: self actionField
				ifAbsent: [^ self start: t1].
	t3 := continuations
				at: t2
				ifAbsent: [^ self unknownRequest: t1].
	t3 value: t1! !

!WASession methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: '(' , (application urlForRequestHandler: self) asString , ')'! !

!WASession methodsFor: 'responding' stamp: ''!
redirect
	^ self
		respond: [:t1 | WAResponse redirectTo: t1 asString]! !

!WASession methodsFor: 'responding' stamp: ''!
redirectTo: t1 
	self
		returnResponse: (WAResponse redirectTo: t1)! !

!WASession methodsFor: 'cookies' stamp: ''!
redirectWithCookies: t1 
	| t2 |
	self
		respond: [:t3 | 
			t2 := WAResponse redirectTo: t3 asString.
			t1
				do: [:t4 | t2 addCookie: t4].
			t2]! !

!WASession methodsFor: 'cookies' stamp: ''!
redirectWithCookie: t1 
	self
		redirectWithCookies: (Array with: t1)! !

!WASession methodsFor: 'responding' stamp: ''!
redirectWithMessage: t1 delay: t2 
	self
		respond: [:t3 | WAResponse
				refreshWithMessage: t1
				location: t3 asString
				delay: t2]! !

!WASession methodsFor: 'state' stamp: ''!
registerObjectForBacktracking: t1 
	state registerObject: t1! !

!WASession methodsFor: 'responding' stamp: ''!
respond: t1 
	| t2 t3 t4 t5 t8 |
	t3 := ValueHolder new.
	t5 := escapeContinuation.
	escapeContinuation := [:t6 | 
			t3 contents: state snapshot.
			t5 value: t6].
	t2 := ResponseContinuation
				currentDo: [:t7 | 
					t8 := self actionUrlForContinuation: t7.
					t4 := t1 value: t8.
					self returnResponse: t4].
	state restoreSnapshot: t3 contents.
	^ t2! !

!WASession methodsFor: 'request handling' stamp: ''!
responseForRequest: t1 
	currentRequest := t1.
	^ self
		withEscapeContinuation: [WACurrentSession
				use: self
				during: [self
						withErrorHandler: [self performRequest: t1]]]! !

!WASession methodsFor: 'responding' stamp: ''!
returnResponse: t1 
	escapeContinuation value: t1! !

!WASession methodsFor: 'responding' stamp: ''!
script: t1 
	self redirectWithMessage: '<script>' , t1 , '</script>' delay: 0! !

!WASession methodsFor: 'request handling' stamp: ''!
start: t1 
	self mainClass new start: t1! !

!WASession methodsFor: 'request handling' stamp: ''!
unknownRequest: t1 
	self pageExpired! !

!WASession methodsFor: 'request handling' stamp: ''!
withErrorHandler: t1 
	^ [t1
		on: Error
		do: [:t2 | 
			self errorHandler handleError: t2.
			WAPageExpired raiseSignal]]
		on: Warning
		do: [:t3 | 
			self errorHandler handleWarning: t3.
			WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: ''!
withEscapeContinuation: t1 
	^ EscapeContinuation
		currentDo: [:t2 | 
			escapeContinuation := t2.
			t1 value.
			self pageIntentionallyLeftBlank]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WANotFoundHandler methodsFor: 'as yet unclassified' stamp: ''!
handleRequest: t1 
	^ WAResponse notFound: t1 url! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: ''!
handleRequest: t1 
	self subclassResponsibility! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: ''!
isActive
	^ true! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: ''!
unregistered
	^ self! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
basicAuthWithRealm: t1 
	^ self new basicAuthenticationRealm: t1! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
document: t1 mimeType: t2 
	| t3 |
	t3 := t1 asMIMEDocument.
	^ self new
		contentType: (t2
				ifNil: [t3 contentType]);
		 headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		 nextPutAll: t3 content! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
document: t1 mimeType: t2 fileName: t3 
	^ (self document: t1 mimeType: t2) attachmentWithFileName: t3;
		 yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
internalError: t1 
	^ self new internalError; nextPutAll: '<h1> Internal Error</h1>'; nextPutAll: '<h2>'; nextPutAll: t1 asString; nextPutAll: '</h2>'; yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
notFound: t1 
	^ self new notFound; nextPutAll: '<h1> Error: "' , t1 , '" not found. </h1>'; yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
redirectTo: t1 
	^ self new redirectTo: t1! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: ''!
refreshWithMessage: t1 location: t2 delay: t3 
	^ self new nextPutAll: '<html>
			<head>
			<meta http-equiv="refresh" content="' , t3 asString , ';URL=' , t2 , '">
			<title>' , t1 , '</title>
			</head>
			<body>
			<h1>' , t1 , '</h1>
			You are being redirected to <a href="' , t2 , '">' , t2 , '</a>
			</body>
		</html>';
		 yourself! !

!WAResponse methodsFor: 'accessing' stamp: ''!
addCookie: t1 
	cookies
		ifNil: [cookies := OrderedCollection new].
	cookies add: t1! !

!WAResponse methodsFor: 'convenience' stamp: ''!
attachmentWithFileName: t1 
	self headerAt: 'Content-dispostion' put: 'attachment; filename="' , t1 , '"'! !

!WAResponse methodsFor: 'status' stamp: ''!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: ''!
basicAuthenticationRealm: t1 
	self headerAt: 'WWW-Authenticate' put: 'Basic realm="' , t1 , '"'.
	self authenticationFailed! !

!WAResponse methodsFor: 'accessing' stamp: ''!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: ''!
contents: t1 
	stream := t1! !

!WAResponse methodsFor: 'accessing' stamp: ''!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: ''!
contentType: t1 
	contentType := t1! !

!WAResponse methodsFor: 'accessing' stamp: ''!
cookieAt: t1 put: t2 
	self
		addCookie: (WACookie key: t1 value: t2)! !

!WAResponse methodsFor: 'accessing' stamp: ''!
cookies
	^ cookies
		ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: ''!
headerAt: t1 put: t2 
	headers
		ifNil: [headers := OrderedCollection new].
	headers
		add: (Association key: t1 value: t2)! !

!WAResponse methodsFor: 'accessing' stamp: ''!
headers
	^ headers
		ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: ''!
initialize
	stream := SeasidePlatformSupport readWriteStream.
	status := '200'.
	contentType := 'text/html; charset=utf-8'! !

!WAResponse methodsFor: 'status' stamp: ''!
internalError
	self status: 500! !

!WAResponse methodsFor: 'accessing' stamp: ''!
nextPutAll: t1 
	t1
		do: [:t2 | self nextPut: t2]! !

!WAResponse methodsFor: 'accessing' stamp: ''!
nextPut: t1 
	stream nextPut: t1 asCharacter! !

!WAResponse methodsFor: 'status' stamp: ''!
notFound
	self status: 404! !

!WAResponse methodsFor: 'status' stamp: ''!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: ''!
redirectTo: t1 
	self headerAt: 'Location' put: t1.
	self redirect! !

!WAResponse methodsFor: 'accessing' stamp: ''!
release
	stream := cookies := headers := nil! !

!WAResponse methodsFor: 'accessing' stamp: ''!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: ''!
status: t1 
	status := t1 asString! !

!WAResponse methodsFor: 'accessing' stamp: ''!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: ''!
stream: t1 
	stream := t1! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateHolder class methodsFor: 'as yet unclassified' stamp: ''!
new
	| t1 |
	t1 := super new.
	WACurrentSession value registerObjectForBacktracking: t1.
	^ t1! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: ''!
contents
	^ contents! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: ''!
contents: t1 
	contents := t1! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(.
	contents printOn: t1.
	t1 nextPut: $)! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistry class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ super new initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
calculateFootprint
	^ (objects
		detectSum: [:t1 | 2 + t1 class instSize
				+ (t1 class isVariable
						ifTrue: [t1 size + 1]
						ifFalse: [0])])
		* 4! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
initialize
	objects := SeasidePlatformSupport weakDictionaryOfSize: 10! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
registerObject: t1 
	objects at: t1 put: t1 snapshotCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
restoreLastSnapshot
	lastSnapshot
		ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
restoreObject: t1 fromSnapshot: t2 
	t1 restoreFromSnapshot: t2.
	objects at: t1 put: t2! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
restoreSnapshot: t1 
	t1
		keysAndValuesDo: [:t2 :t3 | self restoreObject: t2 fromSnapshot: t3]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
size
	^ objects size! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: ''!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects
		keysAndValuesDo: [:t1 :t2 | (t1 isIdenticalToSnapshot: t2)
				ifTrue: [lastSnapshot at: t1 put: t2]
				ifFalse: [lastSnapshot at: t1 put: t1 snapshotCopy]].
	^ lastSnapshot! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
city
	^ city! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
city: t1 
	city := t1! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
country
	^ country! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
country: t1 
	country := t1! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
street
	^ street! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
street: t1 
	street := t1! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: ''!
validate
	street
		ifNil: [self error: 'You must provide a street address.'].
	city
		ifNil: [self error: 'You must provide a city.'].
	country
		ifNil: [self error: 'You must provide a country.']! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
add: t1 
	items
		ifNil: [items := Bag new].
	items add: t1! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
hasItems
	^ items notNil
		and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
items
	^ items! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
remove: t1 
	items
		remove: t1
		ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: ''!
totalPrice
	^ items
		detectSum: [:t1 | t1 price]! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
expiry
	^ self! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
expiry: t1 
	expiry := t1! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
number
	^ number! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
number: t1 
	number := t1! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: ''!
validate
	name
		ifNil: [self error: 'You must provide the name of the credit card owner.'].
	number
		ifNil: [self error: 'You must provide a credit card number.'].
	expiry
		ifNil: [self error: 'You must provide an expiry date.'].
	expiry < Date today
		ifTrue: [self error: 'The expiry date must not be in the past']! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreMasterCard class methodsFor: 'as yet unclassified' stamp: ''!
abbreviation
	^ 'MC'! !

!WAStoreMasterCard methodsFor: 'as yet unclassified' stamp: ''!
validate
	super validate.
	number first = $5
		ifFalse: [self error: 'Mastercard numbers must start with "5"']! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreVisaCard class methodsFor: 'as yet unclassified' stamp: ''!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'as yet unclassified' stamp: ''!
validate
	super validate.
	number first = $4
		ifFalse: [self error: 'Visa card numbers must start with "4"']! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: ''!
default
	^ default
		ifNil: [default := self new]! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: ''!
allItems
	^ items! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: ''!
findItem: t1 
	^ items
		select: [:t2 | t2 matches: t1]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: ''!
initialize
	items := OrderedCollection new.
	self itemSpecs
		do: [:t1 | items
				add: (self itemFromSpec: t1)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: ''!
itemFromSpec: t1 
	^ WAStoreItem new title: t1 first;
		 subtitle: t1 second;
		 description: t1 third;
		 price: t1 fourth! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: ''!
itemSpecs
	^ #(#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150) #('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275) #('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200) #('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200) #('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250) #('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175) #('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475) #('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225) #('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325) #('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180) #('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250) #('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200) #('Kappa Maki' 'Cucumber Rolls' '' 150) #('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200) #('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250) #('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275) #('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225) #('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300) #('Shiro Maguro' 'Albacore Tuna' '' 300) #('Hamachi' 'Yellowtail' '' 325) #('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275) #('Katsuo' 'Bonito' '' 275) #('Saba' 'Mackerel' '' 200) #('Sake' 'Salmon' '' 250) #('Tai' 'Red Snapper' '' 250) #('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350) #('Suzuki' 'Sea Bass' '' 300) #('Unagi' 'Freshwater Eel' '' 300) #('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325) #('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300) #('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350) #('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300) #('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500) #('Kani' 'Crab' '' 250) #('Ebi' 'Cooked Prawn' '' 225) #('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325) #('Tobiko ' 'Flying-Fish Roe' '' 350) #('Masago ' 'Capelin Roe' '' 350) #('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300) #('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400) )
		asSortedCollection: [:t1 :t2 | t1 first <= t2 first]! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
description: t1 
	description := t1! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
matches: t1 
	^ (title includesSubstring: t1 caseSensitive: false)
		or: [description includesSubstring: t1 caseSensitive: false]! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
price
	^ price! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
price: t1 
	price := t1! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
printString
	^ self title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
subtitle: t1 
	subtitle := t1! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
title
	^ title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: ''!
title: t1 
	title := t1! !

Object subclass: #WAStringLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStringLibrary subclass: #WAScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAScriptLibrary class methodsFor: 'as yet unclassified' stamp: ''!
updateRoot: t1 
	self new
		do: [:t2 | t1 addScript: t2]! !

WAScriptLibrary subclass: #WAStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardScripts methodsFor: 'as yet unclassified ' stamp: ''!
liveUpdate
	^ 'function liveUpdaterUri(uri)
{
    return liveUpdater(function() { return uri; });
}

function addParameter(uri, key, value)
{
	var separator = "?";

	if(uri.indexOf("?") >= 0)
	    separator = "&";
	return uri + separator + key + "=" + escape(value);
}

function liveUpdater(uriFunc)
{
    var request = false;
    var regex = /<(\w+).*?id="(\w+)".*?>((.|\n)*)<\/\1>/;
    
    if (window.XMLHttpRequest) {
       	request = new XMLHttpRequest();
    }
    

    function update()
    {
       if(request && request.readyState < 4)
            request.abort();
            
        if(!!window.XMLHttpRequest)
            request = new ActiveXObject("Microsoft.XMLHTTP");
        
        request.onreadystatechange = processRequestChange;
        request.open("GET", addParameter(uriFunc(), "timestamp", (new Date()).getTime().toString()));
        request.send(null);
        return false;
    }
    
 function processRequestChange()
   {
       if(request.readyState == 4)
       {
           var results = regex.exec(request.responseText);
           if(results) {
               document.getElementById(results[2]).innerHTML =
results[3];
           } else {
                 var bodyRegex = /<body>(.*)?<\/body>/;
                 var body = bodyRegex.exec(request.responseText);
                 if ( body ) {
                     document.body.innerHTML = body[1];
                 } else {
                     document.body.innerHTML = request.responseText;
                 }
           }
       }
   }
    return update;
}

function liveSelect(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).selectedIndex.toString());
	}
	
	return liveUpdater(constructUri); 
}

function liveSearch(id, uri)
{
    function constructUri()
    {
        return addParameter(uri, "s", document.getElementById(id).value);
    }
    
    var updater = liveUpdater(constructUri);
    var last = "";
    var timeout = false;
   
    function update()
    {
       if (last !!= document.getElementById(id).value)
            updater();
    }
        
    function start() {
	   if (timeout)
	       window.clearTimeout(timeout);
	   
    	   timeout = window.setTimeout(update, 300);
    }

	
	if (navigator.userAgent.indexOf("Safari") > 0)
		document.getElementById(id).addEventListener("keydown",start,false);
    else if (navigator.product == "Gecko")
		document.getElementById(id).addEventListener("keypress",start,false);
    else
		document.getElementById(id).attachEvent("onkeydown",start);
}

function timedUpdate(uriFunc, milliSeconds)
{
	var updater = liveUpdaterUri(uriFunc);
	updater();
	var again = "timedUpdate(\""+uriFunc+"\","+milliSeconds+")";
	setTimeout(again, milliSeconds);
}
'! !

!WAStandardScripts methodsFor: 'as yet unclassified' stamp: ''!
misc
	^ 'function swapDisplay(a, b) {
			var tmp = document.getElementById(a).style.display;
			document.getElementById(a).style.display = document.getElementById(b).style.display;
			document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey) {
		var ele = document.createElement("input");
		ele.type = "hidden";
		ele.name = callbackKey;
		document.forms[formName].appendChild(ele);
		document.forms[formName].submit();
	}
'! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: ''!
asString
	^ self class name! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: ''!
at: t1 
	^ self perform: t1! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: ''!
at: t1 put: t2 
	self class compile: t1 , '
	^ ' , t2 printString! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: ''!
do: t1 
	self keys
		do: [:t2 | t1
				value: (self at: t2)]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: ''!
keys
	^ self class selectors
		select: [:t1 | t1 isUnary]! !

WAStringLibrary subclass: #WAStyleLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStyleLibrary subclass: #WAStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: ''!
basics
	^ 'div.clearer {clear: both}'! !

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: ''!
kalseyTabs
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options #option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: ''!
sourceStyle
	^ '
.halo-source .html-source {
	font-family: courier, serif;
	font-size: 9pt;
}

.halo-source .xmlDeclaration {
	color: limegreen;
	font-style: italic;
}

.halo-source .doctype {
	color: skyblue;
	font-style: italic;
}

.halo-source .tag-known {
	color: purple;
	font-weight: bold;
}

.halo-source .attribute-known {
	font-weight: bold;
}

.halo-source .attribute-value {
	color: blue;
}

.halo-source .template {
	color: blue;
	font-weight: bold;
}

'! !

!WAStyleLibrary class methodsFor: 'as yet unclassified' stamp: ''!
updateRoot: t1 
	self new
		do: [:t2 | t1 addStyle: t2]! !

Object subclass: #WAUrl
	instanceVariableNames: 'host port scheme path params fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAUrl class methodsFor: 'as yet unclassified' stamp: ''!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'accessing' stamp: ''!
addParameter: t1 
	self addParameter: t1 value: nil! !

!WAUrl methodsFor: 'accessing' stamp: ''!
addParameter: t1 value: t2 
	params at: t1 put: t2! !

!WAUrl methodsFor: 'accessing' stamp: ''!
addToPath: t1 
	path
		addAll: (t1 findTokens: '/')! !

!WAUrl methodsFor: 'printing' stamp: ''!
asString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'copying' stamp: ''!
copy
	| t1 |
	t1 := self class new.
	t1 hostname: host;
		 port: port;
		 scheme: scheme;
		 fragment: fragment.
	t1 addToPath: self pathString.
	params
		keysAndValuesDo: [:t2 :t3 | t1 addParameter: t2 value: t3].
	^ t1! !

!WAUrl methodsFor: 'private' stamp: ''!
defaultPortForScheme: t1 
	^ t1 = #http
		ifTrue: [80]
		ifFalse: [t1 = #https
				ifTrue: [443]]! !

!WAUrl methodsFor: 'accessing' stamp: ''!
fragment
	^ fragment! !

!WAUrl methodsFor: 'printing' stamp: ''!
fragmentString
	^ fragment
		ifNil: ['']
		ifNotNil: ['#' , fragment]! !

!WAUrl methodsFor: 'accessing' stamp: ''!
fragment: t1 
	fragment := t1! !

!WAUrl methodsFor: 'accessing' stamp: ''!
hostname
	^ host! !

!WAUrl methodsFor: 'accessing' stamp: ''!
hostname: t1 
	host := t1! !

!WAUrl methodsFor: 'initialize-release' stamp: ''!
initialize
	path := OrderedCollection new.
	params := Dictionary new.
	scheme := #http! !

!WAUrl methodsFor: 'accessing' stamp: ''!
parameters
	^ params! !

!WAUrl methodsFor: 'accessing' stamp: ''!
path
	^ path! !

!WAUrl methodsFor: 'printing' stamp: ''!
pathString
	^ String
		streamContents: [:t1 | path
				do: [:t2 | t1 nextPut: $/;
						 nextPutAll: t2]]! !

!WAUrl methodsFor: 'accessing' stamp: ''!
port
	^ port
		ifNil: [self defaultPortForScheme: scheme]! !

!WAUrl methodsFor: 'accessing' stamp: ''!
port: t1 
	port := t1! !

!WAUrl methodsFor: 'accessing' stamp: ''!
scheme
	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: ''!
scheme: t1 
	scheme := t1! !

!WAUrl methodsFor: 'printing' stamp: ''!
serverString
	host
		ifNil: [^ ''].
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: scheme.
			t1 nextPutAll: '://'.
			t1 nextPutAll: host.
			(self defaultPortForScheme: scheme)
					= port
				ifFalse: [t1 nextPutAll: ':' , port asString]]! !

!WAUrl methodsFor: 'printing' stamp: ''!
urlString
	^ self serverString , self pathString , self fragmentString! !

!WAUrl methodsFor: 'printing' stamp: ''!
urlWithQueryString
	^ String
		streamContents: [:t1 | 
			t1 nextPutAll: self serverString.
			t1 nextPutAll: self pathString.
			params isEmpty
				ifFalse: [t1 nextPut: $?.
					params
						keysAndValuesDo: [:t2 :t3 | 
							t1 nextPutAll: t2 encodeForHTTP.
							t3
								ifNotNil: [t1 nextPut: $=;
										 nextPutAll: t3 encodeForHTTP].
							t1 nextPut: $&].
					t1 skip: -1].
			t1 nextPutAll: self fragmentString]! !

!WAUrl methodsFor: 'copying' stamp: ''!
withParameter: t1 
	^ self copy addParameter: t1;
		 yourself! !

!WAUrl methodsFor: 'copying' stamp: ''!
withParameter: t1 value: t2 
	^ self copy addParameter: t1 value: t2;
		 yourself! !

!WAUrl methodsFor: 'copying' stamp: ''!
with: t1 
	^ self copy addToPath: t1;
		 yourself! !

!Date class methodsFor: '*seaside2-squeak' stamp: ''!
newDay: t1 monthNumber: t2 year: t3 
	^ self
		newDay: t1
		month: t2
		year: t3! !

!Exception class methodsFor: '*seaside2-squeak' stamp: ''!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: ''!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: ''!
reactivateHandler
	handlerContext
		ifNotNil: [handlerContext tempAt: 3 put: true]! !

!Color methodsFor: '*seaside2' stamp: ''!
asHTMLColor
	^ '#' , self hex! !

!Color methodsFor: '*seaside2' stamp: ''!
hex
	^ (rgb hex allButFirst: 3) asLowercase! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
pickANumberGreaterThan: t1 
	^ amb
		valueOf: [t1 + 1]
		or: [self pickANumberGreaterThan: t1 + 1]! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
setUp
	amb := Amb new! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testAllValuesAboveFive
	| t1 t2 |
	t2 := amb
				allValues: [t1 := amb
								oneOf: (1 to: 10).
					amb assert: t1 > 5.
					t1].
	self assert: t2 = #(6 7 8 9 10 )! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testMaybe
	| t1 t2 t3 |
	t1 := amb maybe.
	t2 := amb maybe.
	t3 := amb maybe not.
	amb deny: t1 = t2.
	amb deny: t1 = t3.
	self assert: t1.
	self deny: t2.
	self deny: t3! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testPickANumber
	self assert: self pickANumber = 1! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testPickANumberAboveFive
	| t1 |
	t1 := self pickANumber.
	amb assert: t1 > 5.
	self assert: t1 = 6! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testSicpLogicProblem
	^ self! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testSicpLogicProblemFaster
	| t1 t2 t3 t4 t5 |
	t3 := amb
				oneOf: (1 to: 5).
	amb deny: t3 = 5.
	amb deny: t3 = 1.
	t5 := amb
				oneOf: (1 to: 5).
	amb deny: (t5 - t3) abs = 1.
	t2 := amb
				oneOf: (1 to: 5).
	amb deny: t2 = 1.
	amb deny: (t3 - t2) abs = 1.
	t4 := amb
				oneOf: (1 to: 5).
	amb assert: t4 > t2.
	t1 := amb
				oneOf: (1 to: 5).
	amb deny: t1 = 5.
	amb assert: (Set new add: t1;
			 add: t2;
			 add: t3;
			 add: t4;
			 add: t5;
			 size) = 5.
	self assert: t1 = 3.
	self assert: t2 = 2.
	self assert: t3 = 4.
	self assert: t4 = 5.
	self assert: t5 = 1! !

!AmbTest methodsFor: 'as yet unclassified' stamp: ''!
testSolveAnEquation
	| t1 t2 |
	t1 := amb
				oneOf: (1 to: 10).
	t2 := amb
				oneOf: (1 to: 10).
	amb assert: t2 * t1 = 42.
	self assert: t1 = 6.
	self assert: t2 = 7! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
callcc: t1 
	^ Continuation currentDo: t1! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testBlockEscape
	| t1 |
	tmp := 0.
	t1 := [tmp := tmp + 1.
			tmp2 value].
	self
		callcc: [:t2 | 
			tmp2 := t2.
			t1 value].
	tmp2 := [].
	t1 value.
	self assert: tmp = 2! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testBlockTemps
	| t1 t3 |
	#(1 2 3 )
		do: [:t2 | 
			t3 := t2.
			tmp
				ifNil: [tmp2 := self
								callcc: [:t4 | 
									tmp := t4.
									[:t5 | t5]]].
			tmp2 value: t3.
			t3 := 17].
	t1 := self
				callcc: [:t4 | 
					tmp value: t4.
					42].
	self assert: t1 = 1! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testBlockVars
	| t1 |
	tmp := 0.
	tmp := (self
				callcc: [:t2 | 
					t1 := t2.
					0])
				+ tmp.
	tmp2
		ifNil: [#(1 2 3 )
				do: [:t3 | self
						callcc: [:t2 | 
							tmp2 := t2.
							t1 value: t3]]]
		ifNotNil: [tmp2 value].
	self assert: tmp = 6! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testComprehension
	^ self! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testMethodTemps
	| t1 t2 |
	t1 := 0.
	t1 := t1
				+ (self
						callcc: [:t3 | 
							t2 := t3.
							1]).
	self assert: t1 ~= 3.
	t1 = 2
		ifFalse: [t2 value: 2]! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testSimpleCallCC
	| t1 t2 |
	t1 := self
				callcc: [:t3 | 
					t2 := t3.
					false].
	t1
		ifFalse: [t2 value: true].
	self assert: t1! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: ''!
testSimplestCallCC
	| t1 |
	t1 := self
				callcc: [:t2 | t2 value: true].
	self assert: t1! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationTest methodsFor: 'as yet unclassified' stamp: ''!
testLinearization
	| t1 t2 t3 t4 t5 t6 t7 t8 t9 |
	t1 := WAUserConfiguration new.
	t2 := WAUserConfiguration new addAncestor: t1.
	t3 := WAUserConfiguration new addAncestor: t2.
	t4 := WAUserConfiguration new addAncestor: t2.
	t5 := WAUserConfiguration new addAncestor: t3.
	t6 := WAUserConfiguration new addAncestor: t5;
				 addAncestor: t4.
	t7 := WAUserConfiguration new addAncestor: t3.
	t8 := WAUserConfiguration new addAncestor: t7.
	t9 := WAUserConfiguration new addAncestor: t6;
				 addAncestor: t8.
	self assert: t6 allAncestors
			= (Array
					with: t5
					with: t3
					with: t4
					with: t2
					with: t1).
	self assert: t8 allAncestors
			= (Array
					with: t7
					with: t3
					with: t2
					with: t1).
	self assert: t9 allAncestors = ((Array
				with: t6
				with: t5
				with: t8
				with: t7)
				, (Array
						with: t3
						with: t4
						with: t2
						with: t1))! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
assertSnapshot: t1 isIdenticalTo: t2 
	^ self! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
setUp
	registry := WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
snapshot: t1 isIdenticalTo: t2 
	^ (IdentitySet withAll: t1 values)
		includesAllOf: t2 values! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
testConsecutiveSnapshots
	| t1 t2 t3 t4 |
	t1 := ValueHolder new contents: 1.
	registry registerObject: t1.
	t2 := registry snapshot.
	t3 := registry snapshot.
	self
		assert: (self snapshot: t2 isIdenticalTo: t3).
	t1 contents: 2.
	t4 := registry snapshot.
	self
		deny: (self snapshot: t4 isIdenticalTo: t3)! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
testGarbageCollection
	| t1 t2 |
	t1 := ValueHolder new contents: 1.
	registry registerObject: t1.
	t2 := registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	t1 := nil.
	Smalltalk garbageCollect.
	self assert: registry size = 0! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
testNoChangeAfterRestore
	| t1 t2 t3 t4 |
	t1 := ValueHolder new contents: 1.
	registry registerObject: t1.
	t2 := registry snapshot.
	t1 contents: 2.
	t3 := registry snapshot.
	self
		deny: (self snapshot: t2 isIdenticalTo: t3).
	registry restoreSnapshot: t2.
	self assert: t1 contents = 1.
	t4 := registry snapshot.
	self
		assert: (self snapshot: t2 isIdenticalTo: t4)! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
testRevert
	| t1 t2 |
	t1 := ValueHolder new contents: 1.
	registry registerObject: t1.
	t2 := registry snapshot.
	t1 contents: 2.
	self assert: t1 contents = 2.
	registry restoreSnapshot: t2.
	self assert: t1 contents = 1! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: ''!
testRevertTwice
	| t1 t2 |
	t1 := ValueHolder new contents: 1.
	registry registerObject: t1.
	t2 := registry snapshot.
	t1 contents: 2.
	self assert: t1 contents = 2.
	registry restoreSnapshot: t2.
	self assert: t1 contents = 1.
	t1 contents: 3.
	registry restoreSnapshot: t2.
	self assert: t1 contents = 1! !

!Stream methodsFor: '*seaside2-squeak' stamp: ''!
closed
	^ false! !

!UndefinedObject methodsFor: '*seaside2' stamp: ''!
renderOn: t1 
	^ self! !

!Morph methodsFor: '*seaside2-squeak' stamp: ''!
asMIMEDocument
	^ self imageForm asMIMEDocument! !

!Dictionary methodsFor: '*seaside2' stamp: ''!
inspectorFields
	^ self! !

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: ''!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: ''!
use: t1 during: t2 
	^ t2
		on: self
		do: [:t3 | t3 resume: t1]! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: ''!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'as yet unclassified' stamp: ''!
defaultAction
	self resume: self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: 'redirect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderNotification methodsFor: 'as yet unclassified' stamp: ''!
shouldRedirect
	^ redirect
		ifNil: [true]! !

!WARenderNotification methodsFor: 'as yet unclassified' stamp: ''!
shouldRedirect: t1 
	redirect := t1! !

!BlockContext methodsFor: '*seaside2' stamp: ''!
handleRequest: t1 
	^ self value: t1! !

!BlockContext methodsFor: '*seaside2' stamp: ''!
renderOn: t1 
	self numArgs = 0
		ifTrue: [self value]
		ifFalse: [self value: t1]! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!Seaside2Info class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	[self new register]
		on: MessageNotUnderstood
		do: []! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: ''!
packageName
	^ 'Seaside2'! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: ''!
systemCategoryPrefix
	^ 'Seaside'! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: ''!
fileOutVW3
	VW3PackageExporter
		fileOutPackage: self default
		on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: ''!
fileOutVW5
	VW5PackageExporter
		fileOutPackage: self default
		on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: ''!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: ''!
ignoredCategories
	^ #('Platform' 'Base-Connections' 'Rendering-Buttons' 'Components-Tools-Squeak' )! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: ''!
includesSystemCategory: t1 
	^ (t1 beginsWith: 'Seaside-')
		and: [(self ignoredCategories
				includes: (t1 copyAfter: $-)) not]! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: ''!
isYourClassExtension: t1 
	^ (self category: t1 asLowercase matches: '*seaside2')
		and: [(t1 endsWith: 'squeak') not]! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: ''!
packageName
	^ 'SeasideVW'! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: ''!
asMIMEDocument
	^ MIMELocalFileDocument contentType: 'text/plain' contentStream: self! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: ''!
upToAndSkipThroughAll: t1 
	^ self upToAll: t1! !

!Parser methodsFor: '*seaside2-squeak-override' stamp: ''!
interactive
	^ (requestor == nil
		or: [requestor isKindOf: SyntaxError]
		or: [requestor isKindOf: WAMethodEditor]) not! !

!Form methodsFor: '*seaside2-squeak' stamp: ''!
asMIMEDocument
	| t1 |
	t1 := RWBinaryOrTextStream on: ''.
	GIFReadWriter
		putForm: (self asFormOfDepth: 8)
		onStream: t1.
	^ MIMEDocument contentType: 'image/gif' content: t1 contents! !

!True methodsFor: '*seaside2' stamp: ''!
yesNoString
	^ 'yes'! !

!False methodsFor: '*seaside2' stamp: ''!
yesNoString
	^ 'no'! !

!String methodsFor: '*seaside2' stamp: ''!
asCapitalizedPhrase
	| t1 t2 t3 t4 t6 |
	(self
			noneSatisfy: [:t5 | t5 isLowercase])
		ifTrue: [^ self].
	t2 := WriteStream on: String new.
	t1 := ReadStream on: self.
	[t1 atEnd]
		whileFalse: [t3 := WriteStream on: String new.
			t3 nextPut: t1 next.
			[t6 := t1 peek.
			t6 isNil
				or: [t6 isUppercase]]
				whileFalse: [t3 nextPut: t1 next].
			t4 := t3 contents capitalized.
			(#(#Of #In #At #A #Or #To #By ) includes: t4)
				ifTrue: [t4 := t4 asLowercase].
			t2 nextPutAll: t4.
			t2 nextPutAll: ' '].
	t2 skip: -1.
	^ t2 contents! !

!String methodsFor: '*seaside2' stamp: ''!
asMIMEDocument
	^ SeasidePlatformSupport mimeDocumentClass contentType: 'text/plain' content: self! !

!String methodsFor: '*seaside2' stamp: ''!
prettyPrintHtmlOn: t1 indentLevel: t2 
	t1 nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: ''!
printHtmlOn: t1 
	t1 nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: ''!
renderOn: t1 indentLevel: t2 
	t1 text: self! !

!Collection methodsFor: '*seaside2' stamp: ''!
inspectorFields
	| t1 |
	t1 := 0.
	^ self asArray
		collect: [:t2 | 
			t1 := t1 + 1.
			t1 -> t2]! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: ''!
evaluateWithArguments: t1 
	^ self valueWithArguments: t1! !

!MessageSend methodsFor: '*seaside2' stamp: ''!
fixTemps
	^ self! !

!MessageSend methodsFor: '*seaside2' stamp: ''!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: ''!
valueWithPossibleArgs: t1 
	self numArgs = 0
		ifTrue: [^ self value].
	self numArgs = t1 size
		ifTrue: [^ self valueWithArguments: t1].
	self numArgs > t1 size
		ifTrue: [^ self valueWithArguments: t1
					, (Array new: self numArgs - t1 size)].
	^ self
		valueWithArguments: (t1 copyFrom: 1 to: self numArgs)! !

!MessageSend methodsFor: '*seaside2' stamp: ''!
value: t1 
	^ self
		evaluateWithArguments: (Array with: t1)! !

!Integer methodsFor: '*seaside2' stamp: ''!
printStringAsCents
	^ '$' , (self // 100) asString , '.' , (self \\ 100) asTwoCharacterString! !

!Array methodsFor: '*seaside2' stamp: ''!
renderOn: t1 
	self
		do: [:t2 | t2 renderOn: t1]! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: ''!
homeReceiver
	^ self home receiver! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: ''!
localAt: t1 
	^ self at: t1! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: ''!
localAt: t1 put: t2 
	^ self at: t1 put: t2! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: ''!
localSize
	^ self size! !
WAExternalID initialize!
WAAbstractHtmlBuilder initialize!
WAConfigurationPool initialize!
WAKom initialize!
WACounter initialize!
WADispatcherEditor initialize!
WAExampleBrowser initialize!
WAAllTests initialize!
WAHalo initialize!
WAMultiCounter initialize!
WAStore initialize!
WAExpirySession initialize!
Seaside2Info initialize!
